 	subroutine setup_cuts(iout,iflag)
	implicit none
	integer iout,iflag

	real*8 etmin1,ymax1
	common/par_cuts_1/etmin1,ymax1
	real*8 etmin2,ymax2
	common/par_cuts_2/etmin2,ymax2
	real*8 etminP,ymaxP
	common/par_cuts_J/etminP,ymaxP
	real*8 Mllmin
	common/par_cuts_M/Mllmin
	data etmin1,ymax1/20.d0,2.5d0/
	data etmin2,ymax2/20.d0,2.5d0/
	data etminP,ymaxP/0.1d0,100d0/
        data Mllmin/50d0/

	if(iflag.eq.0)then
	   write(iout,*) ' Use of default cuts'
	   print*,' Use of default cuts'
	else
	  print*,' Cuts for first lepton:'
	  print*,' values of Etmin, and ymax?'
	  read*,etmin1,ymax1
	  print*,' '
	  print*,' Cuts for the second lepton:'
	  print*,' values of Etmin, ymax?'
	  read*,etmin2,ymax2
	  print*,' '
	  print*,' Cuts for the photon:'
	  print*,' values of Etmin, ymax?'
	  read*,etminP,ymaxP
	  print*,' '
	  print*,' Cut for the invariant mass'
	  print*,' value of M_ll_min?'
	  read*,Mllmin
	end if

	write(iout,*)' Cuts for lepton1:'
	write(iout,1)' Etmin ',Etmin1,' ymax',Ymax1
	write(iout,*)' Cuts for lepton2:'
	write(iout,1)' Etmin ',Etmin2,' ymax',Ymax2
	write(iout,*)' Cut for M_ll:'
	write(iout,1)' Mllmin',Mllmin
	write(iout,*)' Cuts for the hard photon:'
	write(iout,*)' none applied at the moment'
CC	write(iout,1)' Etmin',EtminP,' ymax',YmaxP
 1	format(4(A10,f10.2,' '))

	print*,' Setup of the cuts done'
        print*,' '
 	
	return
	end

        subroutine newcuts(npart,icut)
        implicit none
        integer npart,icut
        integer i,j

        real*8 etmin1,ymax1
        common/par_cuts_1/etmin1,ymax1
        real*8 etmin2,ymax2
        common/par_cuts_2/etmin2,ymax2
        real*8 etminP,ymaxP
        common/par_cuts_J/etminP,ymaxP
	real*8 mtcut
	common/transversemasscut/mtcut
	real*8 Mllmin,Mll
	common/par_cuts_M/Mllmin

        integer test(10)
        common/par_test/test

        real*8 xmtr
        real*8 pi,dphi1,dphi2
        parameter(pi=3.1415926535987932d0)

        real*8 ptc,etalc,ptnuc
        common /PPPP/ p
        common /MTRS/ xmtr,ptc,etalc,ptnuc
        real*8 phi(3),pt(3),et(3),y(3),dR(3,3),p(4,3)

        integer flag,flagr
        common/recomb/flag, flagr

        real*8 p1(4),sp1(4),p2(4),sp2(4),p3(4),sp3(4)
	real*8 sp(4,3:3)
        character*1 lep

	real*8 scalet
	common/ scalet/ scalet

c
c choice of collider:
c
	integer ppswitch
	common/collider/ppswitch
c
c a priori the event is fine
c
        icut=0
c
c smearing of the electron/muon, photon and neutrino momentum:
c
c sp(i,3) is the smeared photon momentum (local quantity)
c
c momentum assignment:
c p1: electron or muon
c p2: neutrino
c p3: photon
c npart: number of final-state particles
c
	do i=1,4
	   p1(i) = p(i,1)
	   p2(i) = p(i,2)
	   if (npart.eq.3) p3(i) = p(i,3)
	end do
CAC
c       print *,'CAC in cuts_dw: momenta_in:',p1,p2,p3,npart
c       print *,'masses before smearing'
c       print *,'1',p1(4)**2-p1(3)**2-p1(2)**2-p1(1)**2
c       print *,'2',p2(4)**2-p2(3)**2-p2(2)**2-p2(1)**2
c       print *,'3',p3(4)**2-p3(3)**2-p3(2)**2-p3(1)**2
CAC
c
c electron or muon case:
c
	if (test(2).eq.1) then
	   lep = 'e'
	elseif (test(2).eq.2) then
	   lep = 'm'
	endif
c
c test(10)=0: no smearing/recombination
c test(10)=1: with smearing
c test(10)=2: with smearing and recombination
c
	if (test(10).gt.0) then
	   scalet=dsqrt(p1(1)**2+p1(2)**2)
	   if(ppswitch.eq.1) then
	      call d0upgrsmear(p1,sp1,lep)
	      call d0upgrsmear(p2,sp2,lep)
cc	      call metsmear(p2,sp2)
	      if(npart.eq.3) call d0upgrsmear(p3,sp3,'e')
	   else
	      call atlsmear(p1,sp1,lep)
	      call atlsmear(p2,sp2,lep)
	      if (npart.eq.3) call atlsmear(p3,sp3,'e')
	   endif
           do i=1,4
              p(i,1) = sp1(i)
              p(i,2) = sp2(i)
	      if (npart.eq.3) sp(i,3) = sp3(i)
           end do
        end if
CAC
c       print *,'CAC in cuts_dw: momenta_sm:',sp1,sp2,sp3
c       print *,'masses after  smearing'
c       print *,'1',sp1(4)**2-sp1(3)**2-sp1(2)**2-sp1(1)**2
c       print *,'2',sp2(4)**2-sp2(3)**2-sp2(2)**2-sp2(1)**2
c       print *,'3',sp3(4)**2-sp3(3)**2-sp3(2)**2-sp3(1)**2
CAC

c        do i=1,npart
        do i=1,2
          call par_momentum(p(1,i),y(i),pt(i),et(i),phi(i),icut)
        end do
	if (npart.eq.3) then 
	   if (test(10).ge.1) then
	      call par_momentum(sp(1,3),y(3),pt(3),et(3),phi(3),icut)
	   elseif (test(10).eq.0) then
	      call par_momentum(p(1,3),y(3),pt(3),et(3),phi(3),icut)
	   endif
	endif

	if(test(10).lt.2) goto 15

c with recombination:
        flag = 0
        flagr = 0

        if (npart.eq.3) then

           flag = 1
           dphi1 = dabs(phi(1)-phi(3))
           if (dphi1.gt.pi) dphi1 = 2d0*pi-dphi1
           dR(1,3) = dsqrt(dphi1**2+(y(1)-y(3))**2)
           dphi2 = dabs(phi(2)-phi(3))
           if (dphi2.gt.pi) dphi2 = 2d0*pi-dphi2
           dR(2,3) = dsqrt(dphi2**2+(y(2)-y(3))**2)
c
c isolation and recombination cut:
c
c -- electrons
	   if (test(2).eq.1) then
c --Tevatron and LHC
	      if (dR(1,3).lt.0.1d0) then
		 do i=1,4
		    p(i,1) = p(i,1)+sp(i,3)
		    sp(i,3) = 0d0
		    p(i,3) = 0d0
		 end do
		 flagr = 1
		 goto 10
	      end if
	      if (dR(2,3).lt.0.1d0) then
		 do i=1,4
		    p(i,2) = p(i,2)+sp(i,3)
		    sp(i,3) = 0d0
		    p(i,3) = 0d0
		 end do
		 flagr = 1
		 goto 10
	      end if

	      if ((dR(1,3).ge.0.1d0).and.(dR(1,3).le.0.4d0)) then
		 if (sp(4,3).gt.0.1d0*p(4,1)) then
		    icut = 1
		    return
		 end if
	      endif
	      if ((dR(2,3).ge.0.1d0).and.(dR(2,3).le.0.4d0)) then
		 if (sp(4,3).gt.0.1d0*p(4,2)) then
		    icut = 1
		    return
		 end if
	      endif
c
c -- muons
	   elseif (test(2).eq.2) then
c
c --Tevatron and LHC
c
	      if ((dR(1,3).lt.0.1d0).and.(sp(4,3).gt.2d0)) then
		 icut=1
		 return
	      endif
	      if ((dR(2,3).lt.0.1d0).and.(sp(4,3).gt.2d0)) then
		 icut=1
		 return
	      endif
	      if ((dR(1,3).ge.0.1d0).and.(dR(1,3).le.0.4d0)) then
		 if (sp(4,3).gt.0.1d0*p(4,1)) then
		    icut = 1
		    return
		 end if
	      endif
	      if ((dR(2,3).ge.0.1d0).and.(dR(2,3).le.0.4d0)) then
		 if (sp(4,3).gt.0.1d0*p(4,2)) then
		    icut = 1
		    return
		 end if
	      endif
	      
	   end if
 10        continue

           if (flagr.eq.1) then
              npart = 2
              dR(1,3) = 0d0
              y(3) = -100d0
              pt(3) = -100d0
              et(3) = -100d0
              phi(3) = 0d0
           end if

c           do i=1,npart
           do i=1,2
              call par_momentum(p(1,i),y(i),pt(i),et(i),phi(i),icut)
           end do

        end if

 15	continue
c
c transverse mass
c
        xmtr=dsqrt(2d0*pt(1)*pt(2)*(1.d0-dcos(phi(2)-phi(1))))
CAC
c       ptc   = pt(1)
c       ptnuc = pt(2)
c       etalc = y(1)
CAC
c
c invarinat mass of the lepton pair
c
        Mll=dsqrt(p1(4)*p2(4)**2-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3))

c
        if(et(1).lt.etmin1.or.et(2).lt.etmin2)then
          icut=1
          return
        end if
        if(dabs(y(1)).gt.ymax1.or.dabs(y(2)).gt.ymax2)then
c        if(dabs(y(1)).gt.ymax1.or.dabs(y(2)).gt.ymax2.or
c     *     .xmtr.lt.mtcut) then 
          icut=1
          return
        end if
        if(Mll.le.Mllmin)then
          icut=1
          return
        end if

 20     continue
        end

	subroutine par_momentum(p,y,pt,et,phi,icut)
c	
c       input: p(4)
c	output: y pseudo-rapidity
c	        pt transverse momentum
c		et transverse energy 
c		phi azimutal angle
c		icut control flag
c
	implicit none
	real*8 p(4),y,pt,et,phi
	integer icut
	real*8 pm,theta
	real*8 temp,pi
	parameter(pi=3.1415926535987932d0)


	pm=dsqrt(p(1)**2+p(2)**2+p(3)**2)
	if(p(1).eq.0.d0.and.p(2).eq.0.d0.or.dabs(1d0-p(3)/pm).lt.1d-8)
     &  then
c       
c       y is infinite
c       
	   pt=0.d0
	   et=0.d0
	   phi=0.d0
	   icut=1
	   return
	end if
c   	y=0.5*log( (p(4)+p(3)) / (p(4)-p(3)) )
c	pm=sqrt(p(1)**2+p(2)**2+p(3)**2)
	theta=dacos(p(3)/pm)
	temp=dtan(theta/2.d0)
	if(temp.le.0.d0)then
	   print*, 'Precision problem in par_momentum'
	   print*,temp,p
	   icut=1
	   return
	end if
	y=-dlog(temp)
	pt=dsqrt(p(1)**2+p(2)**2)
	et=p(4)*dabs(dsin(theta))
	phi=atan2(p(2),p(1))
c
c	convert phi to an angle between 0 and 2*pi
c
        if(phi.lt.0.d0)phi=phi+2*pi
	
 10	continue
	return
	end

