      PROGRAM PROCESSING
C     ------------------
C.... READ GENERATED EVENTS FROM A FILE
C.... APPLY CUTS AND SMEARING
C.... WRITE PROCESSED EVENTS
      IMPLICIT NONE!
      character*1 lep,smre
      character*3 brn
      real*8 dummy,ranini
      real*8 p(4,3),ppmu(4),ppnu(4),ppph(4)
      integer npart,icut,jjj,NEVE,IEVE,iport,NOK
      integer ILPT,isme,ibrn,wgt
      integer test(10)
      integer ppswitch
      common /PPPP/ p
      common/par_test/test
      common/collider/ppswitch

C... Born of Corrected distribution
      print *,'Please choose between the Born and corrected:'
      print *,'put 1 for Born or 0 for 1-loop corrected'
      READ *,ibrn
      print *,'ibrn=',ibrn
      if(ibrn.lt.0.or.ibrn.gt.1) then
        print *,'improper ibrn value'
        stop
      endif
      if(ibrn.eq.1) brn = 'brn'
      if(ibrn.eq.0) brn = 'tot'

C... number of events to be processed:
      print *,'PLEASE GIVE THE NUMBER OF EVENTS TO BE PROCESSED'
      READ *,NEVE
      PRINT *,'NEVE=',NEVE
      if(NEVE.le.0.or.NEVE.gt.2000000000) then
        print *,'such a number of events can NOT be processed'
        stop
      endif

C... lepton type:
      print *,'PLEASE DEFINE THE LEPTON TYPE:'
      print *,'1 - for muon, and 2 - for electron' 
      READ *,ILPT
      PRINT *,'ilpt=',ILPT
      IF(ILPT.LT.1.OR.ILPT.GT.2) THEN
       PRINT *,'IMPROPER CHOICE OF THE LEPTON TYPE'
       STOP
      ENDIF
      IF(ILPT.EQ.1) test(2) = 2
      IF(ILPT.EQ.1) lep = 'm'
      IF(ILPT.EQ.2) test(2) = 1
      IF(ILPT.EQ.2) lep = 'e'

C... smearing & recombination ON/OFF
      print *,'PLEASE SWITCH SMEARING & RECOMBINATION ON/OFF:'
      print *,'0 - NO smearing, NO recombination'
      print *,'1 - WITH smearing, NO recombination'
      print *,'2 - WITH smearing, WITH recombination'
      READ *,isme
      PRINT *,'isme=',isme
      PRINT *,' '
      IF(isme.LT.0.OR.isme.GT.2) THEN
       PRINT *,'IMPROPER CHOICE OF SMEARING/RECOMBINATION SWITCH'
       STOP
      ENDIF
      IF(isme.EQ.2.AND.ilpt.EQ.1) THEN
       PRINT *,'WARNING !!! RECOMBINATION is applied for MUONS'
      ENDIF
      test(10) = isme
      if(isme.eq.0) smre = '0'
      if(isme.eq.1) smre = '1'
      if(isme.eq.2) smre = '2'

C... choice of collider:
      ppswitch = 2  ! 1/2: Tevatron/LHC

C... initialization of cuts
      call setup_cuts(6,0)
      icut = 0

C... initialization 
      dummy = ranini(1234)
      NOK = 0

C... open the data file created by MC generator
      if(ibrn.eq.1) then
        open(unit=11,name='events_brn.dat',status='old')
      else
        open(unit=11,name='events_tot.dat',status='old')
      endif

C... open the data file to write processed events
      open(unit=12,name='events_'//brn//'_'//lep//'_'//smre//'.dat'
     & ,status='unknown')

      do IEVE=1,NEVE

      read(11,*) wgt,ppmu,ppnu,ppph

C... transformation of the notation for momenta
      p(4,1) = ppmu(1) 
      p(4,2) = ppnu(1) 
      p(4,3) = ppph(1) 
      do jjj = 1,3
        p(jjj,1) = ppmu(jjj+1) 
        p(jjj,2) = ppnu(jjj+1) 
        p(jjj,3) = ppph(jjj+1) 
      enddo
CAC
c      print *,'masses before'
c      print *,'1',ppmu(1)**2-ppmu(2)**2-ppmu(3)**2-ppmu(4)**2
c      print *,'2',ppnu(1)**2-ppnu(2)**2-ppnu(3)**2-ppnu(4)**2
c      print *,'3',ppph(1)**2-ppph(2)**2-ppph(3)**2-ppph(4)**2
CAC

C... calling DW's subroutine 
      npart = 3
      if(abs(p(1,3))+abs(p(2,3))+abs(p(3,3))+abs(p(4,3)).le.1d-6) 
     & npart = 2
      call newcuts(npart,icut)

C... backward transformation of the notation for momenta
      ppmu(1) = p(4,1) 
      ppnu(1) = p(4,2) 
      ppph(1) = p(4,3) 
      do jjj = 1,3
        ppmu(jjj+1) = p(jjj,1) 
        ppnu(jjj+1) = p(jjj,2) 
        ppph(jjj+1) = p(jjj,3) 
      enddo

      if(npart.eq.2) then
        do jjj = 1,4
        ppph(jjj) = 0d0
        enddo
      endif
CAC
c      print *,'masses after'
c      print *,'1',ppmu(1)**2-ppmu(2)**2-ppmu(3)**2-ppmu(4)**2
c      print *,'2',ppnu(1)**2-ppnu(2)**2-ppnu(3)**2-ppnu(4)**2
c      print *,'3',ppph(1)**2-ppph(2)**2-ppph(3)**2-ppph(4)**2
CAC
      if(icut.ne.1) WRITE(12,100) wgt,ppmu,ppnu,ppph 
      if(icut.ne.1) NOK = NOK + 1

      ENDDO ! IEVE
      close(unit=11)
      close(unit=12)
      print *,'NOK=',NOK,'   events written'

 100  FORMAT(1I4,12F12.5)
      STOP
      END
