#define INVBREM 0  // 1/0 inverse bremsstrahlung on/off
//--------------------------------------------------------------------------------------------------
// new exploration of cells: 0 - off, 1 - on: 
#define IEXPLSOBR 1
#define IEXPLBRDQ 1
#define IEXPLVIRT 1
#define IEXPLHARD 1
#define IEXPLIBBR 0
#define IEXPLIBS1 0
#define IEXPLIBS2 0
#define IEXPLBORN 1
//--------------------------------------------------------------------------------------------------
    long NevTot         =             100000;   // MC statistics for Total
    long NevBrn         =             100000;   // MC statistics for Born
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Soft + Born
    int  nDimSobr       =                   0;   // SIMPLICAL   subspace
    int  kDimSobr       =                   3;   // HYP-CUBICAL subspace
    int  TotDimSobr     = kDimSobr + nDimSobr;   // total dimension
    int  nCellsSobr     =               10000;   // Number of Cells
    int  nSamplSobr     =                5000;   // Number of MC events per cell in build-up
    int  nBinSobr       =                  50;   // Number of bins in build-up
    int  EvPerBinSobr   =                  50;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejSobr =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Virt
    int  nDimVirt       =                   0;   // SIMPLICAL   subspace
    int  kDimVirt       =                   3;   // HYP-CUBICAL subspace
    int  TotDimVirt     = kDimVirt + nDimVirt;   // total dimension
    int  nCellsVirt     =                1000;   // Number of Cells
    int  nSamplVirt     =                5000;   // Number of MC events per cell in build-up
    int  nBinVirt       =                  50;   // Number of bins in build-up
    int  EvPerBinVirt   =                  50;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejVirt =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Brdq
    int  nDimBrdq       =                   0;   // SIMPLICAL   subspace
    int  kDimBrdq       =                   4;   // HYP-CUBICAL subspace
    int  TotDimBrdq     = kDimBrdq + nDimBrdq;   // total dimension
    int  nCellsBrdq     =               10000;   // Number of Cells
    int  nSamplBrdq     =                5000;   // Number of MC events per cell in build-up
    int  nBinBrdq       =                  50;   // Number of bins in build-up
    int  EvPerBinBrdq   =                  50;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejBrdq =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Hard
    int  nDimHard       =                   0;   // SIMPLICAL   subspace
    int  kDimHard       =                   6;   // HYP-CUBICAL subspace
    int  TotDimHard     = kDimHard + nDimHard;   // total dimension
    int  nCellsHard     =               10000;   // Number of Cells
    int  nSamplHard     =              100000;   // Number of MC events per cell in build-up
    int  nBinHard       =                 100;   // Number of bins in build-up
    int  EvPerBinHard   =                 500;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejHard =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Ibbr
    int  nDimIbbr       =                   0;   // SIMPLICAL   subspace
    int  kDimIbbr       =                   6;   // HYP-CUBICAL subspace
    int  TotDimIbbr     = kDimIbbr + nDimIbbr;   // total dimension
    int  nCellsIbbr     =                1000;   // Number of Cells
    int  nSamplIbbr     =               20000;   // Number of MC events per cell in build-up
    int  nBinIbbr       =                 100;   // Number of bins in build-up
    int  EvPerBinIbbr   =                 100;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejIbbr =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Ibs1
    int  nDimIbs1       =                   0;   // SIMPLICAL   subspace
    int  kDimIbs1       =                   4;   // HYP-CUBICAL subspace
    int  TotDimIbs1     = kDimIbs1 + nDimIbs1;   // total dimension
    int  nCellsIbs1     =                1000;   // Number of Cells
    int  nSamplIbs1     =               20000;   // Number of MC events per cell in build-up
    int  nBinIbs1       =                 100;   // Number of bins in build-up
    int  EvPerBinIbs1   =                 100;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejIbs1 =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Ibs2
    int  nDimIbs2       =                   0;   // SIMPLICAL   subspace
    int  kDimIbs2       =                   4;   // HYP-CUBICAL subspace
    int  TotDimIbs2     = kDimIbs2 + nDimIbs2;   // total dimension
    int  nCellsIbs2     =                1000;   // Number of Cells
    int  nSamplIbs2     =               20000;   // Number of MC events per cell in build-up
    int  nBinIbs2       =                 100;   // Number of bins in build-up
    int  EvPerBinIbs2   =                 100;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejIbs2 =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  FOAM parameters for Born
    int  nDimBorn       =                   0;   // SIMPLICAL   subspace
    int  kDimBorn       =                   3;   // HYP-CUBICAL subspace
    int  TotDimBorn     = kDimBorn + nDimBorn;   // total dimension
    int  nCellsBorn     =               10000;   // Number of Cells
    int  nSamplBorn     =                5000;   // Number of MC events per cell in build-up
    int  nBinBorn       =                  50;   // Number of bins in build-up
    int  EvPerBinBorn   =                  50;   // Maximum events (equiv.) per bin in buid-up
    double MaxWtRejBorn =                 2.0;   // Maximum wt for rejection, for OptRej=1
//--------------------------------------------------------------------------------------------------
//  General FOAM parameters
    int  OptRej         =                   1;   // =0, weighted events;  =1, wt=1 events
    int  OptDrive       =                   2;   // (D=2) Option, type of Drive =0,1,2 for TrueVol,Sigma,WtMax
    int  OptEdge        =                   0;   // (D=0) Option, vertices are included in the sampling (0) or not (1)
    int  OptOrd         =                   0;   // (D=0) Option, single simplex or nDim! simlices
    int  OptPeek        =                   0;   // (D=0) Option, choice of cell in buid-up maximum(0), random(1)
    int  OptMCell       =                   1;   // (D=1) Option, Mega-Cell = slim memory
    int  Chat           =                   1;   // Chat level
//--------------------------------------------------------------------------------------------------
//  Parameters for branching
    double SigmaSobr = 0.0;
    double SigmaVirt = 0.0;
    double SigmaBrdq = 0.0;
    double SigmaHard = 0.0;
    double SigmaIbbr = 0.0;
    double SigmaIbs1 = 0.0;
    double SigmaIbs2 = 0.0;
    double SigmaBorn = 0.0;
//--------------------------------------------------------------------------------------------------
