c-----------------------------------------------------------------------
      real*8 function function3dborn(x)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"
#include "limits_soft_declare.h"
      integer*4 ilpt
      integer*4 isetup
      integer*4 wgt
      real*8    mfact
      real*8    z1,z2,z3
      real*8    x(3)
      real*8    sqs0,scale,ome,mcut
      real*8    ptcut_t,etacut_t,ptcut_l,etacut_l
      real*8    xmin,xmax,q2mn,q2mx
      real*8    clab,aaa
      real*8    c,x1,x2,sqs,cti,sigti
      real*8    upva,dnva,useaa,dseaa,stra,chma,bota,top,gl
      real*8    upvb,dnvb,useab,dseab,strb,chmb,botb
      real*8    ququs,qdqds           
      real*8    subua,subca,subda,subsa,subdb,subsb,subdv,subub,subcb
      real*8    subba,subbb
      real*8    ppll(4),pmil(4)
      real*8    wx,ajaw
      real*8    ptmib,ptplb
      real*8    etamib,etaplb
      real*8    bornu,bornd,softu,softd
      common /ebeam/ sqs0
      common /weight/ wgt
c-----------------------------------------------------------------------
#include "initialization.h"
      if (isetup.eq.0) then
#include "tev4lhcw_input.h"
      else if (isetup.eq.1) then
#include "leshw_input.h"
      endif
#include "limits_soft.h"
c-----------------------------------------------------------------------
c... parameters for pdf's:
      xmin  = 1d-5
      xmax  = 1d0-1d-5
      q2mn  = 1d-10
      q2mx  = 1d5
c-----------------------------------------------------------------------
      call ffini()
      call s2n_init()
      if (ilpt.eq.1) mf = mel
      if (ilpt.eq.2) mf = mmo
      mup   = mup*mfact
      mdn   = mdn*mfact
      function3dborn  = 0d0
      wgt             = 1
      z1 = xl(1)+x(1)*(xu(1)-xl(1))
      z2 = xl(2)+x(2)*(xu(2)-xl(2))
      z3 = xl(3)+x(3)*(xu(3)-xl(3))
      iborn = 1
      wx = z2
      x2 = z3
      if (x2.le.wx) return
      x1 = wx/x2
      if (x1.le.xmin.or.x1.ge.xmax) return
      ajaw = 1d0/x2
      c    = z1
      clab = c
c... boosted variables in the cms:
      s    = sqs0**2*x1*x2
      sqs  = dsqrt(s)
      if (s.le.mcut**2) return
      aaa  = x1+x2-c*(x1-x2)
      cti  = 1d0-(1d0-c)*2d0*x1/aaa
      cosf = cti
c... the following cut should not affect the result:
      if (dabs(cti).ge.1d0-1d-12) return
c--- structure functions -----------------------------------------------
c... for the first proton:
      call structq(x1,scale,upva,dnva,useaa,dseaa,stra,chma,bota,top,gl)
      upva  = (upva+useaa)/x1   !     up-quark             in 1st proton
      dnva  = (dnva+dseaa)/x1   !     down-quark           in 1st proton
      useaa = useaa/x1          !     anti-up-quark        in 1st proton
      dseaa = dseaa/x1          !     anti-down-quark      in 1st proton
      stra  = stra/x1           !     (anti-)strange-quark in 1st proton
      chma  = chma/x1           !     (anti-)charm-quark   in 1st proton
      bota  = bota/x1           !     (anti-)bottom-quark  in 1st proton
c... for the second proton:
      call structq(x2,scale,upvb,dnvb,useab,dseab,strb,chmb,botb,top,gl)
      upvb  = (upvb+useab)/x2   !     up-quark             in 2nd proton
      dnvb  = (dnvb+dseab)/x2   !     down-quark           in 2nd proton
      useab = useab/x2          !     anti-up-quark        in 2nd proton
      dseab = dseab/x2          !     anti-down-quark      in 2nd proton
      strb  = strb/x2           !     (anti-)strange-quark in 2nd proton
      chmb  = chmb/x2           !     (anti-)charm-quark   in 2nd proton
      botb  = botb/x2           !     (anti-)bottom-quark  in 2nd proton
c-----------------------------------------------------------------------
c--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e -------------------------
c-----------------------------------------------------------------------
c... 4-momenta of particles in the laboratory reference frame
c... lepton      4-momentum components:
      pmil(1) = 0d0
      pmil(2) = -sqs/2d0*dsqrt(1d0-cti**2)
      pmil(3) = sqs0/2d0*(x1-x2)-sqs0/2d0*2d0*x1*x2/aaa*clab
      pmil(4) = sqs0/2d0*(x1+x2)-sqs0/2d0*2d0*x1*x2/aaa
c... anti-lepton 4-momentum components:
      ppll(1) = 0d0
      ppll(2) = sqs/2d0*dsqrt(1d0-cti**2)
      ppll(3) = sqs0/2d0*2d0*x1*x2/aaa*clab
      ppll(4) = sqs0/2d0*2d0*x1*x2/aaa
c-----------------------------------------------------------------------
c... lepton      pt:
      ptmib  = dsqrt(pmil(1)**2+pmil(2)**2)
c... anti-lepton pt:
      ptplb  = dsqrt(ppll(1)**2+ppll(2)**2)
c... lepton      rapidity:
      etamib = dlog((pmil(4)+pmil(3))/(pmil(4)-pmil(3)))/2d0
c... anti-lepton rapidity:
      etaplb = dlog((ppll(4)+ppll(3))/(ppll(4)-ppll(3)))/2d0
c-----------------------------------------------------------------------
c... cuts:
      if (isetup.eq.0) then
          if (ptmib.le.ptcut_t) return
          if (ptplb.le.ptcut_t) return
          if (dabs(etamib).ge.etacut_t) return
          if (dabs(etaplb).ge.etacut_t) return
      else if (isetup.eq.1) then
          if (ptmib.le.ptcut_l) return
          if (ptplb.le.ptcut_l) return
          if (dabs(etamib).ge.etacut_l) return
          if (dabs(etaplb).ge.etacut_l) return
      endif
c-----------------------------------------------------------------------
      subua = upva
      subda = dnva
      subca = chma
      subsa = stra
      subba = bota
      subub = useab
      subdb = dseab
      subsb = strb
      subcb = chmb
      subbb = botb
c-----------------------------------------------------------------------
c.... combination of u quark from p_1 and \bar{d} from p_2
      ququs = (subua*subub+subca*subcb)*2d0
      qdqds = (subda*subdb+subsa*subsb+subba*subbb)*2d0
      sinf  = dsqrt(1d0-cosf**2)
      if (s.lt.4d0*mf**2) return
      betaf = dsqrt(1d0-4d0*mf**2/s)
      t     = mf**2-s/2*(1d0-betaf*cosf)
      u     = mf**2-s/2*(1d0+betaf*cosf)
      if (ququs+qdqds.le.1d-12) return
      if (ilpt.eq.1) then
        call nc_br_1313_1212(-s,-t,-u,bornu,softu,hard)
        call nc_br_1414_1212(-s,-t,-u,bornd,softd,hard)
      elseif (ilpt.eq.2) then
        call nc_br_1313_1616(-s,-t,-u,bornu,softu,hard)
        call nc_br_1414_1616(-s,-t,-u,bornd,softd,hard)
      endif
      sigti = bornu*ququs+bornd*qdqds
      call UniBosConsts_Bos()
      function3dborn = sigti*4d0*x1*x2/aaa**2*ajaw*factor
      if (function3dborn.lt.0d0) wgt = -1
      function3dborn = dabs(function3dborn)
c-----------------------------------------------------------------------
      return
      end
