c-----------------------------------------------------------------------
      real*8 function function3dbrdq(x)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"
#include "limits_brdq_declare.h"
      integer*4 ilpt
      integer*4 isetup
      integer*4 wgt
      real*8    mfact
      real*8    z1,z2,z3,z4
      real*8    x(4)
      real*8    sqs0,mcut,scale,wxcut,ome
      real*8    ptcut_l,etacut_l,ptcut_t,etacut_t
      real*8    xmin,xmax,q2mn,q2mx
      real*8    xx,xxxx,jac4
      real*8    clab,aaa
      real*8    cmi,cpl,lncmi,lncpl,dlome
      real*8    c,x1,x2,sqs,cti,sigti
      real*8    upva,dnva,useaa,dseaa,stra,chma,bota,top,gl
      real*8    upvb,dnvb,useab,dseab,strb,chmb,botb
      real*8    ququ,ququs,qdqd,qdqds           
      real*8    subua,subca,subda,subsa,subdb,subsb,subdv,subub,subcb
      real*8    resua,resca,resda,ressa,resdb,ressb,resdv,resub,rescb
      real*8    d1dua,d1dca,d1dda,d1dsa,d1ddb,d1dsb,d1ddv,d1dub,d1dcb
      real*8    subba,subbb,resba,resbb,d1dba,d1dbb
      real*8    ppll(4),pmil(4),spll(4),smil(4)
      real*8    ald1,ald2,ard1,ard2
      real*8    amin,amax,stp,cc,re2,re3
      real*8    funua,funub,funda,fundb,funst,funch,funbt
      real*8    wx,ajaw
      real*8    ptmib,ptmic,ptplb,ptplc
      real*8    etamib,etamic,etaplb,etaplc
      real*8    sigmau,bornu,softu,sigmad,bornd,softd
      real*8    minv
      real*8    upvc,dnvc,useac,dseac,strc,chmc,botc 
      common /parmm/  mcut,scale,wxcut,ome
      common /w50513/ xmin,xmax,q2mn,q2mx
      common /varxx/  xx
      common /vcms /  clab,aaa
      common /prepa1/ cmi,cpl,lncmi,lncpl,dlome
      common /distr/  upvc,dnvc,useac,dseac,strc,chmc,botc
      common /ebeam/ sqs0
      common /weight/ wgt
      external funua,funub,funda,fundb,funst,funch,funbt
#include "initialization.h"
      if (isetup.eq.0) then
#include "tev4lhcw_input.h"
      else if (isetup.eq.1) then
#include "leshw_input.h"
      endif
#include "limits_brdq.h"
c... parameters for pdf's:
      xmin  = 1d-5
      xmax  = 1d0-1d-5
      q2mn  = 1d-10
      q2mx  = 1d5
      if (ilpt.eq.1) mf = mel
      if (ilpt.eq.2) mf = mmo
      call ffini()
      call s2n_init()
      tlmu2 = 10d0
      thmu  = mw
      thmu2 = thmu**2
      mup   = mup*mfact
      mdn   = mdn*mfact
      function3dbrdq  = 0d0
      wgt = 1
      z1 = xl(1)+x(1)*(xu(1)-xl(1))
      z2 = xl(2)+x(2)*(xu(2)-xl(2))
      z3 = xl(3)+x(3)*(xu(3)-xl(3))
      z4 = xl(4)+x(4)*(xu(4)-xl(4))
      iborn        = 1
      wx           = z2
      x2           = z3
      if (x2.le.wx) return
      x1           = wx/x2
      if (x1.le.xmin.or.x1.ge.xmax) return
      ajaw         = 1d0/x2
      c            = z1
      clab         = c
c... boosted variables in the cms:
      s            = sqs0**2*x1*x2
      sqs          = dsqrt(s)
      if (s.le.mcut**2) return
      aaa          = x1+x2-c*(x1-x2)
      cti          = 1d0-(1d0-c)*2d0*x1/aaa
      cosf         = cti
      if (dabs(cti).ge.1d0-1d-12) return
c-----------------------------------------------------------------------
c--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e -------------------------
c-----------------------------------------------------------------------
c... 4-momenta of particles in the laboratory reference frame
c... lepton      4-momentum components:
      pmil(1) = 0d0
      pmil(2) = -sqs/2d0*dsqrt(1d0-cti**2)
      pmil(3) = sqs0/2d0*(x1-x2)-sqs0/2d0*2d0*x1*x2/aaa*clab
      pmil(4) = sqs0/2d0*(x1+x2)-sqs0/2d0*2d0*x1*x2/aaa
c... anti-lepton 4-momentum components:
      ppll(1) = 0d0
      ppll(2) = sqs/2d0*dsqrt(1d0-cti**2)
      ppll(3) = sqs0/2d0*2d0*x1*x2/aaa*clab
      ppll(4) = sqs0/2d0*2d0*x1*x2/aaa
c-----------------------------------------------------------------------
c... lepton      pt:
      ptmib  = dsqrt(pmil(1)**2+pmil(2)**2)
c... anti-lepton pt:
      ptplb  = dsqrt(ppll(1)**2+ppll(2)**2)
c... lepton      rapidity:
      etamib = dlog((pmil(4)+pmil(3))/(pmil(4)-pmil(3)))/2d0
c... anti-lepton rapidity:
      etaplb = dlog((ppll(4)+ppll(3))/(ppll(4)-ppll(3)))/2d0
c-----------------------------------------------------------------------
c... cuts:                                                                                                                                                   
      if (isetup.eq.0) then                                                                                                                                  
        if (ptmib.le.ptcut_t) return                                                                                                                       
        if (ptplb.le.ptcut_t) return                                                                                                                       
        if (dabs(etamib).ge.etacut_t) return                                                                                                               
        if (dabs(etaplb).ge.etacut_t) return                                                                                                               
      else if (isetup.eq.1) then                                                                                                                             
        if (ptmib.le.ptcut_l) return                                                                                                                       
        if (ptplb.le.ptcut_l) return                                                                                                                       
        if (dabs(etamib).ge.etacut_l) return                                                                                                               
        if (dabs(etaplb).ge.etacut_l) return                                                                                                               
      endif
c-----------------------------------------------------------------------
c... some preparations:
      cpl   = 1d0+cosf
      cmi   = 1d0-cosf
      lncmi = dlog(cmi/2d0)
      lncpl = dlog(cpl/2d0)
c-----------------------------------------------------------------------
c--- structure functions -----------------------------------------------
c... for the first proton:
      call structq(x1,scale,upva,dnva,useaa,dseaa,stra,chma,bota,top,gl)
      upvc  = upva
      dnvc  = dnva
      useac = useaa
      dseac = dseaa
      strc  = stra
      chmc  = chma
      botc  = bota
      upva  = (upva+useaa)/x1   !     up-quark             in 1st proton
      dnva  = (dnva+dseaa)/x1   !     down-quark           in 1st proton
      useaa = useaa/x1          !     anti-up-quark        in 1st proton
      dseaa = dseaa/x1          !     anti-down-quark      in 1st proton
      stra  = stra/x1           !     (anti-)strange-quark in 1st proton
      chma  = chma/x1           !     (anti-)charm-quark   in 1st proton
      bota  = bota/x1           !     (anti-)bottom-quark  in 1st proton
      resua = 0d0
      resda = 0d0
      ressa = 0d0
      resca = 0d0
      resba = 0d0
      xx    = x1
      amin  = x1 +1d-10
      amax  = 1d0-1d-10
      jac4  = amax-amin
      if (jac4.gt.0d0) then
        xxxx  = amin+jac4*z4
        resua = jac4*funua(xxxx)
        resda = jac4*funda(xxxx)
        ressa = jac4*funst(xxxx)
        resca = jac4*funch(xxxx)
        resba = jac4*funbt(xxxx)
      endif
c-----------------------------------------------------------------------
c... for the second proton:
      call structq(x2,scale,upvb,dnvb,useab,dseab,strb,chmb,botb,top,gl)
      upvc  = upvb
      dnvc  = dnvb
      useac = useab
      dseac = dseab
      strc  = strb
      chmc  = chmb
      botc  = botb
      upvb  = (upvb+useab)/x2   !     up-quark             in 2nd proton
      dnvb  = (dnvb+dseab)/x2   !     down-quark           in 2nd proton
      useab = useab/x2          !     anti-up-quark        in 2nd proton
      dseab = dseab/x2          !     anti-down-quark      in 2nd proton
      strb  = strb/x2           !     (anti-)strange-quark in 2nd proton
      chmb  = chmb/x2           !     (anti-)charm-quark   in 2nd proton
      botb  = botb/x2           !     (anti-)bottom-quark  in 2nd proton
      resub = 0d0
      resdb = 0d0
      ressb = 0d0
      rescb = 0d0
      resbb = 0d0
      xx    = x2
      amin  = x2 +1d-10
      amax  = 1d0-1d-10
c-----------------------------------------------------------------------
      jac4  = amax-amin
      if (jac4.gt.0d0) then
        xxxx  = amin+jac4*z4
        resub = jac4*funub(xxxx)
        resdb = jac4*fundb(xxxx)
        ressb = jac4*funst(xxxx)
        rescb = jac4*funch(xxxx)
        resbb = jac4*funbt(xxxx)
      endif
        ald1  = 1d0/2*x1**2+x1+2d0*dlog(1d0-x1)
        ald2  = 1d0/2*x2**2+x2+2d0*dlog(1d0-x2)
        ard1=2d0*x1+(1d0-2d0*x1-x1**2)*dlog(1d0-x1)-2d0*dlog(1d0-x1)**2
        ard2=2d0*x2+(1d0-2d0*x2-x2**2)*dlog(1d0-x2)-2d0*dlog(1d0-x2)**2
        ard1 = ard1+2d0*ddilog(1d0-x1)-pi**2/3d0+dlog(1d0-x1)**2
     &        +(-3d0+x1+1d0/2*x1**2)*dlog(1d0-x1)
     &        -(     x1+1d0/2*x1**2)*dlog(x1)-1d0/2*x1
        ard2 = ard2+2d0*ddilog(1d0-x2)-pi**2/3d0+dlog(1d0-x2)**2
     &        +(-3d0+x2+1d0/2*x2**2)*dlog(1d0-x2)
     &        -(     x2+1d0/2*x2**2)*dlog(x2)-1d0/2*x2
        d1dua = upva *(ald1*dlog(scale**2/mup**2)+ard1)
        d1dda = dnva *(ald1*dlog(scale**2/mdn**2)+ard1)
        d1dsa = stra *(ald1*dlog(scale**2/mdn**2)+ard1)
        d1dca = chma *(ald1*dlog(scale**2/mup**2)+ard1)
        d1dba = bota *(ald1*dlog(scale**2/mdn**2)+ard1)

        d1dub = useab*(ald2*dlog(scale**2/mup**2)+ard2)
        d1ddb = dseab*(ald2*dlog(scale**2/mdn**2)+ard2)
        d1dsb = strb *(ald2*dlog(scale**2/mdn**2)+ard2)
        d1dcb = chmb *(ald2*dlog(scale**2/mup**2)+ard2)
        d1dbb = botb *(ald2*dlog(scale**2/mdn**2)+ard2)

        subua = upva -alpha/2d0/pi*(2d0/3d0)**2*(d1dua+resua)
        subda = dnva -alpha/2d0/pi*(1d0/3d0)**2*(d1dda+resda)
        subsa = stra -alpha/2d0/pi*(1d0/3d0)**2*(d1dsa+ressa)
        subca = chma -alpha/2d0/pi*(2d0/3d0)**2*(d1dca+resca)
        subba = bota -alpha/2d0/pi*(1d0/3d0)**2*(d1dba+resba)
        subub = useab-alpha/2d0/pi*(2d0/3d0)**2*(d1dub+resub)
        subdb = dseab-alpha/2d0/pi*(1d0/3d0)**2*(d1ddb+resdb)
        subsb = strb -alpha/2d0/pi*(1d0/3d0)**2*(d1dsb+ressb)
        subcb = chmb -alpha/2d0/pi*(2d0/3d0)**2*(d1dcb+rescb)
        subbb = botb -alpha/2d0/pi*(1d0/3d0)**2*(d1dbb+resbb)
c.... combination of u quark from p_1 and \bar{d} from p_2
      ququ = (upva*useab+chma*chmb)*2d0
      qdqd = (dnva*dseab+stra*strb+bota*botb)*2d0
      ququs = (subua*useab+upva*subub-upva*useab
     $  +subca*chmb+chma*subcb-chma*chmb)*2d0
      qdqds = (subda*dseab+dnva*subdb-dnva*dseab+subsa*strb
     $  +stra*subsb-stra*strb+subba*botb+bota*subbb-bota*botb)*2d0
      sinf = dsqrt(1d0-cosf**2)
      if (s.lt.4d0*mf**2) return
      betaf = dsqrt(1d0-4d0*mf**2/s)
      t     = mf**2-s/2*(1d0-betaf*cosf)
      u     = mf**2-s/2*(1d0+betaf*cosf)
c... shifted born and one-loop x-sections
      bornu  = 0d0
      bornd  = 0d0
      softu  = 0d0
      softd  = 0d0
      sigmau = 0d0
      sigmad = 0d0
      if (dabs(ququs+qdqds).le.1d-12) return
        if (ilpt.eq.2)
     $  call nc_br_1313_1616(-s,-t,-u,bornu,softu,hard)
        if (ilpt.eq.1)
     $  call nc_br_1313_1212(-s,-t,-u,bornu,softu,hard)
        if (ilpt.eq.2)
     $  call nc_br_1414_1616(-s,-t,-u,bornd,softd,hard)
        if(ilpt.eq.1)
     $  call nc_br_1414_1212(-s,-t,-u,bornd,softd,hard)
      sigti = bornu*ququs+bornd*qdqds
      sigti = sigti-bornu*ququ-bornd*qdqd
      if(dabs(sigti).lt.1d-12) return
      function3dbrdq = sigti*4d0*x1*x2/aaa**2*ajaw*factor
      if (function3dbrdq.lt.0d0) wgt = -1
      function3dbrdq = dabs(function3dbrdq)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funua(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc 
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc 
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funua = (upv+usea-upvc-useac)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mup**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funub(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funub = (usea-useac)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mup**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funch(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funch = (chm-chmc)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mup**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funda(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funda = (dnv+dsea-dnvc-dseac)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mdn**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function fundb(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      fundb = (dsea-dseac)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mdn**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funst(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funst = (str-strc)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mdn**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
c-----------------------------------------------------------------------
      real*8 function funbt(x)
      implicit none!
#include "s2n_declare.h"
      integer*4 ilpt
      real*8 sqs0,mcut,scale,wxcut,ome,xx
      real*8 x,upv,dnv,usea,dsea,str,chm,bot,top,gl
      real*8 upvc,dnvc,useac,dseac,strc,chmc,botc
      common /parmm/ mcut,scale,wxcut,ome
      common /varxx/ xx
      common /distr/ upvc,dnvc,useac,dseac,strc,chmc,botc
      call structq(xx/x,scale,upv,dnv,usea,dsea,str,chm,bot,top,gl)
      funbt = (bot-botc)/(xx/x)/x*(
     $(1d0+x**2)/(1d0-x)*(dlog(scale**2/mdn**2)-2d0*dlog(1d0-x)-1d0)
     $+(1d0+x**2)/(1d0-x)*dlog((1d0-x)/x)-3d0/2d0/(1d0-x)
     $+2d0*x+3d0)
      return
      end
