c-----------------------------------------------------------------------
      real*8 function function6dhard(x)
      implicit none!
#include "s2n_declare.h"
#include "limits_hard_declare.h"
      integer*4 ilpt
      integer*4 isetup
      integer*4 wgt
      real*8 ome
      real*8 mfact
      real*8 z1,z2,z3,z4,z5,z6
      real*8 x(6)
      real*8 sqs0,s0
      real*8 ptcut_t,etacut_t,ptcut_l,etacut_l,mcut
      real*8 scale
      real*8 y,ph4,cth4,cth5,wy,x2
      real*8 x1,ajaw,dtdy,sqs,sqspr,cph4,sph4,sth4,sth5
      real*8 upva,dnva,useaa,dseaa,stra,chma,bota,top,gl
      real*8 upvb,dnvb,useab,dseab,strb,chmb,botb
      real*8 ququ_up,ququ_dn
      real*8 pmi1(4),ppl1(4),pph1(4),pqu1(4),paq1(4)
      real*8 pmi2(4),ppl2(4),pph2(4),pqu2(4),paq2(4)
      real*8 pmil(4),ppll(4),pphl(4),pqul(4),paql(4)
      real*8 beta,gamma,beta1,gamma1,betal
      real*8 ptmib,ptplb,ptphb
      real*8 etamib,etaplb,etaphb
      real*8 cph35b,cph45b,phi35b,phi45b
      real*8 rl35b,rl45b
      real*8 minv
      real*8 hard_up,hard_dn
      common /ebeam/ sqs0
      common /weight/ wgt
#include "initialization.h"
      if (isetup.eq.0) then
#include "tev4lhcw_input.h"
      else if (isetup.eq.1) then
#include "leshw_input.h"
      endif
      call s2n_init()
      mup = mup*mfact
      mdn = mdn*mfact
      if (ilpt.eq.1) mmo = mel
      if (ilpt.eq.2) mmo = mmo
      s0 = sqs0**2
#include "limits_hard.h"
c-----------------------------------------------------------------------
      function6dhard = 0d0
      wgt            = 1
      z1 = xl(1)+x(1)*(xu(1)-xl(1))
      z2 = xl(2)+x(2)*(xu(2)-xl(2))
      z3 = xl(3)+x(3)*(xu(3)-xl(3))
      z4 = xl(4)+x(4)*(xu(4)-xl(4))
      z5 = xl(5)+x(5)*(xu(5)-xl(5))
      z6 = xl(6)+x(6)*(xu(6)-xl(6))
      y           = z1
      ph4         = z2
      cth4        = z3
      cth5        = z4
      wy          = z5
      x2          = z6
      if (x2.le.wy) return
      x1          = wy/x2
      if (x1.le.1d-5.or.x1.ge.1d0-1d-5) return
      ajaw        = 1d0/x2
      dtdy        = s0*wy
      s           = s0*x1*x2
      spr         = y*wy*s0
      sqs         = dsqrt(s)
      sqspr       = dsqrt(spr)
      cph4        = dcos(ph4)
      sph4        = dsin(ph4)
      sth4        = dsqrt(1d0-cth4**2)
      sth5        = dsqrt(1d0-cth5**2)
      if (spr.le.4d0*mmo**2) return
      if (spr.ge.s*(1d0-ome)) return
      beta        = (x2-x1)/(x1+x2)
      gamma       = 1d0/dsqrt(1d0-beta**2)
      beta1       = (s-spr)/(s+spr)
      gamma1      = 1d0/dsqrt(1d0-beta1**2)
      betal       = dsqrt(1d0-4d0*mmo**2/spr)
c--- structure functions -----------------------------------------------
c... for the first proton:
      call structq(x1,scale,upva,dnva,useaa,dseaa,stra,chma,bota,top,gl)
      upva  = (upva+useaa)/x1   !     up-quark             in 1st proton
      dnva  = (dnva+dseaa)/x1   !     down-quark           in 1st proton
      useaa = useaa/x1          !     anti-up-quark        in 1st proton
      dseaa = dseaa/x1          !     anti-down-quark      in 1st proton
      stra  = stra/x1           !     (anti-)strange-quark in 1st proton
      chma  = chma/x1           !     (anti-)charm-quark   in 1st proton
      bota  = bota/x1           !     (anti-)bottom-quark  in 1st proton
c... for the second proton:
      call structq(x2,scale,upvb,dnvb,useab,dseab,strb,chmb,botb,top,gl)
      upvb  = (upvb+useab)/x2   !     up-quark             in 2nd proton
      dnvb  = (dnvb+dseab)/x2   !     down-quark           in 2nd proton
      useab = useab/x2          !     anti-up-quark        in 2nd proton
      dseab = dseab/x2          !     anti-down-quark      in 2nd proton
      strb  = strb/x2           !     (anti-)strange-quark in 2nd proton
      chmb  = chmb/x2           !     (anti-)charm-quark   in 2nd proton
      botb  = botb/x2           !     (anti-)bottom-quark  in 2nd proton
c-----------------------------------------------------------------------
c--- p(1) = px, p(2) = py, p(3) = pz, p(4) = e -------------------------
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r1:
c... lepton      4-momentum components:
      pmi1(1) = -sqspr/2d0*betal*sth4*cph4
      pmi1(2) = -sqspr/2d0*betal*sth4*sph4
      pmi1(3) = (-sqspr/2d0*betal*cth4-beta1*sqspr/2d0)*gamma1
      pmi1(4) = (sqspr/2d0+beta1*sqspr/2d0*betal*cth4)*gamma1
c... anti-lepton 4-momentum components:
      ppl1(1) = sqspr/2d0*betal*sth4*cph4
      ppl1(2) = sqspr/2d0*betal*sth4*sph4
      ppl1(3) = (sqspr/2d0*betal*cth4-beta1*sqspr/2d0)*gamma1
      ppl1(4) = (sqspr/2d0-beta1*sqspr/2d0*betal*cth4)*gamma1
c... photon      4-momentum components:
      pph1(1) = 0d0
      pph1(2) = 0d0
      pph1(3) = (s-spr)/2d0/sqs
      pph1(4) = (s-spr)/2d0/sqs
c... quark       4-momentum components:
      pqu1(1) = 0d0
      pqu1(2) = -sqs/2d0*dsqrt(1d0-4d0*mup**2/s)*sth5
      pqu1(3) = sqs/2d0*dsqrt(1d0-4d0*mup**2/s)*cth5
      pqu1(4) = sqs/2d0
c... anti-quark  4-momentum components:
      paq1(1) = 0d0
      paq1(2) = sqs/2d0*dsqrt(1d0-4d0*mup**2/s)*sth5
      paq1(3) = -sqs/2d0*dsqrt(1d0-4d0*mup**2/s)*cth5
      paq1(4) = sqs/2d0
c-----------------------------------------------------------------------
c... 4-momenta of particles in the rest reference frame of partons r2:
c... lepton      4-momentum components:
      pmi2(1) = pmi1(1)
      pmi2(2) = pmi1(2)*cth5+pmi1(3)*sth5
      pmi2(3) = -pmi1(2)*sth5+pmi1(3)*cth5
      pmi2(4) = pmi1(4)
c... anti-lepton 4-momentum components:
      ppl2(1) = ppl1(1)
      ppl2(2) = ppl1(2)*cth5+ppl1(3)*sth5
      ppl2(3) = -ppl1(2)*sth5+ppl1(3)*cth5
      ppl2(4) = ppl1(4)
c... photon      4-momentum components:
      pph2(1) = pph1(1)
      pph2(2) = pph1(2)*cth5+pph1(3)*sth5
      pph2(3) = -pph1(2)*sth5+pph1(3)*cth5
      pph2(4) = pph1(4)
c... quark       4-momentum components:
      pqu2(1) = pqu1(1)
      pqu2(2) = pqu1(2)*cth5+pqu1(3)*sth5
      pqu2(3) = -pqu1(2)*sth5+pqu1(3)*cth5
      pqu2(4) = pqu1(4)
c... anti-quark  4-momentum components:
      paq2(1) = paq1(1)
      paq2(2) = paq1(2)*cth5+paq1(3)*sth5
      paq2(3) = -paq1(2)*sth5+paq1(3)*cth5
      paq2(4) = paq1(4)
c-----------------------------------------------------------------------
c... 4-momenta of particles in the laboratory reference frame
c... lepton      4-momentum components:
      pmil(1) = pmi2(1)
      pmil(2) = pmi2(2)
      pmil(3) = (pmi2(3)+beta*pmi2(4))*gamma
      pmil(4) = (beta*pmi2(3)+pmi2(4))*gamma
c... anti-lepton 4-momentum components:
      ppll(1) = ppl2(1)
      ppll(2) = ppl2(2)
      ppll(3) = (ppl2(3)+beta*ppl2(4))*gamma
      ppll(4) = (beta*ppl2(3)+ppl2(4))*gamma
c... photon      4-momentum components:
      pphl(1) = pph2(1)
      pphl(2) = pph2(2)
      pphl(3) = (pph2(3)+beta*pph2(4))*gamma
      pphl(4) = (beta*pph2(3)+pph2(4))*gamma
c... quark       4-momentum components:
      pqul(1) = pqu2(1)
      pqul(2) = pqu2(2)
      pqul(3) = (pqu2(3)+beta*pqu2(4))*gamma
      pqul(4) = (beta*pqu2(3)+pqu2(4))*gamma
c... anti-quark  4-momentum components:
      paql(1) = paq2(1)
      paql(2) = paq2(2)
      paql(3) = (paq2(3)+beta*paq2(4))*gamma
      paql(4) = (beta*paq2(3)+paq2(4))*gamma
c-----------------------------------------------------------------------
c... lepton      pt:
      ptmib   = dsqrt(pmil(1)**2+pmil(2)**2)
c... anti-lepton pt:
      ptplb   = dsqrt(ppll(1)**2+ppll(2)**2)
c... photon      pt:
      ptphb   = dsqrt(pphl(1)**2+pphl(2)**2)
c... lepton      rapidity:
      etamib  = dlog((pmil(4)+pmil(3))/(pmil(4)-pmil(3)))/2d0
c... anti-lepton rapidity:
      etaplb  = dlog((ppll(4)+ppll(3))/(ppll(4)-ppll(3)))/2d0
c... photon      rapidity:
      etaphb  = dlog((pphl(4)+pphl(3))/(pphl(4)-pphl(3)))/2d0
c-----------------------------------------------------------------------
      cph35b  = (pmil(1)*pphl(1)+pmil(2)*pphl(2))/ptmib/ptphb
      if (dabs(cph35b).gt.1d0) return
      cph45b  = (ppll(1)*pphl(1)+ppll(2)*pphl(2))/ptplb/ptphb
      if (dabs(cph45b).gt.1d0) return
      phi35b  = dacos(cph35b)
      phi45b  = dacos(cph45b)
      rl35b   = dsqrt(dabs((etamib-etaphb)**2+phi35b**2+1d-22))
      rl45b   = dsqrt(dabs((etaplb-etaphb)**2+phi45b**2+1d-22))
c-----------------------------------------------------------------------
c... cuts:
      if (sqspr.le.mcut) return
      if (isetup.eq.0) then
          if (ptmib.le.ptcut_t) return
          if (ptplb.le.ptcut_t) return
          if (dabs(etamib).ge.etacut_t) return
          if (dabs(etaplb).ge.etacut_t) return
      else if (isetup.eq.1) then
          if (ptmib.le.ptcut_l) return
          if (ptplb.le.ptcut_l) return
          if (dabs(etamib).ge.etacut_l) return
          if (dabs(etaplb).ge.etacut_l) return
      endif
c-----------------------------------------------------------------------
      ququ_up = (upva*useab+chma*chmb)*2d0
      ququ_dn = (dnva*dseab+stra*strb+bota*botb)*2d0
      if ((ququ_up+ququ_dn).le.1d-12) return
      if (ilpt.eq.1) then
        call nc_ha_1313_1212 (s,spr,ph4,cth4,cth5,hard_up)
        call nc_ha_1414_1212 (s,spr,ph4,cth4,cth5,hard_dn)
      elseif (ilpt.eq.2) then
        call nc_ha_1313_1616 (s,spr,ph4,cth4,cth5,hard_up)
        call nc_ha_1414_1616 (s,spr,ph4,cth4,cth5,hard_dn)
      endif
      function6dhard = hard_up*ququ_up+hard_dn*ququ_dn
      function6dhard = function6dhard*ajaw*dtdy*factor
      if (function6dhard.lt.0d0) wgt = -1
      function6dhard = dabs(function6dhard)
c-----------------------------------------------------------------------
      return
      end
