C-----------------------------------------------------------------------
      real*8 function function6dibbr(x)
      implicit none!
#include "s2n_declare.h"
#include "limits_ibbr_declare.h"
      integer*4 ilpt
      integer*4 isetup
      integer*4 wgt
      real*8    mfact
      real*8    z1,z2,z3,z4,z5,z6
      real*8    x(6)
      real*8    sqs0,scale,ome,mcut
      real*8    ptcut_t,etacut_t,ptcut_l,etacut_l
      real*8    cth2,ph4,cth4,x1,x2,wy,ajaw,dtdy,y
      real*8    born_uu,born_dd,born_ubub,born_dbdb
      real*8    UPVa,DNVa,USEAa,DSEAa,STRa,CHMa,BOTa,TOP,GL,PHOTa
      real*8    UPVb,DNVb,USEAb,DSEAb,STRb,CHMb,BOTb,PHOTb
      real*8    ququ_uu,ququ_dd,ququ_ubub,ququ_dbdb
      real*8    ptmi,ptpl,etami,etapl
      real*8    pmi1(4),ppl1(4),pmi2(4),ppl2(4),pmi(4),ppl(4)
      real*8    beta,gamma,beta1,gamma1
      real*8    sqspr
      real*8    sth2,sth4,cph4,sph4
      real*8    l1,l2
      real*8    s0
      common /ebeam/ sqs0                                                                                                                                    
      common /weight/ wgt
C-----------------------------------------------------------------------
#include "initialization.h"
      if (isetup.eq.0) then
#include "tev4lhcw_input.h"
      else if (isetup.eq.1) then
#include "leshw_input.h"
      endif
      call s2n_init()
      if (ilpt.eq.1) mmo = mel
      if (ilpt.eq.2) mmo = mmo
      mup   = mup*mfact
      mdn   = mdn*mfact
      function6dibbr = 0d0
      wgt            = 1
      s0             = sqs0**2
#include "limits_ibbr.h"
      z1 = xl(1)+x(1)*(xu(1)-xl(1))
      z2 = xl(2)+x(2)*(xu(2)-xl(2))
      z3 = xl(3)+x(3)*(xu(3)-xl(3))
      z4 = xl(4)+x(4)*(xu(4)-xl(4))
      z5 = xl(5)+x(5)*(xu(5)-xl(5))
      z6 = xl(6)+x(6)*(xu(6)-xl(6))
      y           = z1
      cth2        = z2
      ph4         = z3
      cth4        = z4
      wy          = z5
      x2          = z6
      if (x2.le.wy) return
      x1          = wy/x2
      if ((x1.le.1d-5).or.(x1.ge.1d0-1d-5)) return
      ajaw        = 1d0/x2
      spr         = y*wy*s0
      if (spr.le.4d0*mmo**2) return
      dtdy        = s0*wy
      s           = s0*x1*x2
C-----------------------------------------------------------------------
C... first proton:
      call STRUCTQA(X1,SCALE,UPVa,DNVa,USEAa,DSEAa,STRa,CHMa,BOTa,TOP,
     $GL,PHOTa)
      UPVa  = (UPVa+USEAa)/x1
      DNVa  = (DNVa+DSEAa)/x1
      STRa  = STRa/x1
      CHMa  = CHMa/x1
      BOTa  = BOTa/x1
      USEAa = USEAa/x1
      DSEAa = DSEAa/x1
      PHOTa = PHOTa/x1
C... second proton:
      call STRUCTQA(X2,SCALE,UPVb,DNVb,USEAb,DSEAb,STRb,CHMb,BOTb,TOP,
     $GL,PHOTb)
      UPVb  = (UPVb+USEAb)/x2
      DNVb  = (DNVb+DSEAb)/x2
      STRb  = STRb/x2
      CHMb  = CHMb/x2
      BOTb  = BOTb/x1
      USEAb = USEAb/x2
      DSEAb = DSEAb/x2
      PHOTb = PHOTb/x2
C-----------------------------------------------------------------------
      sqspr  = dsqrt(spr)
      sth2   = dsqrt(1d0-cth2**2)
      sth4   = dsqrt(1d0-cth4**2)
      cph4   = dcos(ph4)
      sph4   = dsin(ph4)
      l1     = dsqrt(dabs(s**2+spr**2+mup**4
     $-2d0*(s*mup**2+spr*mup**2+s*spr)))
      l2     = sqspr*dsqrt(dabs(spr-4d0*mmo**2))
      beta   = (x1-x2)/(x1+x2)
      gamma  = 1d0/dsqrt(1d0-beta**2)
      beta1  = l1/(s+spr-mup**2)
      gamma1 = 1d0/dsqrt(1d0-beta1**2)
C-----------------------------------------------------------------------
      pmi1(1) = -l2/2d0/sqspr*sth4*cph4
      pmi1(2) = -l2/2d0/sqspr*sth4*sph4
      pmi1(3) = (-l2/2d0/sqspr*cth4+beta1*sqspr/2d0)*gamma1
      pmi1(4) = (sqspr/2d0-beta1*l2/2d0/sqspr*cth4)*gamma1
      ppl1(1) = l2/2d0/sqspr*sth4*cph4
      ppl1(2) = l2/2d0/sqspr*sth4*sph4
      ppl1(3) = (l2/2d0/sqspr*cth4+beta1*sqspr/2d0)*gamma1
      ppl1(4) = (sqspr/2d0+beta1*l2/2d0/sqspr*cth4)*gamma1
      pmi2(1) = pmi1(1)*cth2-pmi1(3)*sth2
      pmi2(2) = pmi1(2)
      pmi2(3) = pmi1(1)*sth2+pmi1(3)*cth2
      pmi2(4) = pmi1(4)
      ppl2(1) = ppl1(1)*cth2-ppl1(3)*sth2
      ppl2(2) = ppl1(2)
      ppl2(3) = ppl1(1)*sth2+ppl1(3)*cth2
      ppl2(4) = ppl1(4)
      pmi(1)  = pmi2(1)
      pmi(2)  = pmi2(2)
      pmi(3)  = (pmi2(3)+beta*pmi2(4))*gamma
      pmi(4)  = (pmi2(4)+beta*pmi2(3))*gamma
      ppl(1)  = ppl2(1)
      ppl(2)  = ppl2(2)
      ppl(3)  = (ppl2(3)+beta*ppl2(4))*gamma
      ppl(4)  = (ppl2(4)+beta*ppl2(3))*gamma
C-----------------------------------------------------------------------
      ptmi  = dsqrt(pmi(1)**2+pmi(2)**2)
      ptpl  = dsqrt(ppl(1)**2+ppl(2)**2)
      etami = dlog((pmi(4)+pmi(3))/(pmi(4)-pmi(3)))/2d0
      etapl = dlog((ppl(4)+ppl(3))/(ppl(4)-ppl(3)))/2d0
C-----------------------------------------------------------------------
C... cuts:
      if (sqspr.le.mcut) return
      if (isetup.eq.0) then
          if (ptmi.le.ptcut_t) return
          if (ptpl.le.ptcut_t) return
          if (dabs(etami).ge.etacut_t) return
          if (dabs(etapl).ge.etacut_t) return
      else if (isetup.eq.1) then
          if (ptmi.le.ptcut_l) return
          if (ptpl.le.ptcut_l) return
          if (dabs(etami).ge.etacut_l) return
          if (dabs(etapl).ge.etacut_l) return
      endif
C-----------------------------------------------------------------------
      call au_ull_born(s,spr,cth2,ph4,cth4,born_uu)
      call ad_dll_born(s,spr,cth2,ph4,cth4,born_dd)
      call aub_ubll_born(s,spr,cth2,ph4,cth4,born_ubub)
      call adb_dbll_born(s,spr,cth2,ph4,cth4,born_dbdb)
C-----------------------------------------------------------------------
      ququ_uu   = PHOTa*(UPVb+CHMb)
      ququ_dd   = PHOTa*(DNVb+STRb+BOTb)
      ququ_ubub = PHOTa*(USEAb+CHMb)
      ququ_dbdb = PHOTa*(DSEAb+STRb+BOTb)
      function6dibbr = 2d0*ajaw*dtdy*factor
     $*(
     $+born_uu*ququ_uu
     $+born_dd*ququ_dd
     $+born_ubub*ququ_ubub
     $+born_dbdb*ququ_dbdb
     $)
      if (function6dibbr.lt.0d0) wgt = -1
      function6dibbr = dabs(function6dibbr)                                                                                                                  
c-----------------------------------------------------------------------
      return
      end
