c-----------------------------------------------------------------------
      real*8 function function4dibs1(x)
      implicit none!
#include "s2n_declare.h"
#include "limits_ibsu_declare.h"
      integer*4 ilpt
      integer*4 isetup
      integer*4 wgt
      real*8     mcut
      real*8     mfact
      real*8     s0,sqs0,scale,ome
      real*8     ptcut_t,etacut_t,ptcut_l,etacut_l
      real*8     z1,z2,z3,z4
      real*8     x(4)
      real*8     c,x3,wy,x2
      real*8     x1,ajaw,aaa,cti,cmi,kappaz,born_uu,born_dd
      real*8     UPVa,DNVa,USEAa,DSEAa,STRa,CHMa,BOTa,TOP,GL,PHOTa
      real*8     UPVb,DNVb,USEAb,DSEAb,STRb,CHMb,BOTb,PHOTb
      real*8     ququ_uu,ququ_dd,ququ_ubub,ququ_dbdb
      real*8     ptmi,ptpl,etami,etapl
      real*8     xmin,xmax
      real*8     pmi(4),ppl(4)
      real*8     subtr_uu,subtr_dd,subtr_ubub,subtr_dbdb
      real*8     minv
      real*8     alphai0      
      complex*16 chizs
      common /xlim/    xmin,xmax
      common /ebeam/ sqs0
      common /weight/ wgt
c-----------------------------------------------------------------------
#include "initialization.h"
      if (isetup.eq.0) then
#include "tev4lhcw_input.h"
      else if (isetup.eq.1) then
#include "leshw_input.h"
      endif
      call s2n_init()
      if (ilpt.eq.1) mmo = mel
      if (ilpt.eq.2) mmo = mmo
      mup   = mup*mfact
      mdn   = mdn*mfact
      function4dibs1 = 0d0
      wgt            = 1
      s0             = sqs0**2
#include "limits_ibsu.h"
      alphai0 = alphai
      z1 = xl(1)+x(1)*(xu(1)-xl(1))
      z2 = xl(2)+x(2)*(xu(2)-xl(2))
      z3 = xl(3)+x(3)*(xu(3)-xl(3))
      z4 = xl(4)+x(4)*(xu(4)-xl(4))
      c           = z1
      x3          = z2
      wy          = z3
      x2          = z4
      x1          = wy/x2/x3
      xmin  = 1d-5
      xmax  = 1d0-1d-6
      if ((x1.le.xmin).or.(x1.ge.xmax)) return
      ajaw        = 1d0/x2/x3
      s           = s0*wy
      if (s.le.4d0*mmo**2) return
C... boosted variables in the CMS:
      aaa         = x1*x3+x2-c*(x1*x3-x2)
      cti         = 1d0-(1d0-c)*2d0*x1*x3/aaa
C... the following cut should not affect the result:
      if (dabs(cti).ge.1d0-1d-12) return
c-----------------------------------------------------------------------
C... first proton:
      call STRUCTQA(x1,scale,UPVa,DNVa,USEAa,DSEAa,STRa,CHMa,BOTa,TOP,
     $GL,PHOTa)
      UPVa  = (UPVa+USEAa)/x1
      DNVa  = (DNVa+DSEAa)/x1
      STRa  = STRa/x1
      CHMa  = CHMa/x1
      BOTa  = BOTa/x1
      USEAa = USEAa/x1
      DSEAa = DSEAa/x1
      PHOTa = PHOTa/x1
C... second proton:
      call STRUCTQA(x2,scale,UPVb,DNVb,USEAb,DSEAb,STRb,CHMb,BOTb,TOP,
     $GL,PHOTb)
      UPVb  = (UPVb+USEAb)/x2
      DNVb  = (DNVb+DSEAb)/x2
      STRb  = STRb/x2
      CHMb  = CHMb/x2
      BOTb  = BOTb/x2
      USEAb = USEAb/x2
      DSEAb = DSEAb/x2
      PHOTb = PHOTb/x2
C-----------------------------------------------------------------------
C... particle 4-momenta in the lab reference frame:
C... anti-lepton:
      ppl(4) = sqs0/2d0*2d0*x1*x2*x3/aaa
      ppl(3) = ppl(4)*c
      ppl(2) = dsqrt(s)/2d0*dsqrt(1d0-cti**2)
      ppl(1) = 0d0
C... lepton:
      pmi(4) = sqs0/2d0*(x1*x3+x2)-ppl(4)
      pmi(3) = dsqrt(pmi(4)**2-ppl(2)**2)
      pmi(2) = -ppl(2)
      pmi(1) = 0d0
C-----------------------------------------------------------------------
      minv   = dsqrt(2d0*(pmi(4)*ppl(4)-pmi(3)*ppl(3)
     $-pmi(2)*ppl(2)-pmi(1)*ppl(1)))
      ptmi   = dsqrt(pmi(1)**2+pmi(2)**2)
      ptpl   = dsqrt(ppl(1)**2+ppl(2)**2)
      etami  = dlog((pmi(4)+pmi(3))/(pmi(4)-pmi(3)))/2d0
      etapl  = dlog((ppl(4)+ppl(3))/(ppl(4)-ppl(3)))/2d0
C-----------------------------------------------------------------------
c... cuts:
      if (minv.le.mcut) return
      if (isetup.eq.0) then
          if (ptmi.le.ptcut_t) return
          if (ptpl.le.ptcut_t) return
          if (dabs(etami).ge.etacut_t) return
          if (dabs(etapl).ge.etacut_t) return
      else if (isetup.eq.1) then
          if (ptmi.le.ptcut_l) return
          if (ptpl.le.ptcut_l) return
          if (dabs(etami).ge.etacut_l) return
          if (dabs(etapl).ge.etacut_l) return
      endif
C-----------------------------------------------------------------------
      mf     = mmo
      betaf  = sqrt(1d0-4d0*mf**2/s)
      t      = mf**2 - s/2d0*(1d0-betaf*cti)
      u      = mf**2 - s/2d0*(1d0+betaf*cti)
      iborn = 1
      born_uu = 0d0
      born_dd = 0d0
      if (ilpt.eq.1) then
        call nc_bo_1313_1212 (-s,-t,-u,born_uu,soft,hard)
        call nc_bo_1313_1212 (-s,-t,-u,born_dd,soft,hard)
      else
        call nc_bo_1313_1616 (-s,-t,-u,born_uu,soft,hard)
        call nc_bo_1313_1616 (-s,-t,-u,born_dd,soft,hard)
      endif
C-----------------------------------------------------------------------
      subtr_uu = 1d0/alphai0/2d0/pi*qup**2
     $*(dlog(scale**2*(1d0-x3)/mup**2/x3)*(x3**2+(1d0-x3)**2)
     $-2d0+16d0*x3-16d0*x3**2)
      subtr_dd = 1d0/alphai0/2d0/pi*qdn**2
     $*(dlog(scale**2*(1d0-x3)/mdn**2/x3)*(x3**2+(1d0-x3)**2)
     $-2d0+16d0*x3-16d0*x3**2)
C-----------------------------------------------------------------------
      ququ_uu   = PHOTa*(UPVb+CHMb)
      ququ_dd   = PHOTa*(DNVb+STRb+BOTb)
      ququ_ubub = PHOTa*(USEAb+CHMb)
      ququ_dbdb = PHOTa*(DSEAb+STRb+BOTb)
C-----------------------------------------------------------------------
      function4dibs1 = -factor*( 
     $ 2d0*born_uu*subtr_uu*(ququ_uu+ququ_ubub)
     $+2d0*born_dd*subtr_dd*(ququ_dd+ququ_dbdb)
     $)
     $*fc*ajaw*4d0*x1*x2*x3/aaa**2
      if (function4dibs1.lt.0d0) wgt = -1
      function4dibs1 = dabs(function4dibs1)
      return
      end
