C=======================================================================
C Born differential cross section for the process
C photon  +  anti-down-quark ---> anti-down-quark + lepton + anti-lepton
C=======================================================================
      subroutine adb_dbll_born(s,spr,costh2,ph4,costh4,born1)
      implicit none!
      include 's2n_declare.h'
      real*8 costh2,ph4,costh4,sinth2,cosph4,sinph4,sinth4
      real*8 sqs,sqspr
      real*8 p1p2,p1p3,p1p4,p2p3,p2p4,p3p4,p1p5,p2p5,p3p5,p4p5
      real*8 p1p22,p1p32,p1p42,p2p32,p2p42,p3p42
      real*8 den1,den2,den3,den4,den5,den6,den7,den8
      real*8 den12,den22,den32,den42,den52,den62,den72,den82
      real*8 s12,s15,s25,s35,s45
      real*8 mdn2,mdn4,mmo2,mmo4,mw2r,mw4,mz2r,mz4
      real*8 wz2
      real*8 stw8,g2,g4,g6,pi4
      real*8 factor
      real*8 l1,l2
      real*8 beta
      real*8 p1e,p1x,p1y,p1z
      real*8 p2e,p2x,p2y,p2z
      real*8 p3e,p3x,p3y,p3z
      real*8 p4e,p4x,p4y,p4z
      real*8 p5e,p5x,p5y,p5z
      real*8 p3e1,p3x1,p3y1,p3z1
      real*8 p4e1,p4x1,p4y1,p4z1
      real*8 born1
      born1   = 0d0
      pi4    = pi**4
      ctw    = mw/mz
      stw    = dsqrt(1d0-ctw**2)
      e      = 2d0*dsqrt(pi/alphai)
      g      = e/stw
      mdn2   = mdn**2
      mdn4   = mdn2**2
      mmo2   = mmo**2
      mmo4   = mmo2**2
      mw2r    = mw**2
      mw4    = mw2r**2
      mz2r    = mz**2
      mz4    = mz2r**2
      wz2    = wz**2
      stw2   = stw**2
      stw4   = stw2**2
      stw6   = stw2*stw4
      stw8   = stw4**2
      g2     = g**2
      g4     = 32d0*(gf**2)*mw4
      g6     = g**6
      sinth2 = dsqrt(1d0-costh2**2)
      cosph4 = dcos(ph4)
      sinph4 = dsin(ph4)
      sinth4 = dsqrt(1d0-costh4**2)
      sqs    = dsqrt(s)
      sqspr  = dsqrt(spr)
      if (spr.ge.(sqs-mdn)**2) return
      l1     = dsqrt(dabs(s**2+spr**2+mdn4-2d0*(s*mdn2+spr*mdn2+s*spr)))
      l2     = sqspr*dsqrt(dabs(spr-4d0*mmo2))
      beta   = l1/(s+spr-mdn2)
      p1e    = (s+mdn2)/2d0/sqs
      p1x    = -(s-mdn2)/2d0/sqs*sinth2
      p1y    = 0d0
      p1z    = -(s-mdn2)/2d0/sqs*costh2
      p2e    = (s-spr+mdn2)/2d0/sqs
      p2x    = 0d0
      p2y    = 0d0
      p2z    = -l1/2d0/sqs
      p3e1   = sqspr/2d0
      p3x1   = -l2/2d0/sqspr*sinth4*cosph4
      p3y1   = -l2/2d0/sqspr*sinth4*sinph4
      p3z1   = -l2/2d0/sqspr*costh4
      p4e1   = sqspr/2d0
      p4x1   = l2/2d0/sqspr*sinth4*cosph4
      p4y1   = l2/2d0/sqspr*sinth4*sinph4
      p4z1   = l2/2d0/sqspr*costh4
      p3e    = (p3e1+beta*p3z1)/dsqrt(1-beta**2)
      p3x    = p3x1
      p3y    = p3y1
      p3z    = (p3z1+beta*p3e1)/dsqrt(1-beta**2)
      p4e    = (p4e1+beta*p4z1)/dsqrt(1-beta**2)
      p4x    = p4x1
      p4y    = p4y1
      p4z    = (p4z1+beta*p4e1)/dsqrt(1-beta**2)
      p5e    = -p1e+p2e+p3e+p4e
      p5x    = -p1x+p2x+p3x+p4x
      p5y    = -p1y+p2y+p3y+p4y
      p5z    = -p1z+p2z+p3z+p4z
      p1p2   = p1e*p2e-p1x*p2x-p1y*p2y-p1z*p2z
      p1p3   = p1e*p3e-p1x*p3x-p1y*p3y-p1z*p3z
      p1p4   = p1e*p4e-p1x*p4x-p1y*p4y-p1z*p4z
      p2p3   = p2e*p3e-p2x*p3x-p2y*p3y-p2z*p3z
      p2p4   = p2e*p4e-p2x*p4x-p2y*p4y-p2z*p4z
      p3p4   = p3e*p4e-p3x*p4x-p3y*p4y-p3z*p4z
      p1p5   = p1e*p5e-p1x*p5x-p1y*p5y-p1z*p5z
      p2p5   = p2e*p5e-p2x*p5x-p2y*p5y-p2z*p5z
      p3p5   = p3e*p5e-p3x*p5x-p3y*p5y-p3z*p5z
      p4p5   = p4e*p5e-p4x*p5x-p4y*p5y-p4z*p5z
      p1p22  = p1p2**2
      p1p32  = p1p3**2
      p1p42  = p1p4**2
      p2p32  = p2p3**2
      p2p42  = p2p4**2
      p3p42  = p3p4**2
      s12    = 2d0*(mdn2-p1p2)
      s15    = 2d0*(p1p2+p1p3+p1p4)-mdn2
      s25    = 2d0*(p1p2-p2p3-p2p4)-mdn2
      s35    = 2d0*(p1p3-p2p3-p3p4)-mmo2
      s45    = 2d0*(p1p4-p2p4-p3p4)-mmo2
      den1   = (s12-mz2r)/((s12-mz2r)**2+mz2r*wz2)
      den2   = (spr-mz2r)/((spr-mz2r)**2+mz2r*wz2)
      den3   = 1d0/s12
      den4   = 1d0/spr
      den5   = 1d0/(s35-mmo2)
      den6   = 1d0/(s45-mmo2)
      den7   = 1d0/(s15-mdn2)
      den8   = 1d0/(s25-mdn2)
      den12  = 1d0/((s12-mz2r)**2+mz2r*wz2)
      den22  = 1d0/((spr-mz2r)**2+mz2r*wz2)
      den32  = den3**2
      den42  = den4**2
      den52  = den5**2
      den62  = den6**2
      den72  = den7**2
      den82  = den8**2
***      factor = g2*g4*stw2*l1*l2/pi4/mw4/s/spr/(s-mdn2)/331776d0
      factor = g6*stw2*l1*l2/pi4/mw4/s/spr/(s-mdn2)/331776d0
      born1 = 0d0
     $+(den1*den2+mz2r*wz2*den12*den22)*den5*den7*(
     $+108d0*stw2*p1p2*p1p3*mmo2*mz4
     $+108d0*stw2*p1p2*p1p4*mmo2*mz4
     $+576d0*stw2*p1p2*p2p3*p2p4*mz4
     $+576d0*stw2*p1p2*p2p4*p3p4*mz4
     $+864d0*stw2*p1p2*p2p4*mmo2*mz4
     $+576d0*stw2*p1p2*p3p4*mdn2*mmo2*mz2r
     $-72d0*stw2*p1p2*p3p4*mdn2*mz4
     $-216d0*stw2*p1p2*p3p4*mmo2*mz4
     $+576d0*stw2*p1p2*mdn2*mz2r*mmo4
     $-216d0*stw2*p1p2*mmo4*mz4
     $+288d0*stw2*p1p3*p1p4*mdn2*mmo2*mz2r
     $-36d0*stw2*p1p3*p1p4*mdn2*mz4
     $-288d0*stw2*p1p3*p2p3*mdn2*mmo2*mz2r
     $+108d0*stw2*p1p3*p2p3*mmo2*mz4
     $-288d0*stw2*p1p3*p2p4*mdn2*mmo2*mz2r
     $+288d0*stw2*p1p3*p2p4*mdn2*mz4
     $+288d0*stw2*p1p3*p2p4*mmo2*mz4
     $-36d0*stw2*p1p3*p3p4*mdn2*mz4
     $+576d0*stw2*p1p4*p2p3*p2p4*mz4
     $-288d0*stw2*p1p4*p2p3*mdn2*mmo2*mz2r
     $+72d0*stw2*p1p4*p2p3*mdn2*mz4
     $+216d0*stw2*p1p4*p2p3*mmo2*mz4
     $+576d0*stw2*p1p4*p2p4*p3p4*mz4
     $-288d0*stw2*p1p4*p2p4*mdn2*mmo2*mz2r
     $+972d0*stw2*p1p4*p2p4*mmo2*mz4
     $+180d0*stw2*p1p4*mdn2*mmo2*mz4
     $+288d0*stw2*p2p3*p2p4*mdn2*mmo2*mz2r
     $-900d0*stw2*p2p3*p2p4*mdn2*mz4
     $+36d0*stw2*p2p3*p3p4*mdn2*mz4
     $-252d0*stw2*p2p3*mdn2*mmo2*mz4
     $-864d0*stw2*p2p4*p3p4*mdn2*mz4
     $-1296d0*stw2*p2p4*mdn2*mmo2*mz4
     $-576d0*stw2*p3p4*mmo2*mz2r*mdn4
     $+72d0*stw2*p3p4*mdn4*mz4
     $+108d0*stw2*p1p22*mmo2*mz4
     $+144d0*stw2*p1p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p1p42*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p42*mdn2*mmo2*mz2r
     $+36d0*stw2*p3p42*mdn2*mz4
     $-36d0*stw2*mdn2*mmo4*mz4
     $-108d0*stw2*mmo2*mdn4*mz4
     $-576d0*stw2*mz2r*mdn4*mmo4
     $+240d0*stw4*p1p2*p1p3*p2p4*mz4
     $-240d0*stw4*p1p2*p1p3*p3p4*mz4
     $-360d0*stw4*p1p2*p1p3*mmo2*mz4
     $+240d0*stw4*p1p2*p1p4*p2p3*mz4
     $-120d0*stw4*p1p2*p1p4*mmo2*mz4
     $-1056d0*stw4*p1p2*p2p3*p2p4*mz4
     $-816d0*stw4*p1p2*p2p4*p3p4*mz4
     $-1584d0*stw4*p1p2*p2p4*mmo2*mz4
     $-576d0*stw4*p1p2*p3p4*mdn2*mmo2*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mz4
     $+960d0*stw4*p1p2*p3p4*mmo2*mz4
     $+240d0*stw4*p1p2*p3p42*mz4
     $+432d0*stw4*p1p2*mdn2*mmo2*mz4
     $-576d0*stw4*p1p2*mdn2*mz2r*mmo4
     $+720d0*stw4*p1p2*mmo4*mz4
     $-240d0*stw4*p1p3*p1p4*p2p3*mz4
     $-288d0*stw4*p1p3*p1p4*mdn2*mmo2*mz2r
     $-72d0*stw4*p1p3*p1p4*mdn2*mz4
     $+288d0*stw4*p1p3*p2p3*mdn2*mmo2*mz2r
     $-120d0*stw4*p1p3*p2p3*mmo2*mz4
     $-240d0*stw4*p1p3*p2p4*p3p4*mz4
     $+288d0*stw4*p1p3*p2p4*mdn2*mmo2*mz2r
     $-768d0*stw4*p1p3*p2p4*mdn2*mz4
     $-768d0*stw4*p1p3*p2p4*mmo2*mz4
     $+168d0*stw4*p1p3*p3p4*mdn2*mz4
     $-240d0*stw4*p1p3*p2p42*mz4
     $+144d0*stw4*p1p3*mdn2*mmo2*mz4
     $-1296d0*stw4*p1p4*p2p3*p2p4*mz4
     $-240d0*stw4*p1p4*p2p3*p3p4*mz4
     $+288d0*stw4*p1p4*p2p3*mdn2*mmo2*mz2r
     $-336d0*stw4*p1p4*p2p3*mdn2*mz4
     $-720d0*stw4*p1p4*p2p3*mmo2*mz4
     $-1056d0*stw4*p1p4*p2p4*p3p4*mz4
     $+288d0*stw4*p1p4*p2p4*mdn2*mmo2*mz2r
     $-1944d0*stw4*p1p4*p2p4*mmo2*mz4
     $-264d0*stw4*p1p4*mdn2*mmo2*mz4
     $-288d0*stw4*p2p3*p2p4*mdn2*mmo2*mz2r
     $+1752d0*stw4*p2p3*p2p4*mdn2*mz4
     $+72d0*stw4*p2p3*p3p4*mdn2*mz4
     $+456d0*stw4*p2p3*mdn2*mmo2*mz4
     $+1584d0*stw4*p2p4*p3p4*mdn2*mz4
     $+240d0*stw4*p2p4*p1p32*mz4
     $+2496d0*stw4*p2p4*mdn2*mmo2*mz4
     $-240d0*stw4*p3p4*p1p22*mz4
     $-432d0*stw4*p3p4*mdn2*mmo2*mz4
     $+576d0*stw4*p3p4*mmo2*mz2r*mdn4
     $-336d0*stw4*p3p4*mdn4*mz4
     $-360d0*stw4*p1p22*mmo2*mz4
     $-144d0*stw4*p1p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p1p42*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p42*mdn2*mmo2*mz2r
     $-168d0*stw4*p3p42*mdn2*mz4
     $-264d0*stw4*mdn2*mmo4*mz4
     $-72d0*stw4*mmo2*mdn4*mz4
     $+576d0*stw4*mz2r*mdn4*mmo4
     $-384d0*stw6*p1p2*p1p3*p2p4*mz4
     $+384d0*stw6*p1p2*p1p3*p3p4*mz4
     $+384d0*stw6*p1p2*p1p3*mmo2*mz4
     $-384d0*stw6*p1p2*p1p4*p2p3*mz4
     $+768d0*stw6*p1p2*p2p3*p2p4*mz4
     $+384d0*stw6*p1p2*p2p4*p3p4*mz4
     $+1152d0*stw6*p1p2*p2p4*mmo2*mz4
     $-1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $-1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $-384d0*stw6*p1p2*p3p42*mz4
     $-1152d0*stw6*p1p2*mdn2*mmo2*mz4
     $-768d0*stw6*p1p2*mmo4*mz4
     $+384d0*stw6*p1p3*p1p4*p2p3*mz4
     $+384d0*stw6*p1p3*p2p4*p3p4*mz4
     $+768d0*stw6*p1p3*p2p4*mdn2*mz4
     $+768d0*stw6*p1p3*p2p4*mmo2*mz4
     $-384d0*stw6*p1p3*p3p4*mdn2*mz4
     $+384d0*stw6*p1p3*p2p42*mz4
     $-384d0*stw6*p1p3*mdn2*mmo2*mz4
     $+1152d0*stw6*p1p4*p2p3*p2p4*mz4
     $+384d0*stw6*p1p4*p2p3*p3p4*mz4
     $+768d0*stw6*p1p4*p2p3*mdn2*mz4
     $+768d0*stw6*p1p4*p2p3*mmo2*mz4
     $+768d0*stw6*p1p4*p2p4*p3p4*mz4
     $+1536d0*stw6*p1p4*p2p4*mmo2*mz4
     $-1536d0*stw6*p2p3*p2p4*mdn2*mz4
     $-1152d0*stw6*p2p4*p3p4*mdn2*mz4
     $-384d0*stw6*p2p4*p1p32*mz4
     $-1920d0*stw6*p2p4*mdn2*mmo2*mz4
     $+384d0*stw6*p3p4*p1p22*mz4
     $+1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $+768d0*stw6*p3p4*mdn4*mz4
     $+384d0*stw6*p1p22*mmo2*mz4
     $+384d0*stw6*p3p42*mdn2*mz4
     $+768d0*stw6*mdn2*mmo4*mz4
     $+768d0*stw6*mmo2*mdn4*mz4
     $+192d0*stw8*p1p2*p1p3*p2p4*mz4
     $-192d0*stw8*p1p2*p1p3*p3p4*mz4
     $-192d0*stw8*p1p2*p1p3*mmo2*mz4
     $+192d0*stw8*p1p2*p1p4*p2p3*mz4
     $-384d0*stw8*p1p2*p2p3*p2p4*mz4
     $-192d0*stw8*p1p2*p2p4*p3p4*mz4
     $-576d0*stw8*p1p2*p2p4*mmo2*mz4
     $+576d0*stw8*p1p2*p3p4*mdn2*mz4
     $+576d0*stw8*p1p2*p3p4*mmo2*mz4
     $+192d0*stw8*p1p2*p3p42*mz4
     $+576d0*stw8*p1p2*mdn2*mmo2*mz4
     $+384d0*stw8*p1p2*mmo4*mz4
     $-192d0*stw8*p1p3*p1p4*p2p3*mz4
     $-192d0*stw8*p1p3*p2p4*p3p4*mz4
     $-384d0*stw8*p1p3*p2p4*mdn2*mz4
     $-384d0*stw8*p1p3*p2p4*mmo2*mz4
     $+192d0*stw8*p1p3*p3p4*mdn2*mz4
     $-192d0*stw8*p1p3*p2p42*mz4
     $+192d0*stw8*p1p3*mdn2*mmo2*mz4
     $-576d0*stw8*p1p4*p2p3*p2p4*mz4
     $-192d0*stw8*p1p4*p2p3*p3p4*mz4
     $-384d0*stw8*p1p4*p2p3*mdn2*mz4
     $-384d0*stw8*p1p4*p2p3*mmo2*mz4
     $-384d0*stw8*p1p4*p2p4*p3p4*mz4
     $-768d0*stw8*p1p4*p2p4*mmo2*mz4
     $+768d0*stw8*p2p3*p2p4*mdn2*mz4
     $+576d0*stw8*p2p4*p3p4*mdn2*mz4
     $+192d0*stw8*p2p4*p1p32*mz4
     $+960d0*stw8*p2p4*mdn2*mmo2*mz4
     $-192d0*stw8*p3p4*p1p22*mz4
     $-576d0*stw8*p3p4*mdn2*mmo2*mz4
     $-384d0*stw8*p3p4*mdn4*mz4
     $-192d0*stw8*p1p22*mmo2*mz4
     $-192d0*stw8*p3p42*mdn2*mz4
     $-384d0*stw8*mdn2*mmo4*mz4
     $-384d0*stw8*mmo2*mdn4*mz4
     $-27d0*p1p2*p1p3*p3p4*mdn2*mmo2
     $+27d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p1p3*mdn2*mmo4
     $+27d0*p1p2*p1p4*p3p4*mdn2*mmo2
     $-27d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p1p4*mdn2*mmo4
     $-108d0*p1p2*p2p3*p2p4*mz4
     $-27d0*p1p2*p2p3*p3p4*mdn2*mmo2
     $-54d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p2p3*mdn2*mmo4
     $-81d0*p1p2*p2p4*p3p4*mdn2*mmo2
     $-108d0*p1p2*p2p4*p3p4*mz4
     $+54d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $-81d0*p1p2*p2p4*mdn2*mmo4
     $-162d0*p1p2*p2p4*mmo2*mz4
     $-162d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-162d0*p1p2*mdn2*mz2r*mmo4
     $-27d0*p1p3*p1p4*p2p3*mdn2*mmo2
     $+27d0*p1p3*p1p4*p2p4*mdn2*mmo2
     $-27d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-27d0*p1p3*p2p3*p2p4*mdn2*mmo2
     $+27d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+54d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $-54d0*p1p3*p2p4*mdn2*mz4
     $-54d0*p1p3*p2p4*mmo2*mz4
     $-27d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $+27d0*p1p3*p3p4*mmo2*mdn4
     $-27d0*p1p3*p2p42*mdn2*mmo2
     $-27d0*p1p3*mdn2*mz2r*mmo4
     $-27d0*p1p3*mmo2*mz2r*mdn4
     $+27d0*p1p3*mdn4*mmo4
     $+27d0*p1p4*p2p3*p2p4*mdn2*mmo2
     $-108d0*p1p4*p2p3*p2p4*mz4
     $+54d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $-108d0*p1p4*p2p4*p3p4*mz4
     $+81d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $-162d0*p1p4*p2p4*mmo2*mz4
     $-54d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $-27d0*p1p4*p3p4*mmo2*mdn4
     $+27d0*p1p4*p2p32*mdn2*mmo2
     $-54d0*p1p4*mdn2*mz2r*mmo4
     $+27d0*p1p4*mmo2*mz2r*mdn4
     $-27d0*p1p4*mdn4*mmo4
     $-81d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $+162d0*p2p3*p2p4*mdn2*mz4
     $-27d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $+27d0*p2p3*p3p4*mmo2*mdn4
     $-27d0*p2p3*p1p42*mdn2*mmo2
     $-27d0*p2p3*mdn2*mz2r*mmo4
     $+54d0*p2p3*mmo2*mz2r*mdn4
     $+27d0*p2p3*mdn4*mmo4
     $-54d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $+162d0*p2p4*p3p4*mdn2*mz4
     $+81d0*p2p4*p3p4*mmo2*mdn4
     $+27d0*p2p4*p1p32*mdn2*mmo2
     $+216d0*p2p4*mdn2*mmo2*mz4
     $-54d0*p2p4*mdn2*mz2r*mmo4
     $-54d0*p2p4*mmo2*mz2r*mdn4
     $+81d0*p2p4*mdn4*mmo4
     $+162d0*p3p4*mmo2*mz2r*mdn4
     $-27d0*p1p42*mdn2*mmo2*mz2r
     $-27d0*p2p32*mdn2*mmo2*mz2r
     $-54d0*p2p42*mdn2*mmo2*mz2r
     $+162d0*mz2r*mdn4*mmo4
     $)
     $+(den1*den2+mz2r*wz2*den12*den22)*den5*den8*(
     $+288d0*stw2*p1p2*p1p3*p2p4*mz4
     $+288d0*stw2*p1p2*p1p4*p2p3*mz4
     $-288d0*stw2*p1p2*p1p4*p3p4*mz4
     $+288d0*stw2*p1p2*p2p3*p3p4*mz4
     $+108d0*stw2*p1p2*p2p3*mmo2*mz4
     $-180d0*stw2*p1p2*p2p4*mmo2*mz4
     $+576d0*stw2*p1p2*p3p4*mdn2*mmo2*mz2r
     $+360d0*stw2*p1p2*p3p4*mdn2*mz4
     $+504d0*stw2*p1p2*p3p4*mmo2*mz4
     $+288d0*stw2*p1p2*p3p42*mz4
     $+576d0*stw2*p1p2*mdn2*mz2r*mmo4
     $+216d0*stw2*p1p2*mmo4*mz4
     $+288d0*stw2*p1p3*p1p4*p2p4*mz4
     $+288d0*stw2*p1p3*p1p4*mdn2*mmo2*mz2r
     $+36d0*stw2*p1p3*p1p4*mdn2*mz4
     $+288d0*stw2*p1p3*p2p3*p2p4*mz4
     $-288d0*stw2*p1p3*p2p3*mdn2*mmo2*mz2r
     $+180d0*stw2*p1p3*p2p3*mmo2*mz4
     $-288d0*stw2*p1p3*p2p4*p3p4*mz4
     $-288d0*stw2*p1p3*p2p4*mdn2*mmo2*mz2r
     $-72d0*stw2*p1p3*p2p4*mdn2*mz4
     $-216d0*stw2*p1p3*p2p4*mmo2*mz4
     $-252d0*stw2*p1p3*p3p4*mdn2*mz4
     $-252d0*stw2*p1p3*mdn2*mmo2*mz4
     $-288d0*stw2*p1p4*p2p3*p3p4*mz4
     $-288d0*stw2*p1p4*p2p3*mdn2*mmo2*mz2r
     $-288d0*stw2*p1p4*p2p3*mdn2*mz4
     $-288d0*stw2*p1p4*p2p3*mmo2*mz4
     $-288d0*stw2*p1p4*p2p4*mdn2*mmo2*mz2r
     $-108d0*stw2*p1p4*p2p4*mmo2*mz4
     $-288d0*stw2*p1p4*p2p32*mz4
     $-144d0*stw2*p1p4*mdn2*mmo2*mz4
     $+288d0*stw2*p2p3*p2p4*mdn2*mmo2*mz2r
     $-252d0*stw2*p2p3*p2p4*mdn2*mz4
     $-36d0*stw2*p2p3*p3p4*mdn2*mz4
     $+288d0*stw2*p2p3*p1p42*mz4
     $+180d0*stw2*p2p4*mdn2*mmo2*mz4
     $-288d0*stw2*p3p4*p1p22*mz4
     $-576d0*stw2*p3p4*mmo2*mz2r*mdn4
     $-72d0*stw2*p3p4*mdn4*mz4
     $-108d0*stw2*p1p22*mmo2*mz4
     $+144d0*stw2*p1p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p1p42*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p42*mdn2*mmo2*mz2r
     $-36d0*stw2*p3p42*mdn2*mz4
     $+36d0*stw2*mdn2*mmo4*mz4
     $+108d0*stw2*mmo2*mdn4*mz4
     $-576d0*stw2*mz2r*mdn4*mmo4
     $+480d0*stw4*p1p2*p1p3*p1p4*mz4
     $-528d0*stw4*p1p2*p1p3*p2p4*mz4
     $-528d0*stw4*p1p2*p1p4*p2p3*mz4
     $+48d0*stw4*p1p2*p1p4*p3p4*mz4
     $-720d0*stw4*p1p2*p1p4*mmo2*mz4
     $-528d0*stw4*p1p2*p2p3*p3p4*mz4
     $-360d0*stw4*p1p2*p2p3*mmo2*mz4
     $+168d0*stw4*p1p2*p2p4*mmo2*mz4
     $-576d0*stw4*p1p2*p3p4*mdn2*mmo2*mz2r
     $-864d0*stw4*p1p2*p3p4*mdn2*mz4
     $-1248d0*stw4*p1p2*p3p4*mmo2*mz4
     $-528d0*stw4*p1p2*p3p42*mz4
     $-432d0*stw4*p1p2*mdn2*mmo2*mz4
     $-576d0*stw4*p1p2*mdn2*mz2r*mmo4
     $-720d0*stw4*p1p2*mmo4*mz4
     $-1008d0*stw4*p1p3*p1p4*p2p4*mz4
     $-288d0*stw4*p1p3*p1p4*mdn2*mmo2*mz2r
     $-888d0*stw4*p1p3*p1p4*mdn2*mz4
     $-528d0*stw4*p1p3*p2p3*p2p4*mz4
     $+288d0*stw4*p1p3*p2p3*mdn2*mmo2*mz2r
     $-168d0*stw4*p1p3*p2p3*mmo2*mz4
     $+528d0*stw4*p1p3*p2p4*p3p4*mz4
     $+288d0*stw4*p1p3*p2p4*mdn2*mmo2*mz2r
     $+336d0*stw4*p1p3*p2p4*mdn2*mz4
     $+720d0*stw4*p1p3*p2p4*mmo2*mz4
     $+360d0*stw4*p1p3*p3p4*mdn2*mz4
     $+456d0*stw4*p1p3*mdn2*mmo2*mz4
     $+528d0*stw4*p1p4*p2p3*p3p4*mz4
     $+288d0*stw4*p1p4*p2p3*mdn2*mmo2*mz2r
     $+768d0*stw4*p1p4*p2p3*mdn2*mz4
     $+768d0*stw4*p1p4*p2p3*mmo2*mz4
     $+480d0*stw4*p1p4*p2p4*p3p4*mz4
     $+288d0*stw4*p1p4*p2p4*mdn2*mmo2*mz2r
     $+1080d0*stw4*p1p4*p2p4*mmo2*mz4
     $+720d0*stw4*p1p4*p3p4*mdn2*mz4
     $+528d0*stw4*p1p4*p2p32*mz4
     $+1344d0*stw4*p1p4*mdn2*mmo2*mz4
     $-288d0*stw4*p2p3*p2p4*mdn2*mmo2*mz2r
     $+360d0*stw4*p2p3*p2p4*mdn2*mz4
     $+168d0*stw4*p2p3*p3p4*mdn2*mz4
     $-528d0*stw4*p2p3*p1p42*mz4
     $+144d0*stw4*p2p3*mdn2*mmo2*mz4
     $-264d0*stw4*p2p4*mdn2*mmo2*mz4
     $+528d0*stw4*p3p4*p1p22*mz4
     $+432d0*stw4*p3p4*mdn2*mmo2*mz4
     $+576d0*stw4*p3p4*mmo2*mz2r*mdn4
     $+336d0*stw4*p3p4*mdn4*mz4
     $+360d0*stw4*p1p22*mmo2*mz4
     $-144d0*stw4*p1p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p1p42*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p42*mdn2*mmo2*mz2r
     $+168d0*stw4*p3p42*mdn2*mz4
     $+264d0*stw4*mdn2*mmo4*mz4
     $+72d0*stw4*mmo2*mdn4*mz4
     $+576d0*stw4*mz2r*mdn4*mmo4
     $-768d0*stw6*p1p2*p1p3*p1p4*mz4
     $+384d0*stw6*p1p2*p1p3*p2p4*mz4
     $+384d0*stw6*p1p2*p1p4*p2p3*mz4
     $+384d0*stw6*p1p2*p1p4*p3p4*mz4
     $+1152d0*stw6*p1p2*p1p4*mmo2*mz4
     $+384d0*stw6*p1p2*p2p3*p3p4*mz4
     $+384d0*stw6*p1p2*p2p3*mmo2*mz4
     $+1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $+384d0*stw6*p1p2*p3p42*mz4
     $+1152d0*stw6*p1p2*mdn2*mmo2*mz4
     $+768d0*stw6*p1p2*mmo4*mz4
     $+1152d0*stw6*p1p3*p1p4*p2p4*mz4
     $+1536d0*stw6*p1p3*p1p4*mdn2*mz4
     $+384d0*stw6*p1p3*p2p3*p2p4*mz4
     $-384d0*stw6*p1p3*p2p4*p3p4*mz4
     $-768d0*stw6*p1p3*p2p4*mdn2*mz4
     $-768d0*stw6*p1p3*p2p4*mmo2*mz4
     $-384d0*stw6*p1p4*p2p3*p3p4*mz4
     $-768d0*stw6*p1p4*p2p3*mdn2*mz4
     $-768d0*stw6*p1p4*p2p3*mmo2*mz4
     $-768d0*stw6*p1p4*p2p4*p3p4*mz4
     $-1536d0*stw6*p1p4*p2p4*mmo2*mz4
     $-1152d0*stw6*p1p4*p3p4*mdn2*mz4
     $-384d0*stw6*p1p4*p2p32*mz4
     $-1920d0*stw6*p1p4*mdn2*mmo2*mz4
     $-384d0*stw6*p2p3*p3p4*mdn2*mz4
     $+384d0*stw6*p2p3*p1p42*mz4
     $-384d0*stw6*p2p3*mdn2*mmo2*mz4
     $-384d0*stw6*p3p4*p1p22*mz4
     $-1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $-768d0*stw6*p3p4*mdn4*mz4
     $-384d0*stw6*p1p22*mmo2*mz4
     $-384d0*stw6*p3p42*mdn2*mz4
     $-768d0*stw6*mdn2*mmo4*mz4
     $-768d0*stw6*mmo2*mdn4*mz4
     $+384d0*stw8*p1p2*p1p3*p1p4*mz4
     $-192d0*stw8*p1p2*p1p3*p2p4*mz4
     $-192d0*stw8*p1p2*p1p4*p2p3*mz4
     $-192d0*stw8*p1p2*p1p4*p3p4*mz4
     $-576d0*stw8*p1p2*p1p4*mmo2*mz4
     $-192d0*stw8*p1p2*p2p3*p3p4*mz4
     $-192d0*stw8*p1p2*p2p3*mmo2*mz4
     $-576d0*stw8*p1p2*p3p4*mdn2*mz4
     $-576d0*stw8*p1p2*p3p4*mmo2*mz4
     $-192d0*stw8*p1p2*p3p42*mz4
     $-576d0*stw8*p1p2*mdn2*mmo2*mz4
     $-384d0*stw8*p1p2*mmo4*mz4
     $-576d0*stw8*p1p3*p1p4*p2p4*mz4
     $-768d0*stw8*p1p3*p1p4*mdn2*mz4
     $-192d0*stw8*p1p3*p2p3*p2p4*mz4
     $+192d0*stw8*p1p3*p2p4*p3p4*mz4
     $+384d0*stw8*p1p3*p2p4*mdn2*mz4
     $+384d0*stw8*p1p3*p2p4*mmo2*mz4
     $+192d0*stw8*p1p4*p2p3*p3p4*mz4
     $+384d0*stw8*p1p4*p2p3*mdn2*mz4
     $+384d0*stw8*p1p4*p2p3*mmo2*mz4
     $+384d0*stw8*p1p4*p2p4*p3p4*mz4
     $+768d0*stw8*p1p4*p2p4*mmo2*mz4
     $+576d0*stw8*p1p4*p3p4*mdn2*mz4
     $+192d0*stw8*p1p4*p2p32*mz4
     $+960d0*stw8*p1p4*mdn2*mmo2*mz4
     $+192d0*stw8*p2p3*p3p4*mdn2*mz4
     $-192d0*stw8*p2p3*p1p42*mz4
     $+192d0*stw8*p2p3*mdn2*mmo2*mz4
     $+192d0*stw8*p3p4*p1p22*mz4
     $+576d0*stw8*p3p4*mdn2*mmo2*mz4
     $+384d0*stw8*p3p4*mdn4*mz4
     $+192d0*stw8*p1p22*mmo2*mz4
     $+192d0*stw8*p3p42*mdn2*mz4
     $+384d0*stw8*mdn2*mmo4*mz4
     $+384d0*stw8*mmo2*mdn4*mz4
     $-54d0*p1p2*p1p3*p2p4*mz4
     $-27d0*p1p2*p1p3*p3p4*mdn2*mmo2
     $-54d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p1p3*mdn2*mmo4
     $-54d0*p1p2*p1p4*p2p3*mz4
     $-81d0*p1p2*p1p4*p3p4*mdn2*mmo2
     $+54d0*p1p2*p1p4*p3p4*mz4
     $+54d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $-81d0*p1p2*p1p4*mdn2*mmo4
     $-27d0*p1p2*p2p3*p3p4*mdn2*mmo2
     $-54d0*p1p2*p2p3*p3p4*mz4
     $+27d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p2p3*mdn2*mmo4
     $+27d0*p1p2*p2p4*p3p4*mdn2*mmo2
     $-27d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p2p4*mdn2*mmo4
     $+54d0*p1p2*p2p4*mmo2*mz4
     $-54d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-54d0*p1p2*p3p4*mdn2*mz4
     $-54d0*p1p2*p3p4*mmo2*mz4
     $-54d0*p1p2*p3p42*mz4
     $-54d0*p1p2*mdn2*mz2r*mmo4
     $-27d0*p1p3*p1p4*p2p3*mdn2*mmo2
     $+27d0*p1p3*p1p4*p2p4*mdn2*mmo2
     $-54d0*p1p3*p1p4*p2p4*mz4
     $-27d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-27d0*p1p3*p2p3*p2p4*mdn2*mmo2
     $-54d0*p1p3*p2p3*p2p4*mz4
     $+81d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $-54d0*p1p3*p2p3*mmo2*mz4
     $+54d0*p1p3*p2p4*p3p4*mz4
     $+54d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $-27d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $+54d0*p1p3*p3p4*mdn2*mz4
     $+27d0*p1p3*p3p4*mmo2*mdn4
     $-27d0*p1p3*p2p42*mdn2*mmo2
     $-27d0*p1p3*mdn2*mz2r*mmo4
     $+54d0*p1p3*mmo2*mz2r*mdn4
     $+27d0*p1p3*mdn4*mmo4
     $+27d0*p1p4*p2p3*p2p4*mdn2*mmo2
     $+54d0*p1p4*p2p3*p3p4*mz4
     $+54d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+54d0*p1p4*p2p3*mdn2*mz4
     $+54d0*p1p4*p2p3*mmo2*mz4
     $+27d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $-54d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $+81d0*p1p4*p3p4*mmo2*mdn4
     $+27d0*p1p4*p2p32*mdn2*mmo2
     $+54d0*p1p4*p2p32*mz4
     $-54d0*p1p4*mdn2*mz2r*mmo4
     $-54d0*p1p4*mmo2*mz2r*mdn4
     $+81d0*p1p4*mdn4*mmo4
     $-81d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $+54d0*p2p3*p2p4*mdn2*mz4
     $-27d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $+27d0*p2p3*p3p4*mmo2*mdn4
     $-27d0*p2p3*p1p42*mdn2*mmo2
     $-54d0*p2p3*p1p42*mz4
     $-27d0*p2p3*mdn2*mz2r*mmo4
     $-27d0*p2p3*mmo2*mz2r*mdn4
     $+27d0*p2p3*mdn4*mmo4
     $-54d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $-27d0*p2p4*p3p4*mmo2*mdn4
     $+27d0*p2p4*p1p32*mdn2*mmo2
     $-54d0*p2p4*mdn2*mz2r*mmo4
     $+27d0*p2p4*mmo2*mz2r*mdn4
     $-27d0*p2p4*mdn4*mmo4
     $+54d0*p3p4*p1p22*mz4
     $+54d0*p3p4*mmo2*mz2r*mdn4
     $-27d0*p1p32*mdn2*mmo2*mz2r
     $-54d0*p2p32*mdn2*mmo2*mz2r
     $-27d0*p2p42*mdn2*mmo2*mz2r
     $+54d0*mz2r*mdn4*mmo4
     $)
     $+(den1*den2+mz2r*wz2*den12*den22)*den6*den7*(
     $+288d0*stw2*p1p2*p1p3*p2p4*mz4
     $+180d0*stw2*p1p2*p1p3*mmo2*mz4
     $+288d0*stw2*p1p2*p1p4*p2p3*mz4
     $-288d0*stw2*p1p2*p1p4*p3p4*mz4
     $-108d0*stw2*p1p2*p1p4*mmo2*mz4
     $+288d0*stw2*p1p2*p2p3*p3p4*mz4
     $+576d0*stw2*p1p2*p3p4*mdn2*mmo2*mz2r
     $+360d0*stw2*p1p2*p3p4*mdn2*mz4
     $+504d0*stw2*p1p2*p3p4*mmo2*mz4
     $+288d0*stw2*p1p2*p3p42*mz4
     $+576d0*stw2*p1p2*mdn2*mz2r*mmo4
     $+216d0*stw2*p1p2*mmo4*mz4
     $-288d0*stw2*p1p3*p1p4*p2p4*mz4
     $+288d0*stw2*p1p3*p1p4*mdn2*mmo2*mz2r
     $-252d0*stw2*p1p3*p1p4*mdn2*mz4
     $-288d0*stw2*p1p3*p2p3*p2p4*mz4
     $-288d0*stw2*p1p3*p2p3*mdn2*mmo2*mz2r
     $-108d0*stw2*p1p3*p2p3*mmo2*mz4
     $-288d0*stw2*p1p3*p2p4*p3p4*mz4
     $-288d0*stw2*p1p3*p2p4*mdn2*mmo2*mz2r
     $-72d0*stw2*p1p3*p2p4*mdn2*mz4
     $-216d0*stw2*p1p3*p2p4*mmo2*mz4
     $-180d0*stw2*p1p3*mdn2*mmo2*mz4
     $-288d0*stw2*p1p4*p2p3*p3p4*mz4
     $-288d0*stw2*p1p4*p2p3*mdn2*mmo2*mz2r
     $-288d0*stw2*p1p4*p2p3*mdn2*mz4
     $-288d0*stw2*p1p4*p2p3*mmo2*mz4
     $-288d0*stw2*p1p4*p2p4*mdn2*mmo2*mz2r
     $+180d0*stw2*p1p4*p2p4*mmo2*mz4
     $+36d0*stw2*p1p4*p3p4*mdn2*mz4
     $-288d0*stw2*p1p4*p2p32*mz4
     $+288d0*stw2*p2p3*p2p4*mdn2*mmo2*mz2r
     $+36d0*stw2*p2p3*p2p4*mdn2*mz4
     $+288d0*stw2*p2p3*p1p42*mz4
     $+144d0*stw2*p2p3*mdn2*mmo2*mz4
     $+252d0*stw2*p2p4*p3p4*mdn2*mz4
     $+252d0*stw2*p2p4*mdn2*mmo2*mz4
     $-288d0*stw2*p3p4*p1p22*mz4
     $-576d0*stw2*p3p4*mmo2*mz2r*mdn4
     $-72d0*stw2*p3p4*mdn4*mz4
     $-108d0*stw2*p1p22*mmo2*mz4
     $+144d0*stw2*p1p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p1p42*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p42*mdn2*mmo2*mz2r
     $-36d0*stw2*p3p42*mdn2*mz4
     $+36d0*stw2*mdn2*mmo4*mz4
     $+108d0*stw2*mmo2*mdn4*mz4
     $-576d0*stw2*mz2r*mdn4*mmo4
     $-528d0*stw4*p1p2*p1p3*p2p4*mz4
     $-168d0*stw4*p1p2*p1p3*mmo2*mz4
     $-528d0*stw4*p1p2*p1p4*p2p3*mz4
     $+528d0*stw4*p1p2*p1p4*p3p4*mz4
     $+360d0*stw4*p1p2*p1p4*mmo2*mz4
     $+480d0*stw4*p1p2*p2p3*p2p4*mz4
     $-48d0*stw4*p1p2*p2p3*p3p4*mz4
     $+720d0*stw4*p1p2*p2p3*mmo2*mz4
     $-576d0*stw4*p1p2*p3p4*mdn2*mmo2*mz2r
     $-864d0*stw4*p1p2*p3p4*mdn2*mz4
     $-1248d0*stw4*p1p2*p3p4*mmo2*mz4
     $-528d0*stw4*p1p2*p3p42*mz4
     $-432d0*stw4*p1p2*mdn2*mmo2*mz4
     $-576d0*stw4*p1p2*mdn2*mz2r*mmo4
     $-720d0*stw4*p1p2*mmo4*mz4
     $+528d0*stw4*p1p3*p1p4*p2p4*mz4
     $-288d0*stw4*p1p3*p1p4*mdn2*mmo2*mz2r
     $+360d0*stw4*p1p3*p1p4*mdn2*mz4
     $+1008d0*stw4*p1p3*p2p3*p2p4*mz4
     $+480d0*stw4*p1p3*p2p3*p3p4*mz4
     $+288d0*stw4*p1p3*p2p3*mdn2*mmo2*mz2r
     $+1080d0*stw4*p1p3*p2p3*mmo2*mz4
     $+528d0*stw4*p1p3*p2p4*p3p4*mz4
     $+288d0*stw4*p1p3*p2p4*mdn2*mmo2*mz2r
     $+336d0*stw4*p1p3*p2p4*mdn2*mz4
     $+720d0*stw4*p1p3*p2p4*mmo2*mz4
     $+264d0*stw4*p1p3*mdn2*mmo2*mz4
     $+528d0*stw4*p1p4*p2p3*p3p4*mz4
     $+288d0*stw4*p1p4*p2p3*mdn2*mmo2*mz2r
     $+768d0*stw4*p1p4*p2p3*mdn2*mz4
     $+768d0*stw4*p1p4*p2p3*mmo2*mz4
     $+288d0*stw4*p1p4*p2p4*mdn2*mmo2*mz2r
     $-168d0*stw4*p1p4*p2p4*mmo2*mz4
     $-168d0*stw4*p1p4*p3p4*mdn2*mz4
     $+528d0*stw4*p1p4*p2p32*mz4
     $-144d0*stw4*p1p4*mdn2*mmo2*mz4
     $-288d0*stw4*p2p3*p2p4*mdn2*mmo2*mz2r
     $-888d0*stw4*p2p3*p2p4*mdn2*mz4
     $-720d0*stw4*p2p3*p3p4*mdn2*mz4
     $-528d0*stw4*p2p3*p1p42*mz4
     $-1344d0*stw4*p2p3*mdn2*mmo2*mz4
     $-360d0*stw4*p2p4*p3p4*mdn2*mz4
     $-456d0*stw4*p2p4*mdn2*mmo2*mz4
     $+528d0*stw4*p3p4*p1p22*mz4
     $+432d0*stw4*p3p4*mdn2*mmo2*mz4
     $+576d0*stw4*p3p4*mmo2*mz2r*mdn4
     $+336d0*stw4*p3p4*mdn4*mz4
     $+360d0*stw4*p1p22*mmo2*mz4
     $-144d0*stw4*p1p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p1p42*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p42*mdn2*mmo2*mz2r
     $+168d0*stw4*p3p42*mdn2*mz4
     $+264d0*stw4*mdn2*mmo4*mz4
     $+72d0*stw4*mmo2*mdn4*mz4
     $+576d0*stw4*mz2r*mdn4*mmo4
     $+384d0*stw6*p1p2*p1p3*p2p4*mz4
     $+384d0*stw6*p1p2*p1p4*p2p3*mz4
     $-384d0*stw6*p1p2*p1p4*p3p4*mz4
     $-384d0*stw6*p1p2*p1p4*mmo2*mz4
     $-768d0*stw6*p1p2*p2p3*p2p4*mz4
     $-384d0*stw6*p1p2*p2p3*p3p4*mz4
     $-1152d0*stw6*p1p2*p2p3*mmo2*mz4
     $+1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $+384d0*stw6*p1p2*p3p42*mz4
     $+1152d0*stw6*p1p2*mdn2*mmo2*mz4
     $+768d0*stw6*p1p2*mmo4*mz4
     $-384d0*stw6*p1p3*p1p4*p2p4*mz4
     $-1152d0*stw6*p1p3*p2p3*p2p4*mz4
     $-768d0*stw6*p1p3*p2p3*p3p4*mz4
     $-1536d0*stw6*p1p3*p2p3*mmo2*mz4
     $-384d0*stw6*p1p3*p2p4*p3p4*mz4
     $-768d0*stw6*p1p3*p2p4*mdn2*mz4
     $-768d0*stw6*p1p3*p2p4*mmo2*mz4
     $-384d0*stw6*p1p4*p2p3*p3p4*mz4
     $-768d0*stw6*p1p4*p2p3*mdn2*mz4
     $-768d0*stw6*p1p4*p2p3*mmo2*mz4
     $+384d0*stw6*p1p4*p3p4*mdn2*mz4
     $-384d0*stw6*p1p4*p2p32*mz4
     $+384d0*stw6*p1p4*mdn2*mmo2*mz4
     $+1536d0*stw6*p2p3*p2p4*mdn2*mz4
     $+1152d0*stw6*p2p3*p3p4*mdn2*mz4
     $+384d0*stw6*p2p3*p1p42*mz4
     $+1920d0*stw6*p2p3*mdn2*mmo2*mz4
     $-384d0*stw6*p3p4*p1p22*mz4
     $-1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $-768d0*stw6*p3p4*mdn4*mz4
     $-384d0*stw6*p1p22*mmo2*mz4
     $-384d0*stw6*p3p42*mdn2*mz4
     $-768d0*stw6*mdn2*mmo4*mz4
     $-768d0*stw6*mmo2*mdn4*mz4
     $-192d0*stw8*p1p2*p1p3*p2p4*mz4
     $-192d0*stw8*p1p2*p1p4*p2p3*mz4
     $+192d0*stw8*p1p2*p1p4*p3p4*mz4
     $+192d0*stw8*p1p2*p1p4*mmo2*mz4
     $+384d0*stw8*p1p2*p2p3*p2p4*mz4
     $+192d0*stw8*p1p2*p2p3*p3p4*mz4
     $+576d0*stw8*p1p2*p2p3*mmo2*mz4
     $-576d0*stw8*p1p2*p3p4*mdn2*mz4
     $-576d0*stw8*p1p2*p3p4*mmo2*mz4
     $-192d0*stw8*p1p2*p3p42*mz4
     $-576d0*stw8*p1p2*mdn2*mmo2*mz4
     $-384d0*stw8*p1p2*mmo4*mz4
     $+192d0*stw8*p1p3*p1p4*p2p4*mz4
     $+576d0*stw8*p1p3*p2p3*p2p4*mz4
     $+384d0*stw8*p1p3*p2p3*p3p4*mz4
     $+768d0*stw8*p1p3*p2p3*mmo2*mz4
     $+192d0*stw8*p1p3*p2p4*p3p4*mz4
     $+384d0*stw8*p1p3*p2p4*mdn2*mz4
     $+384d0*stw8*p1p3*p2p4*mmo2*mz4
     $+192d0*stw8*p1p4*p2p3*p3p4*mz4
     $+384d0*stw8*p1p4*p2p3*mdn2*mz4
     $+384d0*stw8*p1p4*p2p3*mmo2*mz4
     $-192d0*stw8*p1p4*p3p4*mdn2*mz4
     $+192d0*stw8*p1p4*p2p32*mz4
     $-192d0*stw8*p1p4*mdn2*mmo2*mz4
     $-768d0*stw8*p2p3*p2p4*mdn2*mz4
     $-576d0*stw8*p2p3*p3p4*mdn2*mz4
     $-192d0*stw8*p2p3*p1p42*mz4
     $-960d0*stw8*p2p3*mdn2*mmo2*mz4
     $+192d0*stw8*p3p4*p1p22*mz4
     $+576d0*stw8*p3p4*mdn2*mmo2*mz4
     $+384d0*stw8*p3p4*mdn4*mz4
     $+192d0*stw8*p1p22*mmo2*mz4
     $+192d0*stw8*p3p42*mdn2*mz4
     $+384d0*stw8*mdn2*mmo4*mz4
     $+384d0*stw8*mmo2*mdn4*mz4
     $-54d0*p1p2*p1p3*p2p4*mz4
     $-27d0*p1p2*p1p3*p3p4*mdn2*mmo2
     $+27d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p1p3*mdn2*mmo4
     $-54d0*p1p2*p1p3*mmo2*mz4
     $-54d0*p1p2*p1p4*p2p3*mz4
     $+27d0*p1p2*p1p4*p3p4*mdn2*mmo2
     $+54d0*p1p2*p1p4*p3p4*mz4
     $-27d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p1p4*mdn2*mmo4
     $+81d0*p1p2*p2p3*p3p4*mdn2*mmo2
     $-54d0*p1p2*p2p3*p3p4*mz4
     $-54d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $+81d0*p1p2*p2p3*mdn2*mmo4
     $+27d0*p1p2*p2p4*p3p4*mdn2*mmo2
     $+54d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p2p4*mdn2*mmo4
     $-54d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-54d0*p1p2*p3p4*mdn2*mz4
     $-54d0*p1p2*p3p4*mmo2*mz4
     $-54d0*p1p2*p3p42*mz4
     $-54d0*p1p2*mdn2*mz2r*mmo4
     $-27d0*p1p3*p1p4*p2p3*mdn2*mmo2
     $+27d0*p1p3*p1p4*p2p4*mdn2*mmo2
     $+54d0*p1p3*p1p4*p2p4*mz4
     $-81d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $+54d0*p1p3*p1p4*mdn2*mz4
     $-27d0*p1p3*p2p3*p2p4*mdn2*mmo2
     $+54d0*p1p3*p2p3*p2p4*mz4
     $+27d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+54d0*p1p3*p2p4*p3p4*mz4
     $+54d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $+54d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $+27d0*p1p3*p3p4*mmo2*mdn4
     $-27d0*p1p3*p2p42*mdn2*mmo2
     $+54d0*p1p3*mdn2*mz2r*mmo4
     $-27d0*p1p3*mmo2*mz2r*mdn4
     $+27d0*p1p3*mdn4*mmo4
     $+27d0*p1p4*p2p3*p2p4*mdn2*mmo2
     $+54d0*p1p4*p2p3*p3p4*mz4
     $+54d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+54d0*p1p4*p2p3*mdn2*mz4
     $+54d0*p1p4*p2p3*mmo2*mz4
     $+81d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $-54d0*p1p4*p2p4*mmo2*mz4
     $+27d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $-27d0*p1p4*p3p4*mmo2*mdn4
     $+27d0*p1p4*p2p32*mdn2*mmo2
     $+54d0*p1p4*p2p32*mz4
     $+27d0*p1p4*mdn2*mz2r*mmo4
     $+27d0*p1p4*mmo2*mz2r*mdn4
     $-27d0*p1p4*mdn4*mmo4
     $-27d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $+54d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $-81d0*p2p3*p3p4*mmo2*mdn4
     $-27d0*p2p3*p1p42*mdn2*mmo2
     $-54d0*p2p3*p1p42*mz4
     $+54d0*p2p3*mdn2*mz2r*mmo4
     $+54d0*p2p3*mmo2*mz2r*mdn4
     $-81d0*p2p3*mdn4*mmo4
     $+27d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $-54d0*p2p4*p3p4*mdn2*mz4
     $-27d0*p2p4*p3p4*mmo2*mdn4
     $+27d0*p2p4*p1p32*mdn2*mmo2
     $+27d0*p2p4*mdn2*mz2r*mmo4
     $-54d0*p2p4*mmo2*mz2r*mdn4
     $-27d0*p2p4*mdn4*mmo4
     $+54d0*p3p4*p1p22*mz4
     $+54d0*p3p4*mmo2*mz2r*mdn4
     $-27d0*p1p32*mdn2*mmo2*mz2r
     $-54d0*p1p42*mdn2*mmo2*mz2r
     $-27d0*p2p42*mdn2*mmo2*mz2r
     $+54d0*mz2r*mdn4*mmo4
     $)
     $+(den1*den2+mz2r*wz2*den12*den22)*den6*den8*(
     $+576d0*stw2*p1p2*p1p3*p1p4*mz4
     $-576d0*stw2*p1p2*p1p3*p3p4*mz4
     $-864d0*stw2*p1p2*p1p3*mmo2*mz4
     $-108d0*stw2*p1p2*p2p3*mmo2*mz4
     $-108d0*stw2*p1p2*p2p4*mmo2*mz4
     $+576d0*stw2*p1p2*p3p4*mdn2*mmo2*mz2r
     $-72d0*stw2*p1p2*p3p4*mdn2*mz4
     $-216d0*stw2*p1p2*p3p4*mmo2*mz4
     $+576d0*stw2*p1p2*mdn2*mz2r*mmo4
     $-216d0*stw2*p1p2*mmo4*mz4
     $-576d0*stw2*p1p3*p1p4*p2p3*mz4
     $+288d0*stw2*p1p3*p1p4*mdn2*mmo2*mz2r
     $-900d0*stw2*p1p3*p1p4*mdn2*mz4
     $+576d0*stw2*p1p3*p2p3*p3p4*mz4
     $-288d0*stw2*p1p3*p2p3*mdn2*mmo2*mz2r
     $+972d0*stw2*p1p3*p2p3*mmo2*mz4
     $-288d0*stw2*p1p3*p2p4*mdn2*mmo2*mz2r
     $+288d0*stw2*p1p3*p2p4*mdn2*mz4
     $+288d0*stw2*p1p3*p2p4*mmo2*mz4
     $+864d0*stw2*p1p3*p3p4*mdn2*mz4
     $+1296d0*stw2*p1p3*mdn2*mmo2*mz4
     $-288d0*stw2*p1p4*p2p3*mdn2*mmo2*mz2r
     $+72d0*stw2*p1p4*p2p3*mdn2*mz4
     $+216d0*stw2*p1p4*p2p3*mmo2*mz4
     $-288d0*stw2*p1p4*p2p4*mdn2*mmo2*mz2r
     $+108d0*stw2*p1p4*p2p4*mmo2*mz4
     $-36d0*stw2*p1p4*p3p4*mdn2*mz4
     $+252d0*stw2*p1p4*mdn2*mmo2*mz4
     $+288d0*stw2*p2p3*p2p4*mdn2*mmo2*mz2r
     $-36d0*stw2*p2p3*p2p4*mdn2*mz4
     $-180d0*stw2*p2p3*mdn2*mmo2*mz4
     $+36d0*stw2*p2p4*p3p4*mdn2*mz4
     $-576d0*stw2*p3p4*mmo2*mz2r*mdn4
     $+72d0*stw2*p3p4*mdn4*mz4
     $+108d0*stw2*p1p22*mmo2*mz4
     $+144d0*stw2*p1p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p1p42*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p32*mdn2*mmo2*mz2r
     $+144d0*stw2*p2p42*mdn2*mmo2*mz2r
     $+36d0*stw2*p3p42*mdn2*mz4
     $-36d0*stw2*mdn2*mmo4*mz4
     $-108d0*stw2*mmo2*mdn4*mz4
     $-576d0*stw2*mz2r*mdn4*mmo4
     $-1056d0*stw4*p1p2*p1p3*p1p4*mz4
     $+240d0*stw4*p1p2*p1p3*p2p4*mz4
     $+816d0*stw4*p1p2*p1p3*p3p4*mz4
     $+1584d0*stw4*p1p2*p1p3*mmo2*mz4
     $+240d0*stw4*p1p2*p1p4*p2p3*mz4
     $+120d0*stw4*p1p2*p2p3*mmo2*mz4
     $+240d0*stw4*p1p2*p2p4*p3p4*mz4
     $+360d0*stw4*p1p2*p2p4*mmo2*mz4
     $-576d0*stw4*p1p2*p3p4*mdn2*mmo2*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mz4
     $+960d0*stw4*p1p2*p3p4*mmo2*mz4
     $+240d0*stw4*p1p2*p3p42*mz4
     $+432d0*stw4*p1p2*mdn2*mmo2*mz4
     $-576d0*stw4*p1p2*mdn2*mz2r*mmo4
     $+720d0*stw4*p1p2*mmo4*mz4
     $+1296d0*stw4*p1p3*p1p4*p2p3*mz4
     $-288d0*stw4*p1p3*p1p4*mdn2*mmo2*mz2r
     $+1752d0*stw4*p1p3*p1p4*mdn2*mz4
     $-1056d0*stw4*p1p3*p2p3*p3p4*mz4
     $+288d0*stw4*p1p3*p2p3*mdn2*mmo2*mz2r
     $-1944d0*stw4*p1p3*p2p3*mmo2*mz4
     $-240d0*stw4*p1p3*p2p4*p3p4*mz4
     $+288d0*stw4*p1p3*p2p4*mdn2*mmo2*mz2r
     $-768d0*stw4*p1p3*p2p4*mdn2*mz4
     $-768d0*stw4*p1p3*p2p4*mmo2*mz4
     $-1584d0*stw4*p1p3*p3p4*mdn2*mz4
     $-240d0*stw4*p1p3*p2p42*mz4
     $-2496d0*stw4*p1p3*mdn2*mmo2*mz4
     $+240d0*stw4*p1p4*p2p3*p2p4*mz4
     $-240d0*stw4*p1p4*p2p3*p3p4*mz4
     $+288d0*stw4*p1p4*p2p3*mdn2*mmo2*mz2r
     $-336d0*stw4*p1p4*p2p3*mdn2*mz4
     $-720d0*stw4*p1p4*p2p3*mmo2*mz4
     $+288d0*stw4*p1p4*p2p4*mdn2*mmo2*mz2r
     $-120d0*stw4*p1p4*p2p4*mmo2*mz4
     $-72d0*stw4*p1p4*p3p4*mdn2*mz4
     $-456d0*stw4*p1p4*mdn2*mmo2*mz4
     $-288d0*stw4*p2p3*p2p4*mdn2*mmo2*mz2r
     $-72d0*stw4*p2p3*p2p4*mdn2*mz4
     $+264d0*stw4*p2p3*mdn2*mmo2*mz4
     $-168d0*stw4*p2p4*p3p4*mdn2*mz4
     $+240d0*stw4*p2p4*p1p32*mz4
     $-144d0*stw4*p2p4*mdn2*mmo2*mz4
     $-240d0*stw4*p3p4*p1p22*mz4
     $-432d0*stw4*p3p4*mdn2*mmo2*mz4
     $+576d0*stw4*p3p4*mmo2*mz2r*mdn4
     $-336d0*stw4*p3p4*mdn4*mz4
     $-360d0*stw4*p1p22*mmo2*mz4
     $-144d0*stw4*p1p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p1p42*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p32*mdn2*mmo2*mz2r
     $-144d0*stw4*p2p42*mdn2*mmo2*mz2r
     $-168d0*stw4*p3p42*mdn2*mz4
     $-264d0*stw4*mdn2*mmo4*mz4
     $-72d0*stw4*mmo2*mdn4*mz4
     $+576d0*stw4*mz2r*mdn4*mmo4
     $+768d0*stw6*p1p2*p1p3*p1p4*mz4
     $-384d0*stw6*p1p2*p1p3*p2p4*mz4
     $-384d0*stw6*p1p2*p1p3*p3p4*mz4
     $-1152d0*stw6*p1p2*p1p3*mmo2*mz4
     $-384d0*stw6*p1p2*p1p4*p2p3*mz4
     $-384d0*stw6*p1p2*p2p4*p3p4*mz4
     $-384d0*stw6*p1p2*p2p4*mmo2*mz4
     $-1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $-1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $-384d0*stw6*p1p2*p3p42*mz4
     $-1152d0*stw6*p1p2*mdn2*mmo2*mz4
     $-768d0*stw6*p1p2*mmo4*mz4
     $-1152d0*stw6*p1p3*p1p4*p2p3*mz4
     $-1536d0*stw6*p1p3*p1p4*mdn2*mz4
     $+768d0*stw6*p1p3*p2p3*p3p4*mz4
     $+1536d0*stw6*p1p3*p2p3*mmo2*mz4
     $+384d0*stw6*p1p3*p2p4*p3p4*mz4
     $+768d0*stw6*p1p3*p2p4*mdn2*mz4
     $+768d0*stw6*p1p3*p2p4*mmo2*mz4
     $+1152d0*stw6*p1p3*p3p4*mdn2*mz4
     $+384d0*stw6*p1p3*p2p42*mz4
     $+1920d0*stw6*p1p3*mdn2*mmo2*mz4
     $-384d0*stw6*p1p4*p2p3*p2p4*mz4
     $+384d0*stw6*p1p4*p2p3*p3p4*mz4
     $+768d0*stw6*p1p4*p2p3*mdn2*mz4
     $+768d0*stw6*p1p4*p2p3*mmo2*mz4
     $+384d0*stw6*p2p4*p3p4*mdn2*mz4
     $-384d0*stw6*p2p4*p1p32*mz4
     $+384d0*stw6*p2p4*mdn2*mmo2*mz4
     $+384d0*stw6*p3p4*p1p22*mz4
     $+1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $+768d0*stw6*p3p4*mdn4*mz4
     $+384d0*stw6*p1p22*mmo2*mz4
     $+384d0*stw6*p3p42*mdn2*mz4
     $+768d0*stw6*mdn2*mmo4*mz4
     $+768d0*stw6*mmo2*mdn4*mz4
     $-384d0*stw8*p1p2*p1p3*p1p4*mz4
     $+192d0*stw8*p1p2*p1p3*p2p4*mz4
     $+192d0*stw8*p1p2*p1p3*p3p4*mz4
     $+576d0*stw8*p1p2*p1p3*mmo2*mz4
     $+192d0*stw8*p1p2*p1p4*p2p3*mz4
     $+192d0*stw8*p1p2*p2p4*p3p4*mz4
     $+192d0*stw8*p1p2*p2p4*mmo2*mz4
     $+576d0*stw8*p1p2*p3p4*mdn2*mz4
     $+576d0*stw8*p1p2*p3p4*mmo2*mz4
     $+192d0*stw8*p1p2*p3p42*mz4
     $+576d0*stw8*p1p2*mdn2*mmo2*mz4
     $+384d0*stw8*p1p2*mmo4*mz4
     $+576d0*stw8*p1p3*p1p4*p2p3*mz4
     $+768d0*stw8*p1p3*p1p4*mdn2*mz4
     $-384d0*stw8*p1p3*p2p3*p3p4*mz4
     $-768d0*stw8*p1p3*p2p3*mmo2*mz4
     $-192d0*stw8*p1p3*p2p4*p3p4*mz4
     $-384d0*stw8*p1p3*p2p4*mdn2*mz4
     $-384d0*stw8*p1p3*p2p4*mmo2*mz4
     $-576d0*stw8*p1p3*p3p4*mdn2*mz4
     $-192d0*stw8*p1p3*p2p42*mz4
     $-960d0*stw8*p1p3*mdn2*mmo2*mz4
     $+192d0*stw8*p1p4*p2p3*p2p4*mz4
     $-192d0*stw8*p1p4*p2p3*p3p4*mz4
     $-384d0*stw8*p1p4*p2p3*mdn2*mz4
     $-384d0*stw8*p1p4*p2p3*mmo2*mz4
     $-192d0*stw8*p2p4*p3p4*mdn2*mz4
     $+192d0*stw8*p2p4*p1p32*mz4
     $-192d0*stw8*p2p4*mdn2*mmo2*mz4
     $-192d0*stw8*p3p4*p1p22*mz4
     $-576d0*stw8*p3p4*mdn2*mmo2*mz4
     $-384d0*stw8*p3p4*mdn4*mz4
     $-192d0*stw8*p1p22*mmo2*mz4
     $-192d0*stw8*p3p42*mdn2*mz4
     $-384d0*stw8*mdn2*mmo4*mz4
     $-384d0*stw8*mmo2*mdn4*mz4
     $-108d0*p1p2*p1p3*p1p4*mz4
     $+81d0*p1p2*p1p3*p3p4*mdn2*mmo2
     $+108d0*p1p2*p1p3*p3p4*mz4
     $-54d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $+81d0*p1p2*p1p3*mdn2*mmo4
     $+162d0*p1p2*p1p3*mmo2*mz4
     $+27d0*p1p2*p1p4*p3p4*mdn2*mmo2
     $+54d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p1p4*mdn2*mmo4
     $-27d0*p1p2*p2p3*p3p4*mdn2*mmo2
     $+27d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $-27d0*p1p2*p2p3*mdn2*mmo4
     $+27d0*p1p2*p2p4*p3p4*mdn2*mmo2
     $-27d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+27d0*p1p2*p2p4*mdn2*mmo4
     $-162d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-162d0*p1p2*mdn2*mz2r*mmo4
     $-27d0*p1p3*p1p4*p2p3*mdn2*mmo2
     $+108d0*p1p3*p1p4*p2p3*mz4
     $+27d0*p1p3*p1p4*p2p4*mdn2*mmo2
     $-81d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $+162d0*p1p3*p1p4*mdn2*mz4
     $-27d0*p1p3*p2p3*p2p4*mdn2*mmo2
     $-108d0*p1p3*p2p3*p3p4*mz4
     $+81d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $-162d0*p1p3*p2p3*mmo2*mz4
     $+54d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $-54d0*p1p3*p2p4*mdn2*mz4
     $-54d0*p1p3*p2p4*mmo2*mz4
     $+54d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $-162d0*p1p3*p3p4*mdn2*mz4
     $-81d0*p1p3*p3p4*mmo2*mdn4
     $-27d0*p1p3*p2p42*mdn2*mmo2
     $-216d0*p1p3*mdn2*mmo2*mz4
     $+54d0*p1p3*mdn2*mz2r*mmo4
     $+54d0*p1p3*mmo2*mz2r*mdn4
     $-81d0*p1p3*mdn4*mmo4
     $+27d0*p1p4*p2p3*p2p4*mdn2*mmo2
     $+54d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+27d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $+27d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $-27d0*p1p4*p3p4*mmo2*mdn4
     $+27d0*p1p4*p2p32*mdn2*mmo2
     $+27d0*p1p4*mdn2*mz2r*mmo4
     $-54d0*p1p4*mmo2*mz2r*mdn4
     $-27d0*p1p4*mdn4*mmo4
     $-27d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $+54d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $+27d0*p2p3*p3p4*mmo2*mdn4
     $-27d0*p2p3*p1p42*mdn2*mmo2
     $+54d0*p2p3*mdn2*mz2r*mmo4
     $-27d0*p2p3*mmo2*mz2r*mdn4
     $+27d0*p2p3*mdn4*mmo4
     $+27d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $-27d0*p2p4*p3p4*mmo2*mdn4
     $+27d0*p2p4*p1p32*mdn2*mmo2
     $+27d0*p2p4*mdn2*mz2r*mmo4
     $+27d0*p2p4*mmo2*mz2r*mdn4
     $-27d0*p2p4*mdn4*mmo4
     $+162d0*p3p4*mmo2*mz2r*mdn4
     $-54d0*p1p32*mdn2*mmo2*mz2r
     $-27d0*p1p42*mdn2*mmo2*mz2r
     $-27d0*p2p32*mdn2*mmo2*mz2r
     $+162d0*mz2r*mdn4*mmo4
     $)
     $+den1*den3*den5*den6*(
     $-432d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $+216d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $-432d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $+216d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $-216d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-216d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $+1296d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+864d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p3p42*mw2r*mz2r
     $-432d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $+432d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $-432d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $+432d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-864d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-216d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $-432d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-864d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $-432d0*stw2*p1p4*p2p32*mw2r*mz2r
     $-216d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $+432d0*stw2*p2p3*p1p42*mw2r*mz2r
     $+216d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p3p4*p1p22*mw2r*mz2r
     $-864d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $-864d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-432d0*stw2*p3p42*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-6912d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-4608d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-2304d0*stw4*p1p2*p3p42*mw2r*mz2r
     $+1152d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+1152d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $-1152d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $+2304d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $+4608d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+1152d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+2304d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $+4608d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+1152d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-1152d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-1152d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+2304d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+4608d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $+4608d0*stw4*p3p4*mw2r*mz2r*mdn4
     $+2304d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+6912d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+4608d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+2304d0*stw6*p1p2*p3p42*mw2r*mz2r
     $-1152d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-1152d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $+1152d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $-2304d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $-4608d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-1152d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-2304d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $-4608d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-1152d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+1152d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+1152d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-2304d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-4608d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $-4608d0*stw6*p3p4*mw2r*mz2r*mdn4
     $-2304d0*stw6*p3p42*mdn2*mw2r*mz2r
     $)
     $+den1*den3*den52*(
     $+216d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p2p3*p2p4*mw2r*mz2r
     $-216d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p2*p2p4*p3p4*mw2r*mz2r
     $+432d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-216d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-216d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-1296d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-216d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $+216d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-432d0*stw2*p1p3*p2p42*mw2r*mz2r
     $-216d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+432d0*stw2*p1p4*p2p3*p2p4*mw2r*mz2r
     $+216d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $+432d0*stw2*p1p4*p2p4*p3p4*mw2r*mz2r
     $+864d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $-432d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-648d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $+216d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-432d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+432d0*stw2*p1p22*mmo2*mw2r*mz2r
     $+432d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+864d0*stw2*mmo2*mw2r*mz2r*mdn4
     $-1152d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+6912d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+2304d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+1152d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $+2304d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+1152d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $-1152d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $-2304d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $-4608d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $+2304d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-1152d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-2304d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-2304d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-4608d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+1152d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-6912d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-2304d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-1152d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $-2304d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-1152d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $+1152d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $+2304d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $+4608d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $-2304d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+1152d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+2304d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+2304d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+4608d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den1*den3*den62*(
     $+432d0*stw2*p1p2*p1p3*p1p4*mw2r*mz2r
     $-432d0*stw2*p1p2*p1p3*p3p4*mw2r*mz2r
     $-432d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $+216d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-432d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-216d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-216d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-216d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-1296d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-432d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-432d0*stw2*p1p3*p1p4*p2p3*mw2r*mz2r
     $-648d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $+432d0*stw2*p1p3*p2p3*p3p4*mw2r*mz2r
     $+864d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+216d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+432d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+432d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-216d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-216d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $+432d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+432d0*stw2*p2p4*p1p32*mw2r*mz2r
     $+216d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+216d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+432d0*stw2*p1p22*mmo2*mw2r*mz2r
     $+432d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+864d0*stw2*mmo2*mw2r*mz2r*mdn4
     $-1152d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $-1152d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $+1152d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+6912d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+2304d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+1152d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+2304d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-2304d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $-4608d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $-1152d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+1152d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+1152d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $+2304d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $+1152d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-1152d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-1152d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-2304d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-2304d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-4608d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+1152d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $+1152d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $-1152d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-6912d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-2304d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-1152d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-2304d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+2304d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $+4608d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $+1152d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-1152d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-1152d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $-2304d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $-1152d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $+1152d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+1152d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+1152d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+2304d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+2304d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+4608d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den1*den4*den5*den7*(
     $-144d0*stw2*p1p2*p2p3*p2p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p2*p2p4*p3p4*mw2r*mz2r
     $-288d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $+36d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $-36d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+144d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p4*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $-36d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p4*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $-288d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+144d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $+216d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+144d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $+216d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-324d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $-108d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p3p42*mdn2*mw2r*mz2r
     $-252d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-108d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $-192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $+384d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $+576d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+192d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p42*mw2r*mz2r
     $-192d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $+768d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-768d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-960d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $-384d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $-576d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-192d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p42*mw2r*mz2r
     $+192d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $-768d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+768d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+960d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den1*den4*den5*den8*(
     $-72d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-180d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p3p42*mw2r*mz2r
     $-108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $-108d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-72d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p32*mw2r*mz2r
     $+144d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p3*p1p42*mw2r*mz2r
     $-72d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-72d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p3p4*p1p22*mw2r*mz2r
     $-108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $+36d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+72d0*stw2*p1p22*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-108d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+36d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $-384d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $+576d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+576d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $+768d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $-768d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p32*mw2r*mz2r
     $-960d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-192d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+384d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $-576d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-576d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $-768d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $+768d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p32*mw2r*mz2r
     $+960d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+192d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den1*den4*den6*den7*(
     $-72d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-180d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p3p42*mw2r*mz2r
     $-108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $-108d0*stw2*p1p2*mw2r*mz2r*mmo4
     $+72d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+144d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p32*mw2r*mz2r
     $+72d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*p1p42*mw2r*mz2r
     $-144d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-72d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p3p4*p1p22*mw2r*mz2r
     $-108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $+36d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+72d0*stw2*p1p22*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-108d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+36d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $+192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $-576d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $-192d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $-576d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $-768d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+192d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $+768d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p2p3*p1p42*mw2r*mz2r
     $+960d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $+576d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $+192d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $+576d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $+768d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-192d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $-768d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p2p3*p1p42*mw2r*mz2r
     $-960d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den1*den4*den6*den8*(
     $-144d0*stw2*p1p2*p1p3*p1p4*mw2r*mz2r
     $+144d0*stw2*p1p2*p1p3*p3p4*mw2r*mz2r
     $+288d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $+108d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+36d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $+36d0*stw2*p1p2*mw2r*mz2r*mmo4
     $+144d0*stw2*p1p3*p1p4*p2p3*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+216d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p1p3*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $-288d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $-36d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $-216d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $-36d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-72d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-324d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $-108d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p3p42*mdn2*mw2r*mz2r
     $-252d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-108d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $+384d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $-576d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $-576d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $-768d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $+768d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+960d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p2p4*p1p32*mw2r*mz2r
     $+192d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $-384d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $+576d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $+576d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $+768d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $-768d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-960d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p2p4*p1p32*mw2r*mz2r
     $-192d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den3*den5*den7*(
     $-72d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p2*p2p3*p2p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p2*p2p4*p3p4*mw2r*mz2r
     $-144d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+324d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $+108d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-36d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p4*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-36d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $-144d0*stw2*p1p4*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $-216d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $+288d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $+216d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $-36d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p22*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-108d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-252d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $-192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $+384d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $+576d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+192d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p42*mw2r*mz2r
     $-192d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $+768d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-768d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-960d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $-384d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $-576d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-192d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p42*mw2r*mz2r
     $+192d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $-768d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+768d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+960d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den3*den5*den8*(
     $-72d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $-180d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p3p42*mw2r*mz2r
     $+108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $-36d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-72d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p32*mw2r*mz2r
     $+144d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*p1p42*mw2r*mz2r
     $-72d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p3p4*p1p22*mw2r*mz2r
     $+108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $+108d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $+72d0*stw2*p3p42*mdn2*mw2r*mz2r
     $+36d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-108d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $-384d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $+576d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+576d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $+768d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $-768d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p32*mw2r*mz2r
     $-960d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-192d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+384d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $-576d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-576d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $-768d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $+768d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p32*mw2r*mz2r
     $+960d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+192d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den3*den6*den7*(
     $-72d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $+72d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $-72d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $-180d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-108d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p3p42*mw2r*mz2r
     $+108d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $-36d0*stw2*p1p2*mw2r*mz2r*mmo4
     $+72d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $+72d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p32*mw2r*mz2r
     $+72d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*p1p42*mw2r*mz2r
     $-144d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+72d0*stw2*p3p4*p1p22*mw2r*mz2r
     $+108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $+108d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $+72d0*stw2*p3p42*mdn2*mw2r*mz2r
     $+36d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-108d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $+192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $-576d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $-192d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $-576d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $-768d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+192d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $+768d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $+576d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p2p3*p1p42*mw2r*mz2r
     $+960d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $+576d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $+192d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $+576d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $+768d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-192d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $-768d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $-576d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p2p3*p1p42*mw2r*mz2r
     $-960d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den3*den6*den8*(
     $-144d0*stw2*p1p2*p1p3*p1p4*mw2r*mz2r
     $+144d0*stw2*p1p2*p1p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $+72d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*p3p4*mdn2*mmo2*mw2r
     $+36d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+108d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+324d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p2*mdn2*mw2r*mmo4
     $+108d0*stw2*p1p2*mw2r*mz2r*mmo4
     $+144d0*stw2*p1p3*p1p4*p2p3*mw2r*mz2r
     $-144d0*stw2*p1p3*p1p4*mdn2*mmo2*mw2r
     $+288d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $-144d0*stw2*p1p3*p2p3*p3p4*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p3*mdn2*mmo2*mw2r
     $-216d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p3*p2p4*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $-36d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-288d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $-216d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p3*mdn2*mmo2*mw2r
     $-108d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-36d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+144d0*stw2*p1p4*p2p4*mdn2*mmo2*mw2r
     $+144d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p3*p2p4*mdn2*mmo2*mw2r
     $+72d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $+72d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $-72d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-144d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-108d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+288d0*stw2*p3p4*mmo2*mw2r*mdn4
     $-36d0*stw2*p3p4*mw2r*mz2r*mdn4
     $-72d0*stw2*p1p22*mmo2*mw2r*mz2r
     $-72d0*stw2*p1p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p1p42*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p32*mdn2*mmo2*mw2r
     $-72d0*stw2*p2p42*mdn2*mmo2*mw2r
     $-108d0*stw2*mdn2*mw2r*mz2r*mmo4
     $-252d0*stw2*mmo2*mw2r*mz2r*mdn4
     $+288d0*stw2*mw2r*mdn4*mmo4
     $+384d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $-576d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $-192d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-576d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p2*p3p42*mw2r*mz2r
     $-576d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw4*p1p2*mw2r*mz2r*mmo4
     $-576d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $-768d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $+768d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p4*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+960d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+192d0*stw4*p1p4*p2p3*p3p4*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+384d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $+192d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw4*p2p4*p1p32*mw2r*mz2r
     $+192d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+576d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw4*p3p4*mw2r*mz2r*mdn4
     $+192d0*stw4*p1p22*mmo2*mw2r*mz2r
     $+192d0*stw4*p3p42*mdn2*mw2r*mz2r
     $+384d0*stw4*mdn2*mw2r*mz2r*mmo4
     $+384d0*stw4*mmo2*mw2r*mz2r*mdn4
     $-384d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $+576d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $+192d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+576d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p2*p3p42*mw2r*mz2r
     $+576d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $+384d0*stw6*p1p2*mw2r*mz2r*mmo4
     $+576d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $+768d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $-768d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p4*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $-576d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-192d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-960d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+192d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-192d0*stw6*p1p4*p2p3*p3p4*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-384d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $-192d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+192d0*stw6*p2p4*p1p32*mw2r*mz2r
     $-192d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-576d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $-384d0*stw6*p3p4*mw2r*mz2r*mdn4
     $-192d0*stw6*p1p22*mmo2*mw2r*mz2r
     $-192d0*stw6*p3p42*mdn2*mw2r*mz2r
     $-384d0*stw6*mdn2*mw2r*mz2r*mmo4
     $-384d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den4*den7*den8*(
     $+48d0*stw2*p1p2*p1p3*p2p4*mw2r*mz2r
     $+48d0*stw2*p1p2*p1p4*p2p3*mw2r*mz2r
     $-48d0*stw2*p1p2*p1p4*p3p4*mw2r*mz2r
     $-48d0*stw2*p1p2*p1p4*mmo2*mw2r*mz2r
     $+48d0*stw2*p1p2*p2p3*p3p4*mw2r*mz2r
     $+48d0*stw2*p1p2*p2p3*mmo2*mw2r*mz2r
     $+96d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $+144d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $+48d0*stw2*p1p2*p3p42*mw2r*mz2r
     $+96d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $+96d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-48d0*stw2*p1p3*p1p4*p2p4*mw2r*mz2r
     $+48d0*stw2*p1p3*p2p3*p2p4*mw2r*mz2r
     $+48d0*stw2*p1p3*p2p4*p3p4*mw2r*mz2r
     $-96d0*stw2*p1p3*p2p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $-24d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $-48d0*stw2*p1p4*p2p3*p3p4*mw2r*mz2r
     $-96d0*stw2*p1p4*p2p3*mdn2*mw2r*mz2r
     $-48d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $-48d0*stw2*p1p4*p2p32*mw2r*mz2r
     $-24d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $+24d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p2p3*p1p42*mw2r*mz2r
     $+24d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+24d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $+24d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $-48d0*stw2*p3p4*p1p22*mw2r*mz2r
     $-48d0*stw2*p1p22*mmo2*mw2r*mz2r
     $-256d0*stw4*p1p2*p1p3*p2p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $-256d0*stw4*p1p2*p1p4*p2p3*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $-512d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $-768d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $-256d0*stw4*p1p2*p3p42*mw2r*mz2r
     $-512d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $-512d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+128d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+128d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $-128d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $+512d0*stw4*p1p3*p2p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+128d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $+512d0*stw4*p1p4*p2p3*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+128d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-128d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-128d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $+256d0*stw4*p3p4*p1p22*mw2r*mz2r
     $+256d0*stw4*p1p22*mmo2*mw2r*mz2r
     $+256d0*stw6*p1p2*p1p3*p2p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $+256d0*stw6*p1p2*p1p4*p2p3*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $+512d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $+768d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $+256d0*stw6*p1p2*p3p42*mw2r*mz2r
     $+512d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $+512d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-128d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-128d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $+128d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $-512d0*stw6*p1p3*p2p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-128d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $-512d0*stw6*p1p4*p2p3*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-128d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+128d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+128d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $-256d0*stw6*p3p4*p1p22*mw2r*mz2r
     $-256d0*stw6*p1p22*mmo2*mw2r*mz2r
     $)
     $+den2*den4*den72*(
     $+48d0*stw2*p1p2*p2p3*p2p4*mw2r*mz2r
     $+48d0*stw2*p1p2*p2p4*p3p4*mw2r*mz2r
     $+48d0*stw2*p1p2*p2p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-24d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*mw2r*mz2r*mmo4
     $+24d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+24d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $-48d0*stw2*p1p3*p2p42*mw2r*mz2r
     $-24d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+48d0*stw2*p1p4*p2p3*p2p4*mw2r*mz2r
     $+24d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+48d0*stw2*p1p4*p2p4*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $-24d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $-96d0*stw2*p2p3*p2p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $-48d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $-48d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+144d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+48d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+48d0*stw2*p3p42*mdn2*mw2r*mz2r
     $+96d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+48d0*stw2*mmo2*mw2r*mz2r*mdn4
     $-256d0*stw4*p1p2*p2p3*p2p4*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p3*p3p4*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p4*p3p4*mw2r*mz2r
     $-128d0*stw4*p1p2*p2p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*mw2r*mz2r*mmo4
     $-128d0*stw4*p1p3*p2p3*p2p4*mw2r*mz2r
     $-128d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $-256d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p3*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p3*p2p42*mw2r*mz2r
     $+128d0*stw4*p1p3*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p3*p2p4*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $-256d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p4*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p4*p2p32*mw2r*mz2r
     $+128d0*stw4*p1p4*mdn2*mmo2*mw2r*mz2r
     $+512d0*stw4*p2p3*p2p4*mdn2*mw2r*mz2r
     $-768d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-256d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-256d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-512d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-256d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+256d0*stw6*p1p2*p2p3*p2p4*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p3*p3p4*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p4*p3p4*mw2r*mz2r
     $+128d0*stw6*p1p2*p2p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*mw2r*mz2r*mmo4
     $+128d0*stw6*p1p3*p2p3*p2p4*mw2r*mz2r
     $+128d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $+256d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p3*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p3*p2p42*mw2r*mz2r
     $-128d0*stw6*p1p3*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p3*p2p4*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $+256d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p4*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p4*p2p32*mw2r*mz2r
     $-128d0*stw6*p1p4*mdn2*mmo2*mw2r*mz2r
     $-512d0*stw6*p2p3*p2p4*mdn2*mw2r*mz2r
     $+768d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+256d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+256d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+512d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+256d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den2*den4*den82*(
     $+48d0*stw2*p1p2*p1p3*p1p4*mw2r*mz2r
     $-48d0*stw2*p1p2*p1p3*p3p4*mw2r*mz2r
     $-48d0*stw2*p1p2*p1p3*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*p3p4*mdn2*mw2r*mz2r
     $-24d0*stw2*p1p2*p3p4*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*mdn2*mmo2*mw2r*mz2r
     $-24d0*stw2*p1p2*mw2r*mz2r*mmo4
     $-48d0*stw2*p1p3*p1p4*p2p3*mw2r*mz2r
     $-96d0*stw2*p1p3*p1p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p1p3*p2p3*p3p4*mw2r*mz2r
     $+72d0*stw2*p1p3*p2p3*mmo2*mw2r*mz2r
     $+24d0*stw2*p1p3*p2p4*mmo2*mw2r*mz2r
     $+48d0*stw2*p1p3*p3p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p1p3*mdn2*mmo2*mw2r*mz2r
     $+24d0*stw2*p1p4*p2p3*mmo2*mw2r*mz2r
     $+24d0*stw2*p1p4*p2p4*mmo2*mw2r*mz2r
     $-48d0*stw2*p1p4*p3p4*mdn2*mw2r*mz2r
     $-48d0*stw2*p1p4*mdn2*mmo2*mw2r*mz2r
     $+24d0*stw2*p2p3*p3p4*mdn2*mw2r*mz2r
     $+24d0*stw2*p2p3*mdn2*mmo2*mw2r*mz2r
     $+24d0*stw2*p2p4*p3p4*mdn2*mw2r*mz2r
     $+48d0*stw2*p2p4*p1p32*mw2r*mz2r
     $+24d0*stw2*p2p4*mdn2*mmo2*mw2r*mz2r
     $+144d0*stw2*p3p4*mdn2*mmo2*mw2r*mz2r
     $+48d0*stw2*p3p4*mw2r*mz2r*mdn4
     $+48d0*stw2*p3p42*mdn2*mw2r*mz2r
     $+96d0*stw2*mdn2*mw2r*mz2r*mmo4
     $+48d0*stw2*mmo2*mw2r*mz2r*mdn4
     $-256d0*stw4*p1p2*p1p3*p1p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p3*p3p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p3*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p4*p3p4*mw2r*mz2r
     $+128d0*stw4*p1p2*p1p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw4*p1p2*p3p4*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw4*p1p2*mw2r*mz2r*mmo4
     $+128d0*stw4*p1p3*p1p4*p2p3*mw2r*mz2r
     $+128d0*stw4*p1p3*p1p4*p2p4*mw2r*mz2r
     $+512d0*stw4*p1p3*p1p4*mdn2*mw2r*mz2r
     $-128d0*stw4*p1p3*p2p3*p3p4*mw2r*mz2r
     $-256d0*stw4*p1p3*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p3*p2p4*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p3*mmo2*mw2r*mz2r
     $-128d0*stw4*p1p4*p2p4*p3p4*mw2r*mz2r
     $-256d0*stw4*p1p4*p2p4*mmo2*mw2r*mz2r
     $-128d0*stw4*p2p3*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw4*p2p3*p1p42*mw2r*mz2r
     $-128d0*stw4*p2p3*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw4*p2p4*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw4*p2p4*p1p32*mw2r*mz2r
     $-128d0*stw4*p2p4*mdn2*mmo2*mw2r*mz2r
     $-768d0*stw4*p3p4*mdn2*mmo2*mw2r*mz2r
     $-256d0*stw4*p3p4*mw2r*mz2r*mdn4
     $-256d0*stw4*p3p42*mdn2*mw2r*mz2r
     $-512d0*stw4*mdn2*mw2r*mz2r*mmo4
     $-256d0*stw4*mmo2*mw2r*mz2r*mdn4
     $+256d0*stw6*p1p2*p1p3*p1p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p3*p3p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p3*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p4*p3p4*mw2r*mz2r
     $-128d0*stw6*p1p2*p1p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*p3p4*mdn2*mw2r*mz2r
     $-128d0*stw6*p1p2*p3p4*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*mdn2*mmo2*mw2r*mz2r
     $-128d0*stw6*p1p2*mw2r*mz2r*mmo4
     $-128d0*stw6*p1p3*p1p4*p2p3*mw2r*mz2r
     $-128d0*stw6*p1p3*p1p4*p2p4*mw2r*mz2r
     $-512d0*stw6*p1p3*p1p4*mdn2*mw2r*mz2r
     $+128d0*stw6*p1p3*p2p3*p3p4*mw2r*mz2r
     $+256d0*stw6*p1p3*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p3*p2p4*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p3*mmo2*mw2r*mz2r
     $+128d0*stw6*p1p4*p2p4*p3p4*mw2r*mz2r
     $+256d0*stw6*p1p4*p2p4*mmo2*mw2r*mz2r
     $+128d0*stw6*p2p3*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw6*p2p3*p1p42*mw2r*mz2r
     $+128d0*stw6*p2p3*mdn2*mmo2*mw2r*mz2r
     $+128d0*stw6*p2p4*p3p4*mdn2*mw2r*mz2r
     $+128d0*stw6*p2p4*p1p32*mw2r*mz2r
     $+128d0*stw6*p2p4*mdn2*mmo2*mw2r*mz2r
     $+768d0*stw6*p3p4*mdn2*mmo2*mw2r*mz2r
     $+256d0*stw6*p3p4*mw2r*mz2r*mdn4
     $+256d0*stw6*p3p42*mdn2*mw2r*mz2r
     $+512d0*stw6*mdn2*mw2r*mz2r*mmo4
     $+256d0*stw6*mmo2*mw2r*mz2r*mdn4
     $)
     $+den3*den4*den5*den7*(
     $+192d0*stw4*p1p2*p1p3*p2p4*mw4
     $-192d0*stw4*p1p2*p1p3*p3p4*mw4
     $-192d0*stw4*p1p2*p1p3*mmo2*mw4
     $+192d0*stw4*p1p2*p1p4*p2p3*mw4
     $-384d0*stw4*p1p2*p2p3*p2p4*mw4
     $-192d0*stw4*p1p2*p2p4*p3p4*mw4
     $-576d0*stw4*p1p2*p2p4*mmo2*mw4
     $+576d0*stw4*p1p2*p3p4*mdn2*mw4
     $+576d0*stw4*p1p2*p3p4*mmo2*mw4
     $+192d0*stw4*p1p2*p3p42*mw4
     $+576d0*stw4*p1p2*mdn2*mmo2*mw4
     $+384d0*stw4*p1p2*mmo4*mw4
     $-192d0*stw4*p1p3*p1p4*p2p3*mw4
     $-192d0*stw4*p1p3*p2p4*p3p4*mw4
     $-384d0*stw4*p1p3*p2p4*mdn2*mw4
     $-384d0*stw4*p1p3*p2p4*mmo2*mw4
     $+192d0*stw4*p1p3*p3p4*mdn2*mw4
     $-192d0*stw4*p1p3*p2p42*mw4
     $+192d0*stw4*p1p3*mdn2*mmo2*mw4
     $-576d0*stw4*p1p4*p2p3*p2p4*mw4
     $-192d0*stw4*p1p4*p2p3*p3p4*mw4
     $-384d0*stw4*p1p4*p2p3*mdn2*mw4
     $-384d0*stw4*p1p4*p2p3*mmo2*mw4
     $-384d0*stw4*p1p4*p2p4*p3p4*mw4
     $-768d0*stw4*p1p4*p2p4*mmo2*mw4
     $+768d0*stw4*p2p3*p2p4*mdn2*mw4
     $+576d0*stw4*p2p4*p3p4*mdn2*mw4
     $+192d0*stw4*p2p4*p1p32*mw4
     $+960d0*stw4*p2p4*mdn2*mmo2*mw4
     $-192d0*stw4*p3p4*p1p22*mw4
     $-576d0*stw4*p3p4*mdn2*mmo2*mw4
     $-384d0*stw4*p3p4*mdn4*mw4
     $-192d0*stw4*p1p22*mmo2*mw4
     $-192d0*stw4*p3p42*mdn2*mw4
     $-384d0*stw4*mdn2*mmo4*mw4
     $-384d0*stw4*mmo2*mdn4*mw4
     $)
     $+den3*den4*den5*den8*(
     $+384d0*stw4*p1p2*p1p3*p1p4*mw4
     $-192d0*stw4*p1p2*p1p3*p2p4*mw4
     $-192d0*stw4*p1p2*p1p4*p2p3*mw4
     $-192d0*stw4*p1p2*p1p4*p3p4*mw4
     $-576d0*stw4*p1p2*p1p4*mmo2*mw4
     $-192d0*stw4*p1p2*p2p3*p3p4*mw4
     $-192d0*stw4*p1p2*p2p3*mmo2*mw4
     $-576d0*stw4*p1p2*p3p4*mdn2*mw4
     $-576d0*stw4*p1p2*p3p4*mmo2*mw4
     $-192d0*stw4*p1p2*p3p42*mw4
     $-576d0*stw4*p1p2*mdn2*mmo2*mw4
     $-384d0*stw4*p1p2*mmo4*mw4
     $-576d0*stw4*p1p3*p1p4*p2p4*mw4
     $-768d0*stw4*p1p3*p1p4*mdn2*mw4
     $-192d0*stw4*p1p3*p2p3*p2p4*mw4
     $+192d0*stw4*p1p3*p2p4*p3p4*mw4
     $+384d0*stw4*p1p3*p2p4*mdn2*mw4
     $+384d0*stw4*p1p3*p2p4*mmo2*mw4
     $+192d0*stw4*p1p4*p2p3*p3p4*mw4
     $+384d0*stw4*p1p4*p2p3*mdn2*mw4
     $+384d0*stw4*p1p4*p2p3*mmo2*mw4
     $+384d0*stw4*p1p4*p2p4*p3p4*mw4
     $+768d0*stw4*p1p4*p2p4*mmo2*mw4
     $+576d0*stw4*p1p4*p3p4*mdn2*mw4
     $+192d0*stw4*p1p4*p2p32*mw4
     $+960d0*stw4*p1p4*mdn2*mmo2*mw4
     $+192d0*stw4*p2p3*p3p4*mdn2*mw4
     $-192d0*stw4*p2p3*p1p42*mw4
     $+192d0*stw4*p2p3*mdn2*mmo2*mw4
     $+192d0*stw4*p3p4*p1p22*mw4
     $+576d0*stw4*p3p4*mdn2*mmo2*mw4
     $+384d0*stw4*p3p4*mdn4*mw4
     $+192d0*stw4*p1p22*mmo2*mw4
     $+192d0*stw4*p3p42*mdn2*mw4
     $+384d0*stw4*mdn2*mmo4*mw4
     $+384d0*stw4*mmo2*mdn4*mw4
     $)
     $+den3*den4*den6*den7*(
     $-192d0*stw4*p1p2*p1p3*p2p4*mw4
     $-192d0*stw4*p1p2*p1p4*p2p3*mw4
     $+192d0*stw4*p1p2*p1p4*p3p4*mw4
     $+192d0*stw4*p1p2*p1p4*mmo2*mw4
     $+384d0*stw4*p1p2*p2p3*p2p4*mw4
     $+192d0*stw4*p1p2*p2p3*p3p4*mw4
     $+576d0*stw4*p1p2*p2p3*mmo2*mw4
     $-576d0*stw4*p1p2*p3p4*mdn2*mw4
     $-576d0*stw4*p1p2*p3p4*mmo2*mw4
     $-192d0*stw4*p1p2*p3p42*mw4
     $-576d0*stw4*p1p2*mdn2*mmo2*mw4
     $-384d0*stw4*p1p2*mmo4*mw4
     $+192d0*stw4*p1p3*p1p4*p2p4*mw4
     $+576d0*stw4*p1p3*p2p3*p2p4*mw4
     $+384d0*stw4*p1p3*p2p3*p3p4*mw4
     $+768d0*stw4*p1p3*p2p3*mmo2*mw4
     $+192d0*stw4*p1p3*p2p4*p3p4*mw4
     $+384d0*stw4*p1p3*p2p4*mdn2*mw4
     $+384d0*stw4*p1p3*p2p4*mmo2*mw4
     $+192d0*stw4*p1p4*p2p3*p3p4*mw4
     $+384d0*stw4*p1p4*p2p3*mdn2*mw4
     $+384d0*stw4*p1p4*p2p3*mmo2*mw4
     $-192d0*stw4*p1p4*p3p4*mdn2*mw4
     $+192d0*stw4*p1p4*p2p32*mw4
     $-192d0*stw4*p1p4*mdn2*mmo2*mw4
     $-768d0*stw4*p2p3*p2p4*mdn2*mw4
     $-576d0*stw4*p2p3*p3p4*mdn2*mw4
     $-192d0*stw4*p2p3*p1p42*mw4
     $-960d0*stw4*p2p3*mdn2*mmo2*mw4
     $+192d0*stw4*p3p4*p1p22*mw4
     $+576d0*stw4*p3p4*mdn2*mmo2*mw4
     $+384d0*stw4*p3p4*mdn4*mw4
     $+192d0*stw4*p1p22*mmo2*mw4
     $+192d0*stw4*p3p42*mdn2*mw4
     $+384d0*stw4*mdn2*mmo4*mw4
     $+384d0*stw4*mmo2*mdn4*mw4
     $)
     $+den3*den4*den6*den8*(
     $-384d0*stw4*p1p2*p1p3*p1p4*mw4
     $+192d0*stw4*p1p2*p1p3*p2p4*mw4
     $+192d0*stw4*p1p2*p1p3*p3p4*mw4
     $+576d0*stw4*p1p2*p1p3*mmo2*mw4
     $+192d0*stw4*p1p2*p1p4*p2p3*mw4
     $+192d0*stw4*p1p2*p2p4*p3p4*mw4
     $+192d0*stw4*p1p2*p2p4*mmo2*mw4
     $+576d0*stw4*p1p2*p3p4*mdn2*mw4
     $+576d0*stw4*p1p2*p3p4*mmo2*mw4
     $+192d0*stw4*p1p2*p3p42*mw4
     $+576d0*stw4*p1p2*mdn2*mmo2*mw4
     $+384d0*stw4*p1p2*mmo4*mw4
     $+576d0*stw4*p1p3*p1p4*p2p3*mw4
     $+768d0*stw4*p1p3*p1p4*mdn2*mw4
     $-384d0*stw4*p1p3*p2p3*p3p4*mw4
     $-768d0*stw4*p1p3*p2p3*mmo2*mw4
     $-192d0*stw4*p1p3*p2p4*p3p4*mw4
     $-384d0*stw4*p1p3*p2p4*mdn2*mw4
     $-384d0*stw4*p1p3*p2p4*mmo2*mw4
     $-576d0*stw4*p1p3*p3p4*mdn2*mw4
     $-192d0*stw4*p1p3*p2p42*mw4
     $-960d0*stw4*p1p3*mdn2*mmo2*mw4
     $+192d0*stw4*p1p4*p2p3*p2p4*mw4
     $-192d0*stw4*p1p4*p2p3*p3p4*mw4
     $-384d0*stw4*p1p4*p2p3*mdn2*mw4
     $-384d0*stw4*p1p4*p2p3*mmo2*mw4
     $-192d0*stw4*p2p4*p3p4*mdn2*mw4
     $+192d0*stw4*p2p4*p1p32*mw4
     $-192d0*stw4*p2p4*mdn2*mmo2*mw4
     $-192d0*stw4*p3p4*p1p22*mw4
     $-576d0*stw4*p3p4*mdn2*mmo2*mw4
     $-384d0*stw4*p3p4*mdn4*mw4
     $-192d0*stw4*p1p22*mmo2*mw4
     $-192d0*stw4*p3p42*mdn2*mw4
     $-384d0*stw4*mdn2*mmo4*mw4
     $-384d0*stw4*mmo2*mdn4*mw4
     $)
     $+den5*den6*den12*(
     $+864d0*stw2*p1p2*p1p3*p2p4*mz4
     $-324d0*stw2*p1p2*p1p3*mmo2*mz4
     $-864d0*stw2*p1p2*p1p4*p2p3*mz4
     $+864d0*stw2*p1p2*p1p4*p3p4*mz4
     $-324d0*stw2*p1p2*p1p4*mmo2*mz4
     $-864d0*stw2*p1p2*p2p3*p3p4*mz4
     $+324d0*stw2*p1p2*p2p3*mmo2*mz4
     $+324d0*stw2*p1p2*p2p4*mmo2*mz4
     $-1296d0*stw2*p1p2*p3p4*mdn2*mz4
     $-1512d0*stw2*p1p2*p3p4*mmo2*mz4
     $-864d0*stw2*p1p2*p3p42*mz4
     $+648d0*stw2*p1p2*mdn2*mmo2*mz4
     $+864d0*stw2*p1p3*p1p4*p2p4*mz4
     $-864d0*stw2*p1p3*p2p3*p2p4*mz4
     $-216d0*stw2*p1p3*p2p3*mmo2*mz4
     $+864d0*stw2*p1p3*p2p4*p3p4*mz4
     $-864d0*stw2*p1p3*p2p4*mdn2*mz4
     $+1512d0*stw2*p1p3*p2p4*mmo2*mz4
     $+648d0*stw2*p1p3*p3p4*mdn2*mz4
     $+540d0*stw2*p1p3*mdn2*mmo2*mz4
     $+864d0*stw2*p1p4*p2p3*p3p4*mz4
     $+864d0*stw2*p1p4*p2p3*mdn2*mz4
     $+1512d0*stw2*p1p4*p2p3*mmo2*mz4
     $-216d0*stw2*p1p4*p2p4*mmo2*mz4
     $-216d0*stw2*p1p4*p3p4*mdn2*mz4
     $+864d0*stw2*p1p4*p2p32*mz4
     $+540d0*stw2*p1p4*mdn2*mmo2*mz4
     $+216d0*stw2*p2p3*p3p4*mdn2*mz4
     $-864d0*stw2*p2p3*p1p42*mz4
     $-540d0*stw2*p2p3*mdn2*mmo2*mz4
     $-648d0*stw2*p2p4*p3p4*mdn2*mz4
     $-540d0*stw2*p2p4*mdn2*mmo2*mz4
     $+864d0*stw2*p3p4*p1p22*mz4
     $+216d0*stw2*p3p4*mdn2*mmo2*mz4
     $+432d0*stw2*p3p4*mdn4*mz4
     $+216d0*stw2*p3p42*mdn2*mz4
     $+216d0*stw2*mdn2*mmo4*mz4
     $-648d0*stw2*mmo2*mdn4*mz4
     $-864d0*stw4*p1p2*p1p3*p2p4*mz4
     $-720d0*stw4*p1p2*p1p3*p3p4*mz4
     $+1080d0*stw4*p1p2*p1p3*mmo2*mz4
     $+864d0*stw4*p1p2*p1p4*p2p3*mz4
     $-1584d0*stw4*p1p2*p1p4*p3p4*mz4
     $+1080d0*stw4*p1p2*p1p4*mmo2*mz4
     $+1584d0*stw4*p1p2*p2p3*p3p4*mz4
     $-1080d0*stw4*p1p2*p2p3*mmo2*mz4
     $+720d0*stw4*p1p2*p2p4*p3p4*mz4
     $-1080d0*stw4*p1p2*p2p4*mmo2*mz4
     $+4320d0*stw4*p1p2*p3p4*mdn2*mz4
     $+4464d0*stw4*p1p2*p3p4*mmo2*mz4
     $+2304d0*stw4*p1p2*p3p42*mz4
     $-1296d0*stw4*p1p2*mdn2*mmo2*mz4
     $-720d0*stw4*p1p3*p1p4*p2p3*mz4
     $-1584d0*stw4*p1p3*p1p4*p2p4*mz4
     $+1584d0*stw4*p1p3*p2p3*p2p4*mz4
     $+144d0*stw4*p1p3*p2p3*mmo2*mz4
     $-2304d0*stw4*p1p3*p2p4*p3p4*mz4
     $+864d0*stw4*p1p3*p2p4*mdn2*mz4
     $-4464d0*stw4*p1p3*p2p4*mmo2*mz4
     $-576d0*stw4*p1p3*p3p4*mdn2*mz4
     $-720d0*stw4*p1p3*p2p42*mz4
     $-1656d0*stw4*p1p3*mdn2*mmo2*mz4
     $+720d0*stw4*p1p4*p2p3*p2p4*mz4
     $-2304d0*stw4*p1p4*p2p3*p3p4*mz4
     $-864d0*stw4*p1p4*p2p3*mdn2*mz4
     $-4464d0*stw4*p1p4*p2p3*mmo2*mz4
     $+144d0*stw4*p1p4*p2p4*mmo2*mz4
     $+288d0*stw4*p1p4*p3p4*mdn2*mz4
     $-1584d0*stw4*p1p4*p2p32*mz4
     $-1656d0*stw4*p1p4*mdn2*mmo2*mz4
     $-288d0*stw4*p2p3*p3p4*mdn2*mz4
     $+1584d0*stw4*p2p3*p1p42*mz4
     $+1656d0*stw4*p2p3*mdn2*mmo2*mz4
     $+576d0*stw4*p2p4*p3p4*mdn2*mz4
     $+720d0*stw4*p2p4*p1p32*mz4
     $+1656d0*stw4*p2p4*mdn2*mmo2*mz4
     $-2304d0*stw4*p3p4*p1p22*mz4
     $-1872d0*stw4*p3p4*mdn2*mmo2*mz4
     $-2016d0*stw4*p3p4*mdn4*mz4
     $-1008d0*stw4*p3p42*mdn2*mz4
     $-144d0*stw4*mdn2*mmo4*mz4
     $+1296d0*stw4*mmo2*mdn4*mz4
     $+1152d0*stw6*p1p2*p1p3*p3p4*mz4
     $-1152d0*stw6*p1p2*p1p3*mmo2*mz4
     $+1152d0*stw6*p1p2*p1p4*p3p4*mz4
     $-1152d0*stw6*p1p2*p1p4*mmo2*mz4
     $-1152d0*stw6*p1p2*p2p3*p3p4*mz4
     $+1152d0*stw6*p1p2*p2p3*mmo2*mz4
     $-1152d0*stw6*p1p2*p2p4*p3p4*mz4
     $+1152d0*stw6*p1p2*p2p4*mmo2*mz4
     $-6912d0*stw6*p1p2*p3p4*mdn2*mz4
     $-4608d0*stw6*p1p2*p3p4*mmo2*mz4
     $-2304d0*stw6*p1p2*p3p42*mz4
     $+1152d0*stw6*p1p3*p1p4*p2p3*mz4
     $+1152d0*stw6*p1p3*p1p4*p2p4*mz4
     $-1152d0*stw6*p1p3*p2p3*p2p4*mz4
     $+2304d0*stw6*p1p3*p2p4*p3p4*mz4
     $+4608d0*stw6*p1p3*p2p4*mmo2*mz4
     $-1152d0*stw6*p1p3*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p3*p2p42*mz4
     $+1152d0*stw6*p1p3*mdn2*mmo2*mz4
     $-1152d0*stw6*p1p4*p2p3*p2p4*mz4
     $+2304d0*stw6*p1p4*p2p3*p3p4*mz4
     $+4608d0*stw6*p1p4*p2p3*mmo2*mz4
     $-1152d0*stw6*p1p4*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p4*p2p32*mz4
     $+1152d0*stw6*p1p4*mdn2*mmo2*mz4
     $+1152d0*stw6*p2p3*p3p4*mdn2*mz4
     $-1152d0*stw6*p2p3*p1p42*mz4
     $-1152d0*stw6*p2p3*mdn2*mmo2*mz4
     $+1152d0*stw6*p2p4*p3p4*mdn2*mz4
     $-1152d0*stw6*p2p4*p1p32*mz4
     $-1152d0*stw6*p2p4*mdn2*mmo2*mz4
     $+2304d0*stw6*p3p4*p1p22*mz4
     $+4608d0*stw6*p3p4*mdn2*mmo2*mz4
     $+4608d0*stw6*p3p4*mdn4*mz4
     $+2304d0*stw6*p3p42*mdn2*mz4
     $-576d0*stw8*p1p2*p1p3*p3p4*mz4
     $+576d0*stw8*p1p2*p1p3*mmo2*mz4
     $-576d0*stw8*p1p2*p1p4*p3p4*mz4
     $+576d0*stw8*p1p2*p1p4*mmo2*mz4
     $+576d0*stw8*p1p2*p2p3*p3p4*mz4
     $-576d0*stw8*p1p2*p2p3*mmo2*mz4
     $+576d0*stw8*p1p2*p2p4*p3p4*mz4
     $-576d0*stw8*p1p2*p2p4*mmo2*mz4
     $+3456d0*stw8*p1p2*p3p4*mdn2*mz4
     $+2304d0*stw8*p1p2*p3p4*mmo2*mz4
     $+1152d0*stw8*p1p2*p3p42*mz4
     $-576d0*stw8*p1p3*p1p4*p2p3*mz4
     $-576d0*stw8*p1p3*p1p4*p2p4*mz4
     $+576d0*stw8*p1p3*p2p3*p2p4*mz4
     $-1152d0*stw8*p1p3*p2p4*p3p4*mz4
     $-2304d0*stw8*p1p3*p2p4*mmo2*mz4
     $+576d0*stw8*p1p3*p3p4*mdn2*mz4
     $-576d0*stw8*p1p3*p2p42*mz4
     $-576d0*stw8*p1p3*mdn2*mmo2*mz4
     $+576d0*stw8*p1p4*p2p3*p2p4*mz4
     $-1152d0*stw8*p1p4*p2p3*p3p4*mz4
     $-2304d0*stw8*p1p4*p2p3*mmo2*mz4
     $+576d0*stw8*p1p4*p3p4*mdn2*mz4
     $-576d0*stw8*p1p4*p2p32*mz4
     $-576d0*stw8*p1p4*mdn2*mmo2*mz4
     $-576d0*stw8*p2p3*p3p4*mdn2*mz4
     $+576d0*stw8*p2p3*p1p42*mz4
     $+576d0*stw8*p2p3*mdn2*mmo2*mz4
     $-576d0*stw8*p2p4*p3p4*mdn2*mz4
     $+576d0*stw8*p2p4*p1p32*mz4
     $+576d0*stw8*p2p4*mdn2*mmo2*mz4
     $-1152d0*stw8*p3p4*p1p22*mz4
     $-2304d0*stw8*p3p4*mdn2*mmo2*mz4
     $-2304d0*stw8*p3p4*mdn4*mz4
     $-1152d0*stw8*p3p42*mdn2*mz4
     $+324d0*p1p2*p1p3*p1p4*mdn2*mmo2
     $-324d0*p1p2*p1p3*p2p4*mdn2*mmo2
     $-162d0*p1p2*p1p3*p2p4*mz4
     $-81d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-324d0*p1p2*p1p4*p2p3*mdn2*mmo2
     $+162d0*p1p2*p1p4*p2p3*mz4
     $-162d0*p1p2*p1p4*p3p4*mz4
     $-81d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+324d0*p1p2*p2p3*p2p4*mdn2*mmo2
     $+162d0*p1p2*p2p3*p3p4*mz4
     $+81d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $+81d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+162d0*p1p2*p3p4*mdn2*mz4
     $+162d0*p1p2*p3p4*mmo2*mz4
     $+162d0*p1p2*p3p42*mz4
     $+324d0*p1p2*mdn2*mz2r*mmo4
     $-648d0*p1p2*mdn4*mmo4
     $-162d0*p1p3*p1p4*p2p4*mz4
     $-324d0*p1p3*p1p4*mmo2*mdn4
     $+162d0*p1p3*p2p3*p2p4*mz4
     $-162d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+162d0*p1p3*p2p3*mmo2*mz4
     $-162d0*p1p3*p2p4*p3p4*mz4
     $+162d0*p1p3*p2p4*mdn2*mz4
     $+324d0*p1p3*p2p4*mmo2*mdn4
     $-162d0*p1p3*p2p4*mmo2*mz4
     $-162d0*p1p3*p3p4*mdn2*mz4
     $+81d0*p1p3*mmo2*mz2r*mdn4
     $-162d0*p1p4*p2p3*p3p4*mz4
     $-162d0*p1p4*p2p3*mdn2*mz4
     $+324d0*p1p4*p2p3*mmo2*mdn4
     $-162d0*p1p4*p2p3*mmo2*mz4
     $-162d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $+162d0*p1p4*p2p4*mmo2*mz4
     $-162d0*p1p4*p2p32*mz4
     $+81d0*p1p4*mmo2*mz2r*mdn4
     $-324d0*p2p3*p2p4*mmo2*mdn4
     $+162d0*p2p3*p1p42*mz4
     $-81d0*p2p3*mmo2*mz2r*mdn4
     $+162d0*p2p4*p3p4*mdn2*mz4
     $-81d0*p2p4*mmo2*mz2r*mdn4
     $-162d0*p3p4*p1p22*mz4
     $+324d0*p1p22*mdn2*mmo4
     $+81d0*p1p32*mdn2*mmo2*mz2r
     $+81d0*p1p42*mdn2*mmo2*mz2r
     $+81d0*p2p32*mdn2*mmo2*mz2r
     $+81d0*p2p42*mdn2*mmo2*mz2r
     $+324d0*mdn2*mdn4*mmo4
     $-324d0*mz2r*mdn4*mmo4
     $)
     $+den5*den6*den32*(
     $-576d0*stw4*p1p2*p1p3*p3p4*mw4
     $+576d0*stw4*p1p2*p1p3*mmo2*mw4
     $-576d0*stw4*p1p2*p1p4*p3p4*mw4
     $+576d0*stw4*p1p2*p1p4*mmo2*mw4
     $+576d0*stw4*p1p2*p2p3*p3p4*mw4
     $-576d0*stw4*p1p2*p2p3*mmo2*mw4
     $+576d0*stw4*p1p2*p2p4*p3p4*mw4
     $-576d0*stw4*p1p2*p2p4*mmo2*mw4
     $+3456d0*stw4*p1p2*p3p4*mdn2*mw4
     $+2304d0*stw4*p1p2*p3p4*mmo2*mw4
     $+1152d0*stw4*p1p2*p3p42*mw4
     $-576d0*stw4*p1p3*p1p4*p2p3*mw4
     $-576d0*stw4*p1p3*p1p4*p2p4*mw4
     $+576d0*stw4*p1p3*p2p3*p2p4*mw4
     $-1152d0*stw4*p1p3*p2p4*p3p4*mw4
     $-2304d0*stw4*p1p3*p2p4*mmo2*mw4
     $+576d0*stw4*p1p3*p3p4*mdn2*mw4
     $-576d0*stw4*p1p3*p2p42*mw4
     $-576d0*stw4*p1p3*mdn2*mmo2*mw4
     $+576d0*stw4*p1p4*p2p3*p2p4*mw4
     $-1152d0*stw4*p1p4*p2p3*p3p4*mw4
     $-2304d0*stw4*p1p4*p2p3*mmo2*mw4
     $+576d0*stw4*p1p4*p3p4*mdn2*mw4
     $-576d0*stw4*p1p4*p2p32*mw4
     $-576d0*stw4*p1p4*mdn2*mmo2*mw4
     $-576d0*stw4*p2p3*p3p4*mdn2*mw4
     $+576d0*stw4*p2p3*p1p42*mw4
     $+576d0*stw4*p2p3*mdn2*mmo2*mw4
     $-576d0*stw4*p2p4*p3p4*mdn2*mw4
     $+576d0*stw4*p2p4*p1p32*mw4
     $+576d0*stw4*p2p4*mdn2*mmo2*mw4
     $-1152d0*stw4*p3p4*p1p22*mw4
     $-2304d0*stw4*p3p4*mdn2*mmo2*mw4
     $-2304d0*stw4*p3p4*mdn4*mw4
     $-1152d0*stw4*p3p42*mdn2*mw4
     $)
     $+den7*den8*den22*(
     $-96d0*stw2*p1p2*p1p3*p2p4*mz4
     $-24d0*stw2*p1p2*p1p3*mmo2*mz4
     $-96d0*stw2*p1p2*p1p4*p2p3*mz4
     $+96d0*stw2*p1p2*p1p4*p3p4*mz4
     $+72d0*stw2*p1p2*p1p4*mmo2*mz4
     $-96d0*stw2*p1p2*p2p3*p3p4*mz4
     $-72d0*stw2*p1p2*p2p3*mmo2*mz4
     $+24d0*stw2*p1p2*p2p4*mmo2*mz4
     $-120d0*stw2*p1p2*p3p4*mdn2*mz4
     $-240d0*stw2*p1p2*p3p4*mmo2*mz4
     $-96d0*stw2*p1p2*p3p42*mz4
     $-72d0*stw2*p1p2*mdn2*mmo2*mz4
     $-144d0*stw2*p1p2*mmo4*mz4
     $+96d0*stw2*p1p3*p1p4*p2p4*mz4
     $+72d0*stw2*p1p3*p1p4*mdn2*mz4
     $-96d0*stw2*p1p3*p2p3*p2p4*mz4
     $-96d0*stw2*p1p3*p2p4*p3p4*mz4
     $+120d0*stw2*p1p3*p2p4*mdn2*mz4
     $-96d0*stw2*p1p3*p2p4*mmo2*mz4
     $+12d0*stw2*p1p3*p3p4*mdn2*mz4
     $-12d0*stw2*p1p3*mdn2*mmo2*mz4
     $+96d0*stw2*p1p4*p2p3*p3p4*mz4
     $+120d0*stw2*p1p4*p2p3*mdn2*mz4
     $+96d0*stw2*p1p4*p2p3*mmo2*mz4
     $+12d0*stw2*p1p4*p3p4*mdn2*mz4
     $+96d0*stw2*p1p4*p2p32*mz4
     $-12d0*stw2*p1p4*mdn2*mmo2*mz4
     $+72d0*stw2*p2p3*p2p4*mdn2*mz4
     $-12d0*stw2*p2p3*p3p4*mdn2*mz4
     $-96d0*stw2*p2p3*p1p42*mz4
     $+12d0*stw2*p2p3*mdn2*mmo2*mz4
     $-12d0*stw2*p2p4*p3p4*mdn2*mz4
     $+12d0*stw2*p2p4*mdn2*mmo2*mz4
     $+96d0*stw2*p3p4*p1p22*mz4
     $-24d0*stw2*p3p4*mdn2*mmo2*mz4
     $+72d0*stw2*p1p22*mmo2*mz4
     $-24d0*stw2*mdn2*mmo4*mz4
     $+72d0*stw2*mmo2*mdn4*mz4
     $+256d0*stw4*p1p2*p1p3*p2p4*mz4
     $-80d0*stw4*p1p2*p1p3*p3p4*mz4
     $-64d0*stw4*p1p2*p1p3*mmo2*mz4
     $+256d0*stw4*p1p2*p1p4*p2p3*mz4
     $-176d0*stw4*p1p2*p1p4*p3p4*mz4
     $-160d0*stw4*p1p2*p1p4*mmo2*mz4
     $+176d0*stw4*p1p2*p2p3*p3p4*mz4
     $+160d0*stw4*p1p2*p2p3*mmo2*mz4
     $+80d0*stw4*p1p2*p2p4*p3p4*mz4
     $+64d0*stw4*p1p2*p2p4*mmo2*mz4
     $+368d0*stw4*p1p2*p3p4*mdn2*mz4
     $+736d0*stw4*p1p2*p3p4*mmo2*mz4
     $+256d0*stw4*p1p2*p3p42*mz4
     $+336d0*stw4*p1p2*mdn2*mmo2*mz4
     $+480d0*stw4*p1p2*mmo4*mz4
     $-80d0*stw4*p1p3*p1p4*p2p3*mz4
     $-176d0*stw4*p1p3*p1p4*p2p4*mz4
     $-144d0*stw4*p1p3*p1p4*mdn2*mz4
     $+176d0*stw4*p1p3*p2p3*p2p4*mz4
     $+96d0*stw4*p1p3*p2p4*p3p4*mz4
     $-368d0*stw4*p1p3*p2p4*mdn2*mz4
     $+96d0*stw4*p1p3*p2p4*mmo2*mz4
     $-56d0*stw4*p1p3*p3p4*mdn2*mz4
     $-80d0*stw4*p1p3*p2p42*mz4
     $+8d0*stw4*p1p3*mdn2*mmo2*mz4
     $+80d0*stw4*p1p4*p2p3*p2p4*mz4
     $-96d0*stw4*p1p4*p2p3*p3p4*mz4
     $-368d0*stw4*p1p4*p2p3*mdn2*mz4
     $-96d0*stw4*p1p4*p2p3*mmo2*mz4
     $-56d0*stw4*p1p4*p3p4*mdn2*mz4
     $-176d0*stw4*p1p4*p2p32*mz4
     $+8d0*stw4*p1p4*mdn2*mmo2*mz4
     $-144d0*stw4*p2p3*p2p4*mdn2*mz4
     $+56d0*stw4*p2p3*p3p4*mdn2*mz4
     $+176d0*stw4*p2p3*p1p42*mz4
     $-8d0*stw4*p2p3*mdn2*mmo2*mz4
     $+56d0*stw4*p2p4*p3p4*mdn2*mz4
     $+80d0*stw4*p2p4*p1p32*mz4
     $-8d0*stw4*p2p4*mdn2*mmo2*mz4
     $-256d0*stw4*p3p4*p1p22*mz4
     $+16d0*stw4*p3p4*mdn2*mmo2*mz4
     $-240d0*stw4*p1p22*mmo2*mz4
     $+16d0*stw4*mdn2*mmo4*mz4
     $-144d0*stw4*mmo2*mdn4*mz4
     $-256d0*stw6*p1p2*p1p3*p2p4*mz4
     $+128d0*stw6*p1p2*p1p3*p3p4*mz4
     $+128d0*stw6*p1p2*p1p3*mmo2*mz4
     $-256d0*stw6*p1p2*p1p4*p2p3*mz4
     $+128d0*stw6*p1p2*p1p4*p3p4*mz4
     $+128d0*stw6*p1p2*p1p4*mmo2*mz4
     $-128d0*stw6*p1p2*p2p3*p3p4*mz4
     $-128d0*stw6*p1p2*p2p3*mmo2*mz4
     $-128d0*stw6*p1p2*p2p4*p3p4*mz4
     $-128d0*stw6*p1p2*p2p4*mmo2*mz4
     $-512d0*stw6*p1p2*p3p4*mdn2*mz4
     $-768d0*stw6*p1p2*p3p4*mmo2*mz4
     $-256d0*stw6*p1p2*p3p42*mz4
     $-512d0*stw6*p1p2*mdn2*mmo2*mz4
     $-512d0*stw6*p1p2*mmo4*mz4
     $+128d0*stw6*p1p3*p1p4*p2p3*mz4
     $+128d0*stw6*p1p3*p1p4*p2p4*mz4
     $-128d0*stw6*p1p3*p2p3*p2p4*mz4
     $+512d0*stw6*p1p3*p2p4*mdn2*mz4
     $+128d0*stw6*p1p3*p3p4*mdn2*mz4
     $+128d0*stw6*p1p3*p2p42*mz4
     $+128d0*stw6*p1p3*mdn2*mmo2*mz4
     $-128d0*stw6*p1p4*p2p3*p2p4*mz4
     $+512d0*stw6*p1p4*p2p3*mdn2*mz4
     $+128d0*stw6*p1p4*p3p4*mdn2*mz4
     $+128d0*stw6*p1p4*p2p32*mz4
     $+128d0*stw6*p1p4*mdn2*mmo2*mz4
     $-128d0*stw6*p2p3*p3p4*mdn2*mz4
     $-128d0*stw6*p2p3*p1p42*mz4
     $-128d0*stw6*p2p3*mdn2*mmo2*mz4
     $-128d0*stw6*p2p4*p3p4*mdn2*mz4
     $-128d0*stw6*p2p4*p1p32*mz4
     $-128d0*stw6*p2p4*mdn2*mmo2*mz4
     $+256d0*stw6*p3p4*p1p22*mz4
     $+256d0*stw6*p1p22*mmo2*mz4
     $+128d0*stw8*p1p2*p1p3*p2p4*mz4
     $-64d0*stw8*p1p2*p1p3*p3p4*mz4
     $-64d0*stw8*p1p2*p1p3*mmo2*mz4
     $+128d0*stw8*p1p2*p1p4*p2p3*mz4
     $-64d0*stw8*p1p2*p1p4*p3p4*mz4
     $-64d0*stw8*p1p2*p1p4*mmo2*mz4
     $+64d0*stw8*p1p2*p2p3*p3p4*mz4
     $+64d0*stw8*p1p2*p2p3*mmo2*mz4
     $+64d0*stw8*p1p2*p2p4*p3p4*mz4
     $+64d0*stw8*p1p2*p2p4*mmo2*mz4
     $+256d0*stw8*p1p2*p3p4*mdn2*mz4
     $+384d0*stw8*p1p2*p3p4*mmo2*mz4
     $+128d0*stw8*p1p2*p3p42*mz4
     $+256d0*stw8*p1p2*mdn2*mmo2*mz4
     $+256d0*stw8*p1p2*mmo4*mz4
     $-64d0*stw8*p1p3*p1p4*p2p3*mz4
     $-64d0*stw8*p1p3*p1p4*p2p4*mz4
     $+64d0*stw8*p1p3*p2p3*p2p4*mz4
     $-256d0*stw8*p1p3*p2p4*mdn2*mz4
     $-64d0*stw8*p1p3*p3p4*mdn2*mz4
     $-64d0*stw8*p1p3*p2p42*mz4
     $-64d0*stw8*p1p3*mdn2*mmo2*mz4
     $+64d0*stw8*p1p4*p2p3*p2p4*mz4
     $-256d0*stw8*p1p4*p2p3*mdn2*mz4
     $-64d0*stw8*p1p4*p3p4*mdn2*mz4
     $-64d0*stw8*p1p4*p2p32*mz4
     $-64d0*stw8*p1p4*mdn2*mmo2*mz4
     $+64d0*stw8*p2p3*p3p4*mdn2*mz4
     $+64d0*stw8*p2p3*p1p42*mz4
     $+64d0*stw8*p2p3*mdn2*mmo2*mz4
     $+64d0*stw8*p2p4*p3p4*mdn2*mz4
     $+64d0*stw8*p2p4*p1p32*mz4
     $+64d0*stw8*p2p4*mdn2*mmo2*mz4
     $-128d0*stw8*p3p4*p1p22*mz4
     $-128d0*stw8*p1p22*mmo2*mz4
     $+18d0*p1p2*p1p3*p2p4*mz4
     $+18d0*p1p2*p1p3*mmo2*mz4
     $+18d0*p1p2*p1p4*p2p3*mz4
     $-18d0*p1p2*p1p4*p3p4*mz4
     $+18d0*p1p2*p2p3*p3p4*mz4
     $-18d0*p1p2*p2p4*mmo2*mz4
     $+18d0*p1p2*p3p4*mdn2*mz4
     $+18d0*p1p2*p3p4*mmo2*mz4
     $+18d0*p1p2*p3p42*mz4
     $-18d0*p1p3*p1p4*p2p4*mz4
     $+18d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-18d0*p1p3*p1p4*mdn2*mz4
     $+18d0*p1p3*p2p3*p2p4*mz4
     $+36d0*p1p3*p2p3*p3p4*mdn2*mmo2
     $+36d0*p1p3*p2p3*mdn2*mmo4
     $+36d0*p1p3*p2p4*p3p4*mdn2*mmo2
     $+18d0*p1p3*p2p4*p3p4*mz4
     $+36d0*p1p3*p2p4*mdn2*mmo4
     $-18d0*p1p3*p2p4*mdn2*mz4
     $+18d0*p1p3*p2p4*mmo2*mz4
     $+9d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $+9d0*p1p3*mdn2*mz2r*mmo4
     $+36d0*p1p4*p2p3*p3p4*mdn2*mmo2
     $-18d0*p1p4*p2p3*p3p4*mz4
     $+36d0*p1p4*p2p3*mdn2*mmo4
     $-18d0*p1p4*p2p3*mdn2*mz4
     $-18d0*p1p4*p2p3*mmo2*mz4
     $+36d0*p1p4*p2p4*p3p4*mdn2*mmo2
     $+36d0*p1p4*p2p4*mdn2*mmo4
     $+9d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $-18d0*p1p4*p2p32*mz4
     $+9d0*p1p4*mdn2*mz2r*mmo4
     $+18d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $-18d0*p2p3*p2p4*mdn2*mz4
     $-9d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $+18d0*p2p3*p1p42*mz4
     $-9d0*p2p3*mdn2*mz2r*mmo4
     $-9d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $-9d0*p2p4*mdn2*mz2r*mmo4
     $-18d0*p3p4*p1p22*mz4
     $-36d0*p3p4*mmo2*mz2r*mdn4
     $+72d0*p3p4*mdn4*mmo4
     $+9d0*p1p32*mdn2*mmo2*mz2r
     $+9d0*p1p42*mdn2*mmo2*mz2r
     $+9d0*p2p32*mdn2*mmo2*mz2r
     $+9d0*p2p42*mdn2*mmo2*mz2r
     $+36d0*p3p42*mmo2*mdn4
     $+36d0*mmo2*mdn4*mmo4
     $-36d0*mz2r*mdn4*mmo4
     $)
     $+den7*den8*den42*(
     $+128d0*stw4*p1p2*p1p3*p2p4*mw4
     $-64d0*stw4*p1p2*p1p3*p3p4*mw4
     $-64d0*stw4*p1p2*p1p3*mmo2*mw4
     $+128d0*stw4*p1p2*p1p4*p2p3*mw4
     $-64d0*stw4*p1p2*p1p4*p3p4*mw4
     $-64d0*stw4*p1p2*p1p4*mmo2*mw4
     $+64d0*stw4*p1p2*p2p3*p3p4*mw4
     $+64d0*stw4*p1p2*p2p3*mmo2*mw4
     $+64d0*stw4*p1p2*p2p4*p3p4*mw4
     $+64d0*stw4*p1p2*p2p4*mmo2*mw4
     $+256d0*stw4*p1p2*p3p4*mdn2*mw4
     $+384d0*stw4*p1p2*p3p4*mmo2*mw4
     $+128d0*stw4*p1p2*p3p42*mw4
     $+256d0*stw4*p1p2*mdn2*mmo2*mw4
     $+256d0*stw4*p1p2*mmo4*mw4
     $-64d0*stw4*p1p3*p1p4*p2p3*mw4
     $-64d0*stw4*p1p3*p1p4*p2p4*mw4
     $+64d0*stw4*p1p3*p2p3*p2p4*mw4
     $-256d0*stw4*p1p3*p2p4*mdn2*mw4
     $-64d0*stw4*p1p3*p3p4*mdn2*mw4
     $-64d0*stw4*p1p3*p2p42*mw4
     $-64d0*stw4*p1p3*mdn2*mmo2*mw4
     $+64d0*stw4*p1p4*p2p3*p2p4*mw4
     $-256d0*stw4*p1p4*p2p3*mdn2*mw4
     $-64d0*stw4*p1p4*p3p4*mdn2*mw4
     $-64d0*stw4*p1p4*p2p32*mw4
     $-64d0*stw4*p1p4*mdn2*mmo2*mw4
     $+64d0*stw4*p2p3*p3p4*mdn2*mw4
     $+64d0*stw4*p2p3*p1p42*mw4
     $+64d0*stw4*p2p3*mdn2*mmo2*mw4
     $+64d0*stw4*p2p4*p3p4*mdn2*mw4
     $+64d0*stw4*p2p4*p1p32*mw4
     $+64d0*stw4*p2p4*mdn2*mmo2*mw4
     $-128d0*stw4*p3p4*p1p22*mw4
     $-128d0*stw4*p1p22*mmo2*mw4
     $)
     $+den12*den52*(
     $-324d0*stw2*p1p2*p1p3*mmo2*mz4
     $-648d0*stw2*p1p2*p1p4*mmo2*mz4
     $-864d0*stw2*p1p2*p2p3*p2p4*mz4
     $+324d0*stw2*p1p2*p2p3*mmo2*mz4
     $-864d0*stw2*p1p2*p2p4*p3p4*mz4
     $-1080d0*stw2*p1p2*p2p4*mmo2*mz4
     $+108d0*stw2*p1p2*p3p4*mdn2*mz4
     $+324d0*stw2*p1p2*p3p4*mmo2*mz4
     $+648d0*stw2*p1p2*mdn2*mmo2*mz4
     $+648d0*stw2*p1p2*mmo4*mz4
     $+108d0*stw2*p1p3*p1p4*mdn2*mz4
     $-108d0*stw2*p1p3*p2p4*mdn2*mz4
     $+864d0*stw2*p1p3*p2p42*mz4
     $-108d0*stw2*p1p3*mdn2*mmo2*mz4
     $-864d0*stw2*p1p4*p2p3*p2p4*mz4
     $-108d0*stw2*p1p4*p2p3*mdn2*mz4
     $-864d0*stw2*p1p4*p2p4*p3p4*mz4
     $-1728d0*stw2*p1p4*p2p4*mmo2*mz4
     $-216d0*stw2*p1p4*mdn2*mmo2*mz4
     $+972d0*stw2*p2p3*p2p4*mdn2*mz4
     $+108d0*stw2*p2p3*mdn2*mmo2*mz4
     $+864d0*stw2*p2p4*p3p4*mdn2*mz4
     $+1944d0*stw2*p2p4*mdn2*mmo2*mz4
     $+108d0*stw2*p3p4*mdn2*mmo2*mz4
     $-108d0*stw2*p3p4*mdn4*mz4
     $-648d0*stw2*p1p22*mmo2*mz4
     $+216d0*stw2*mdn2*mmo4*mz4
     $+720d0*stw4*p1p2*p1p3*p1p4*mz4
     $+1080d0*stw4*p1p2*p1p3*mmo2*mz4
     $-720d0*stw4*p1p2*p1p4*p3p4*mz4
     $+720d0*stw4*p1p2*p1p4*mmo2*mz4
     $+1584d0*stw4*p1p2*p2p3*p2p4*mz4
     $-1080d0*stw4*p1p2*p2p3*mmo2*mz4
     $+1584d0*stw4*p1p2*p2p4*p3p4*mz4
     $+1008d0*stw4*p1p2*p2p4*mmo2*mz4
     $-504d0*stw4*p1p2*p3p4*mdn2*mz4
     $-1080d0*stw4*p1p2*p3p4*mmo2*mz4
     $-3888d0*stw4*p1p2*mdn2*mmo2*mz4
     $-2160d0*stw4*p1p2*mmo4*mz4
     $-720d0*stw4*p1p3*p1p4*p2p4*mz4
     $-1224d0*stw4*p1p3*p1p4*mdn2*mz4
     $+504d0*stw4*p1p3*p2p4*mdn2*mz4
     $-1584d0*stw4*p1p3*p2p42*mz4
     $-360d0*stw4*p1p3*mdn2*mmo2*mz4
     $+1584d0*stw4*p1p4*p2p3*p2p4*mz4
     $+504d0*stw4*p1p4*p2p3*mdn2*mz4
     $+2304d0*stw4*p1p4*p2p4*p3p4*mz4
     $+4608d0*stw4*p1p4*p2p4*mmo2*mz4
     $+720d0*stw4*p1p4*p3p4*mdn2*mz4
     $+720d0*stw4*p1p4*mdn2*mmo2*mz4
     $-2088d0*stw4*p2p3*p2p4*mdn2*mz4
     $+720d0*stw4*p2p3*p1p42*mz4
     $+360d0*stw4*p2p3*mdn2*mmo2*mz4
     $-1584d0*stw4*p2p4*p3p4*mdn2*mz4
     $-2448d0*stw4*p2p4*mdn2*mmo2*mz4
     $+360d0*stw4*p3p4*mdn2*mmo2*mz4
     $+504d0*stw4*p3p4*mdn4*mz4
     $+2160d0*stw4*p1p22*mmo2*mz4
     $+720d0*stw4*mdn2*mmo4*mz4
     $+1728d0*stw4*mmo2*mdn4*mz4
     $-1152d0*stw6*p1p2*p1p3*p1p4*mz4
     $-1152d0*stw6*p1p2*p1p3*mmo2*mz4
     $+1152d0*stw6*p1p2*p1p4*p3p4*mz4
     $-1152d0*stw6*p1p2*p2p3*p2p4*mz4
     $+1152d0*stw6*p1p2*p2p3*mmo2*mz4
     $-1152d0*stw6*p1p2*p2p4*p3p4*mz4
     $+1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $+6912d0*stw6*p1p2*mdn2*mmo2*mz4
     $+2304d0*stw6*p1p2*mmo4*mz4
     $+1152d0*stw6*p1p3*p1p4*p2p4*mz4
     $+2304d0*stw6*p1p3*p1p4*mdn2*mz4
     $-1152d0*stw6*p1p3*p2p4*mdn2*mz4
     $+1152d0*stw6*p1p3*p2p42*mz4
     $+1152d0*stw6*p1p3*mdn2*mmo2*mz4
     $-1152d0*stw6*p1p4*p2p3*p2p4*mz4
     $-1152d0*stw6*p1p4*p2p3*mdn2*mz4
     $-2304d0*stw6*p1p4*p2p4*p3p4*mz4
     $-4608d0*stw6*p1p4*p2p4*mmo2*mz4
     $-1152d0*stw6*p1p4*p3p4*mdn2*mz4
     $+2304d0*stw6*p2p3*p2p4*mdn2*mz4
     $-1152d0*stw6*p2p3*p1p42*mz4
     $-1152d0*stw6*p2p3*mdn2*mmo2*mz4
     $+1152d0*stw6*p2p4*p3p4*mdn2*mz4
     $-1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $-1152d0*stw6*p3p4*mdn4*mz4
     $-2304d0*stw6*p1p22*mmo2*mz4
     $-2304d0*stw6*mdn2*mmo4*mz4
     $-4608d0*stw6*mmo2*mdn4*mz4
     $+576d0*stw8*p1p2*p1p3*p1p4*mz4
     $+576d0*stw8*p1p2*p1p3*mmo2*mz4
     $-576d0*stw8*p1p2*p1p4*p3p4*mz4
     $+576d0*stw8*p1p2*p2p3*p2p4*mz4
     $-576d0*stw8*p1p2*p2p3*mmo2*mz4
     $+576d0*stw8*p1p2*p2p4*p3p4*mz4
     $-576d0*stw8*p1p2*p3p4*mdn2*mz4
     $-576d0*stw8*p1p2*p3p4*mmo2*mz4
     $-3456d0*stw8*p1p2*mdn2*mmo2*mz4
     $-1152d0*stw8*p1p2*mmo4*mz4
     $-576d0*stw8*p1p3*p1p4*p2p4*mz4
     $-1152d0*stw8*p1p3*p1p4*mdn2*mz4
     $+576d0*stw8*p1p3*p2p4*mdn2*mz4
     $-576d0*stw8*p1p3*p2p42*mz4
     $-576d0*stw8*p1p3*mdn2*mmo2*mz4
     $+576d0*stw8*p1p4*p2p3*p2p4*mz4
     $+576d0*stw8*p1p4*p2p3*mdn2*mz4
     $+1152d0*stw8*p1p4*p2p4*p3p4*mz4
     $+2304d0*stw8*p1p4*p2p4*mmo2*mz4
     $+576d0*stw8*p1p4*p3p4*mdn2*mz4
     $-1152d0*stw8*p2p3*p2p4*mdn2*mz4
     $+576d0*stw8*p2p3*p1p42*mz4
     $+576d0*stw8*p2p3*mdn2*mmo2*mz4
     $-576d0*stw8*p2p4*p3p4*mdn2*mz4
     $+576d0*stw8*p3p4*mdn2*mmo2*mz4
     $+576d0*stw8*p3p4*mdn4*mz4
     $+1152d0*stw8*p1p22*mmo2*mz4
     $+1152d0*stw8*mdn2*mmo4*mz4
     $+2304d0*stw8*mmo2*mdn4*mz4
     $+162d0*p1p2*p1p3*p1p4*mdn2*mmo2
     $-162d0*p1p2*p1p3*p2p4*mdn2*mmo2
     $-81d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-162d0*p1p2*p1p4*p2p3*mdn2*mmo2
     $+162d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+162d0*p1p2*p2p3*p2p4*mdn2*mmo2
     $+162d0*p1p2*p2p3*p2p4*mz4
     $+81d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $+162d0*p1p2*p2p4*p3p4*mz4
     $-162d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+324d0*p1p2*p2p4*mmo2*mz4
     $+162d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-324d0*p1p2*p3p4*mmo2*mdn4
     $+324d0*p1p2*mdn2*mz2r*mmo4
     $-648d0*p1p2*mdn4*mmo4
     $+81d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-162d0*p1p3*p1p4*mmo2*mdn4
     $-81d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $+162d0*p1p3*p2p4*mmo2*mdn4
     $-162d0*p1p3*p2p42*mz4
     $+81d0*p1p3*mmo2*mz2r*mdn4
     $+162d0*p1p4*p2p3*p2p4*mz4
     $-81d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+162d0*p1p4*p2p3*mmo2*mdn4
     $+162d0*p1p4*p2p4*p3p4*mz4
     $-324d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $+324d0*p1p4*p2p4*mmo2*mz4
     $-162d0*p1p4*mmo2*mz2r*mdn4
     $+81d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $-162d0*p2p3*p2p4*mdn2*mz4
     $-162d0*p2p3*p2p4*mmo2*mdn4
     $-81d0*p2p3*mmo2*mz2r*mdn4
     $-162d0*p2p4*p3p4*mdn2*mz4
     $-324d0*p2p4*mdn2*mmo2*mz4
     $+162d0*p2p4*mmo2*mz2r*mdn4
     $+162d0*p3p4*p1p22*mdn2*mmo2
     $+162d0*p3p4*mdn2*mmo2*mdn4
     $-162d0*p3p4*mmo2*mz2r*mdn4
     $+324d0*p1p22*mdn2*mmo4
     $+162d0*p1p42*mdn2*mmo2*mz2r
     $+162d0*p2p42*mdn2*mmo2*mz2r
     $+324d0*mdn2*mdn4*mmo4
     $-324d0*mz2r*mdn4*mmo4
     $)
     $+den12*den62*(
     $-864d0*stw2*p1p2*p1p3*p1p4*mz4
     $+864d0*stw2*p1p2*p1p3*p3p4*mz4
     $+1080d0*stw2*p1p2*p1p3*mmo2*mz4
     $-324d0*stw2*p1p2*p1p4*mmo2*mz4
     $+648d0*stw2*p1p2*p2p3*mmo2*mz4
     $+324d0*stw2*p1p2*p2p4*mmo2*mz4
     $+108d0*stw2*p1p2*p3p4*mdn2*mz4
     $+324d0*stw2*p1p2*p3p4*mmo2*mz4
     $+648d0*stw2*p1p2*mdn2*mmo2*mz4
     $+648d0*stw2*p1p2*mmo4*mz4
     $+864d0*stw2*p1p3*p1p4*p2p3*mz4
     $+972d0*stw2*p1p3*p1p4*mdn2*mz4
     $-864d0*stw2*p1p3*p2p3*p3p4*mz4
     $-1728d0*stw2*p1p3*p2p3*mmo2*mz4
     $-108d0*stw2*p1p3*p2p4*mdn2*mz4
     $-864d0*stw2*p1p3*p3p4*mdn2*mz4
     $-1944d0*stw2*p1p3*mdn2*mmo2*mz4
     $-108d0*stw2*p1p4*p2p3*mdn2*mz4
     $-108d0*stw2*p1p4*mdn2*mmo2*mz4
     $+108d0*stw2*p2p3*p2p4*mdn2*mz4
     $+216d0*stw2*p2p3*mdn2*mmo2*mz4
     $-864d0*stw2*p2p4*p1p32*mz4
     $+108d0*stw2*p2p4*mdn2*mmo2*mz4
     $+108d0*stw2*p3p4*mdn2*mmo2*mz4
     $-108d0*stw2*p3p4*mdn4*mz4
     $-648d0*stw2*p1p22*mmo2*mz4
     $+216d0*stw2*mdn2*mmo4*mz4
     $+1584d0*stw4*p1p2*p1p3*p1p4*mz4
     $-1584d0*stw4*p1p2*p1p3*p3p4*mz4
     $-1008d0*stw4*p1p2*p1p3*mmo2*mz4
     $+1080d0*stw4*p1p2*p1p4*mmo2*mz4
     $+720d0*stw4*p1p2*p2p3*p2p4*mz4
     $+720d0*stw4*p1p2*p2p3*p3p4*mz4
     $-720d0*stw4*p1p2*p2p3*mmo2*mz4
     $-1080d0*stw4*p1p2*p2p4*mmo2*mz4
     $-504d0*stw4*p1p2*p3p4*mdn2*mz4
     $-1080d0*stw4*p1p2*p3p4*mmo2*mz4
     $-3888d0*stw4*p1p2*mdn2*mmo2*mz4
     $-2160d0*stw4*p1p2*mmo4*mz4
     $-1584d0*stw4*p1p3*p1p4*p2p3*mz4
     $-2088d0*stw4*p1p3*p1p4*mdn2*mz4
     $+720d0*stw4*p1p3*p2p3*p2p4*mz4
     $+2304d0*stw4*p1p3*p2p3*p3p4*mz4
     $+4608d0*stw4*p1p3*p2p3*mmo2*mz4
     $+504d0*stw4*p1p3*p2p4*mdn2*mz4
     $+1584d0*stw4*p1p3*p3p4*mdn2*mz4
     $+2448d0*stw4*p1p3*mdn2*mmo2*mz4
     $+504d0*stw4*p1p4*p2p3*mdn2*mz4
     $-720d0*stw4*p1p4*p2p32*mz4
     $-360d0*stw4*p1p4*mdn2*mmo2*mz4
     $-1224d0*stw4*p2p3*p2p4*mdn2*mz4
     $-720d0*stw4*p2p3*p3p4*mdn2*mz4
     $-720d0*stw4*p2p3*mdn2*mmo2*mz4
     $+1584d0*stw4*p2p4*p1p32*mz4
     $+360d0*stw4*p2p4*mdn2*mmo2*mz4
     $+360d0*stw4*p3p4*mdn2*mmo2*mz4
     $+504d0*stw4*p3p4*mdn4*mz4
     $+2160d0*stw4*p1p22*mmo2*mz4
     $+720d0*stw4*mdn2*mmo4*mz4
     $+1728d0*stw4*mmo2*mdn4*mz4
     $-1152d0*stw6*p1p2*p1p3*p1p4*mz4
     $+1152d0*stw6*p1p2*p1p3*p3p4*mz4
     $-1152d0*stw6*p1p2*p1p4*mmo2*mz4
     $-1152d0*stw6*p1p2*p2p3*p2p4*mz4
     $-1152d0*stw6*p1p2*p2p3*p3p4*mz4
     $+1152d0*stw6*p1p2*p2p4*mmo2*mz4
     $+1152d0*stw6*p1p2*p3p4*mdn2*mz4
     $+1152d0*stw6*p1p2*p3p4*mmo2*mz4
     $+6912d0*stw6*p1p2*mdn2*mmo2*mz4
     $+2304d0*stw6*p1p2*mmo4*mz4
     $+1152d0*stw6*p1p3*p1p4*p2p3*mz4
     $+2304d0*stw6*p1p3*p1p4*mdn2*mz4
     $-1152d0*stw6*p1p3*p2p3*p2p4*mz4
     $-2304d0*stw6*p1p3*p2p3*p3p4*mz4
     $-4608d0*stw6*p1p3*p2p3*mmo2*mz4
     $-1152d0*stw6*p1p3*p2p4*mdn2*mz4
     $-1152d0*stw6*p1p3*p3p4*mdn2*mz4
     $-1152d0*stw6*p1p4*p2p3*mdn2*mz4
     $+1152d0*stw6*p1p4*p2p32*mz4
     $+1152d0*stw6*p1p4*mdn2*mmo2*mz4
     $+2304d0*stw6*p2p3*p2p4*mdn2*mz4
     $+1152d0*stw6*p2p3*p3p4*mdn2*mz4
     $-1152d0*stw6*p2p4*p1p32*mz4
     $-1152d0*stw6*p2p4*mdn2*mmo2*mz4
     $-1152d0*stw6*p3p4*mdn2*mmo2*mz4
     $-1152d0*stw6*p3p4*mdn4*mz4
     $-2304d0*stw6*p1p22*mmo2*mz4
     $-2304d0*stw6*mdn2*mmo4*mz4
     $-4608d0*stw6*mmo2*mdn4*mz4
     $+576d0*stw8*p1p2*p1p3*p1p4*mz4
     $-576d0*stw8*p1p2*p1p3*p3p4*mz4
     $+576d0*stw8*p1p2*p1p4*mmo2*mz4
     $+576d0*stw8*p1p2*p2p3*p2p4*mz4
     $+576d0*stw8*p1p2*p2p3*p3p4*mz4
     $-576d0*stw8*p1p2*p2p4*mmo2*mz4
     $-576d0*stw8*p1p2*p3p4*mdn2*mz4
     $-576d0*stw8*p1p2*p3p4*mmo2*mz4
     $-3456d0*stw8*p1p2*mdn2*mmo2*mz4
     $-1152d0*stw8*p1p2*mmo4*mz4
     $-576d0*stw8*p1p3*p1p4*p2p3*mz4
     $-1152d0*stw8*p1p3*p1p4*mdn2*mz4
     $+576d0*stw8*p1p3*p2p3*p2p4*mz4
     $+1152d0*stw8*p1p3*p2p3*p3p4*mz4
     $+2304d0*stw8*p1p3*p2p3*mmo2*mz4
     $+576d0*stw8*p1p3*p2p4*mdn2*mz4
     $+576d0*stw8*p1p3*p3p4*mdn2*mz4
     $+576d0*stw8*p1p4*p2p3*mdn2*mz4
     $-576d0*stw8*p1p4*p2p32*mz4
     $-576d0*stw8*p1p4*mdn2*mmo2*mz4
     $-1152d0*stw8*p2p3*p2p4*mdn2*mz4
     $-576d0*stw8*p2p3*p3p4*mdn2*mz4
     $+576d0*stw8*p2p4*p1p32*mz4
     $+576d0*stw8*p2p4*mdn2*mmo2*mz4
     $+576d0*stw8*p3p4*mdn2*mmo2*mz4
     $+576d0*stw8*p3p4*mdn4*mz4
     $+1152d0*stw8*p1p22*mmo2*mz4
     $+1152d0*stw8*mdn2*mmo4*mz4
     $+2304d0*stw8*mmo2*mdn4*mz4
     $+162d0*p1p2*p1p3*p1p4*mdn2*mmo2
     $+162d0*p1p2*p1p3*p1p4*mz4
     $-162d0*p1p2*p1p3*p2p4*mdn2*mmo2
     $-162d0*p1p2*p1p3*p3p4*mz4
     $+162d0*p1p2*p1p3*mdn2*mmo2*mz2r
     $-324d0*p1p2*p1p3*mmo2*mz4
     $-162d0*p1p2*p1p4*p2p3*mdn2*mmo2
     $-81d0*p1p2*p1p4*mdn2*mmo2*mz2r
     $+162d0*p1p2*p2p3*p2p4*mdn2*mmo2
     $-162d0*p1p2*p2p3*mdn2*mmo2*mz2r
     $+81d0*p1p2*p2p4*mdn2*mmo2*mz2r
     $+162d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-324d0*p1p2*p3p4*mmo2*mdn4
     $+324d0*p1p2*mdn2*mz2r*mmo4
     $-648d0*p1p2*mdn4*mmo4
     $-162d0*p1p3*p1p4*p2p3*mz4
     $+81d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-162d0*p1p3*p1p4*mdn2*mz4
     $-162d0*p1p3*p1p4*mmo2*mdn4
     $+162d0*p1p3*p2p3*p3p4*mz4
     $-324d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+324d0*p1p3*p2p3*mmo2*mz4
     $-81d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $+162d0*p1p3*p2p4*mmo2*mdn4
     $+162d0*p1p3*p3p4*mdn2*mz4
     $+324d0*p1p3*mdn2*mmo2*mz4
     $-162d0*p1p3*mmo2*mz2r*mdn4
     $-81d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+162d0*p1p4*p2p3*mmo2*mdn4
     $+81d0*p1p4*mmo2*mz2r*mdn4
     $+81d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $-162d0*p2p3*p2p4*mmo2*mdn4
     $+162d0*p2p3*mmo2*mz2r*mdn4
     $+162d0*p2p4*p1p32*mz4
     $-81d0*p2p4*mmo2*mz2r*mdn4
     $+162d0*p3p4*p1p22*mdn2*mmo2
     $+162d0*p3p4*mdn2*mmo2*mdn4
     $-162d0*p3p4*mmo2*mz2r*mdn4
     $+324d0*p1p22*mdn2*mmo4
     $+162d0*p1p32*mdn2*mmo2*mz2r
     $+162d0*p2p32*mdn2*mmo2*mz2r
     $+324d0*mdn2*mdn4*mmo4
     $-324d0*mz2r*mdn4*mmo4
     $)
     $+den22*den72*(
     $-96d0*stw2*p1p2*p2p3*p2p4*mz4
     $-96d0*stw2*p1p2*p2p4*p3p4*mz4
     $-96d0*stw2*p1p2*p2p4*mmo2*mz4
     $+12d0*stw2*p1p2*p3p4*mdn2*mz4
     $+36d0*stw2*p1p2*p3p4*mmo2*mz4
     $-36d0*stw2*p1p2*mdn2*mmo2*mz4
     $+36d0*stw2*p1p2*mmo4*mz4
     $-36d0*stw2*p1p3*p2p3*mmo2*mz4
     $-36d0*stw2*p1p3*p2p4*mmo2*mz4
     $+12d0*stw2*p1p3*p3p4*mdn2*mz4
     $+96d0*stw2*p1p3*p2p42*mz4
     $-36d0*stw2*p1p3*mdn2*mmo2*mz4
     $-96d0*stw2*p1p4*p2p3*p2p4*mz4
     $-36d0*stw2*p1p4*p2p3*mmo2*mz4
     $-96d0*stw2*p1p4*p2p4*p3p4*mz4
     $-132d0*stw2*p1p4*p2p4*mmo2*mz4
     $+12d0*stw2*p1p4*p3p4*mdn2*mz4
     $-36d0*stw2*p1p4*mdn2*mmo2*mz4
     $+192d0*stw2*p2p3*p2p4*mdn2*mz4
     $-24d0*stw2*p2p3*p3p4*mdn2*mz4
     $+72d0*stw2*p2p3*mdn2*mmo2*mz4
     $+168d0*stw2*p2p4*p3p4*mdn2*mz4
     $+264d0*stw2*p2p4*mdn2*mmo2*mz4
     $-24d0*stw2*p3p4*mdn2*mmo2*mz4
     $-24d0*stw2*p3p4*mdn4*mz4
     $-24d0*stw2*p3p42*mdn2*mz4
     $+72d0*stw2*mmo2*mdn4*mz4
     $+256d0*stw4*p1p2*p2p3*p2p4*mz4
     $+80d0*stw4*p1p2*p2p3*p3p4*mz4
     $+80d0*stw4*p1p2*p2p3*mmo2*mz4
     $+176d0*stw4*p1p2*p2p4*p3p4*mz4
     $+176d0*stw4*p1p2*p2p4*mmo2*mz4
     $-56d0*stw4*p1p2*p3p4*mdn2*mz4
     $-120d0*stw4*p1p2*p3p4*mmo2*mz4
     $+24d0*stw4*p1p2*mdn2*mmo2*mz4
     $-120d0*stw4*p1p2*mmo4*mz4
     $+80d0*stw4*p1p3*p2p3*p2p4*mz4
     $+80d0*stw4*p1p3*p2p3*p3p4*mz4
     $+200d0*stw4*p1p3*p2p3*mmo2*mz4
     $+120d0*stw4*p1p3*p2p4*mmo2*mz4
     $-56d0*stw4*p1p3*p3p4*mdn2*mz4
     $-176d0*stw4*p1p3*p2p42*mz4
     $+24d0*stw4*p1p3*mdn2*mmo2*mz4
     $+176d0*stw4*p1p4*p2p3*p2p4*mz4
     $+120d0*stw4*p1p4*p2p3*mmo2*mz4
     $+176d0*stw4*p1p4*p2p4*p3p4*mz4
     $+296d0*stw4*p1p4*p2p4*mmo2*mz4
     $-56d0*stw4*p1p4*p3p4*mdn2*mz4
     $-80d0*stw4*p1p4*p2p32*mz4
     $+24d0*stw4*p1p4*mdn2*mmo2*mz4
     $-512d0*stw4*p2p3*p2p4*mdn2*mz4
     $-48d0*stw4*p2p3*p3p4*mdn2*mz4
     $-208d0*stw4*p2p3*mdn2*mmo2*mz4
     $-240d0*stw4*p2p4*p3p4*mdn2*mz4
     $-400d0*stw4*p2p4*mdn2*mmo2*mz4
     $+304d0*stw4*p3p4*mdn2*mmo2*mz4
     $+112d0*stw4*p3p4*mdn4*mz4
     $+112d0*stw4*p3p42*mdn2*mz4
     $+192d0*stw4*mdn2*mmo4*mz4
     $-48d0*stw4*mmo2*mdn4*mz4
     $-256d0*stw6*p1p2*p2p3*p2p4*mz4
     $-128d0*stw6*p1p2*p2p3*p3p4*mz4
     $-128d0*stw6*p1p2*p2p3*mmo2*mz4
     $-128d0*stw6*p1p2*p2p4*p3p4*mz4
     $-128d0*stw6*p1p2*p2p4*mmo2*mz4
     $+128d0*stw6*p1p2*p3p4*mdn2*mz4
     $+128d0*stw6*p1p2*p3p4*mmo2*mz4
     $+128d0*stw6*p1p2*mdn2*mmo2*mz4
     $+128d0*stw6*p1p2*mmo4*mz4
     $-128d0*stw6*p1p3*p2p3*p2p4*mz4
     $-128d0*stw6*p1p3*p2p3*p3p4*mz4
     $-256d0*stw6*p1p3*p2p3*mmo2*mz4
     $-128d0*stw6*p1p3*p2p4*mmo2*mz4
     $+128d0*stw6*p1p3*p3p4*mdn2*mz4
     $+128d0*stw6*p1p3*p2p42*mz4
     $+128d0*stw6*p1p3*mdn2*mmo2*mz4
     $-128d0*stw6*p1p4*p2p3*p2p4*mz4
     $-128d0*stw6*p1p4*p2p3*mmo2*mz4
     $-128d0*stw6*p1p4*p2p4*p3p4*mz4
     $-256d0*stw6*p1p4*p2p4*mmo2*mz4
     $+128d0*stw6*p1p4*p3p4*mdn2*mz4
     $+128d0*stw6*p1p4*p2p32*mz4
     $+128d0*stw6*p1p4*mdn2*mmo2*mz4
     $+512d0*stw6*p2p3*p2p4*mdn2*mz4
     $-768d0*stw6*p3p4*mdn2*mmo2*mz4
     $-256d0*stw6*p3p4*mdn4*mz4
     $-256d0*stw6*p3p42*mdn2*mz4
     $-512d0*stw6*mdn2*mmo4*mz4
     $-256d0*stw6*mmo2*mdn4*mz4
     $+128d0*stw8*p1p2*p2p3*p2p4*mz4
     $+64d0*stw8*p1p2*p2p3*p3p4*mz4
     $+64d0*stw8*p1p2*p2p3*mmo2*mz4
     $+64d0*stw8*p1p2*p2p4*p3p4*mz4
     $+64d0*stw8*p1p2*p2p4*mmo2*mz4
     $-64d0*stw8*p1p2*p3p4*mdn2*mz4
     $-64d0*stw8*p1p2*p3p4*mmo2*mz4
     $-64d0*stw8*p1p2*mdn2*mmo2*mz4
     $-64d0*stw8*p1p2*mmo4*mz4
     $+64d0*stw8*p1p3*p2p3*p2p4*mz4
     $+64d0*stw8*p1p3*p2p3*p3p4*mz4
     $+128d0*stw8*p1p3*p2p3*mmo2*mz4
     $+64d0*stw8*p1p3*p2p4*mmo2*mz4
     $-64d0*stw8*p1p3*p3p4*mdn2*mz4
     $-64d0*stw8*p1p3*p2p42*mz4
     $-64d0*stw8*p1p3*mdn2*mmo2*mz4
     $+64d0*stw8*p1p4*p2p3*p2p4*mz4
     $+64d0*stw8*p1p4*p2p3*mmo2*mz4
     $+64d0*stw8*p1p4*p2p4*p3p4*mz4
     $+128d0*stw8*p1p4*p2p4*mmo2*mz4
     $-64d0*stw8*p1p4*p3p4*mdn2*mz4
     $-64d0*stw8*p1p4*p2p32*mz4
     $-64d0*stw8*p1p4*mdn2*mmo2*mz4
     $-256d0*stw8*p2p3*p2p4*mdn2*mz4
     $+384d0*stw8*p3p4*mdn2*mmo2*mz4
     $+128d0*stw8*p3p4*mdn4*mz4
     $+128d0*stw8*p3p42*mdn2*mz4
     $+256d0*stw8*mdn2*mmo4*mz4
     $+128d0*stw8*mmo2*mdn4*mz4
     $+18d0*p1p2*p2p3*p2p4*mz4
     $+18d0*p1p2*p2p4*p3p4*mz4
     $+18d0*p1p2*p2p4*mmo2*mz4
     $+18d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-36d0*p1p2*p3p4*mdn2*mmo4
     $-18d0*p1p2*p3p42*mdn2*mmo2
     $-18d0*p1p2*mdn2*mmo2*mmo4
     $+18d0*p1p2*mdn2*mz2r*mmo4
     $+18d0*p1p3*p2p3*p3p4*mdn2*mmo2
     $-9d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+18d0*p1p3*p2p3*mdn2*mmo4
     $+18d0*p1p3*p2p4*p3p4*mdn2*mmo2
     $-9d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $+18d0*p1p3*p2p4*mdn2*mmo4
     $+9d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $-18d0*p1p3*p2p42*mz4
     $+9d0*p1p3*mdn2*mz2r*mmo4
     $+18d0*p1p4*p2p3*p2p4*mz4
     $+18d0*p1p4*p2p3*p3p4*mdn2*mmo2
     $-9d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+18d0*p1p4*p2p3*mdn2*mmo4
     $+18d0*p1p4*p2p4*p3p4*mdn2*mmo2
     $+18d0*p1p4*p2p4*p3p4*mz4
     $-9d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $+18d0*p1p4*p2p4*mdn2*mmo4
     $+18d0*p1p4*p2p4*mmo2*mz4
     $+9d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $+9d0*p1p4*mdn2*mz2r*mmo4
     $+36d0*p2p3*p2p4*mdn2*mmo2*mz2r
     $-36d0*p2p3*p2p4*mdn2*mz4
     $+18d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $+18d0*p2p3*mdn2*mz2r*mmo4
     $+18d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $-36d0*p2p4*p3p4*mdn2*mz4
     $-36d0*p2p4*mdn2*mmo2*mz4
     $+18d0*p2p4*mdn2*mz2r*mmo4
     $-36d0*p3p4*mmo2*mz2r*mdn4
     $+72d0*p3p4*mdn4*mmo4
     $+18d0*p2p32*mdn2*mmo2*mz2r
     $+18d0*p2p42*mdn2*mmo2*mz2r
     $+36d0*p3p42*mmo2*mdn4
     $+36d0*mmo2*mdn4*mmo4
     $-36d0*mz2r*mdn4*mmo4
     $)
     $+den22*den82*(
     $-96d0*stw2*p1p2*p1p3*p1p4*mz4
     $+96d0*stw2*p1p2*p1p3*p3p4*mz4
     $+96d0*stw2*p1p2*p1p3*mmo2*mz4
     $+12d0*stw2*p1p2*p3p4*mdn2*mz4
     $+36d0*stw2*p1p2*p3p4*mmo2*mz4
     $-36d0*stw2*p1p2*mdn2*mmo2*mz4
     $+36d0*stw2*p1p2*mmo4*mz4
     $+96d0*stw2*p1p3*p1p4*p2p3*mz4
     $+192d0*stw2*p1p3*p1p4*mdn2*mz4
     $-96d0*stw2*p1p3*p2p3*p3p4*mz4
     $-132d0*stw2*p1p3*p2p3*mmo2*mz4
     $-36d0*stw2*p1p3*p2p4*mmo2*mz4
     $-168d0*stw2*p1p3*p3p4*mdn2*mz4
     $-264d0*stw2*p1p3*mdn2*mmo2*mz4
     $-36d0*stw2*p1p4*p2p3*mmo2*mz4
     $-36d0*stw2*p1p4*p2p4*mmo2*mz4
     $+24d0*stw2*p1p4*p3p4*mdn2*mz4
     $-72d0*stw2*p1p4*mdn2*mmo2*mz4
     $-12d0*stw2*p2p3*p3p4*mdn2*mz4
     $+36d0*stw2*p2p3*mdn2*mmo2*mz4
     $-12d0*stw2*p2p4*p3p4*mdn2*mz4
     $-96d0*stw2*p2p4*p1p32*mz4
     $+36d0*stw2*p2p4*mdn2*mmo2*mz4
     $-24d0*stw2*p3p4*mdn2*mmo2*mz4
     $-24d0*stw2*p3p4*mdn4*mz4
     $-24d0*stw2*p3p42*mdn2*mz4
     $+72d0*stw2*mmo2*mdn4*mz4
     $+256d0*stw4*p1p2*p1p3*p1p4*mz4
     $-176d0*stw4*p1p2*p1p3*p3p4*mz4
     $-176d0*stw4*p1p2*p1p3*mmo2*mz4
     $-80d0*stw4*p1p2*p1p4*p3p4*mz4
     $-80d0*stw4*p1p2*p1p4*mmo2*mz4
     $-56d0*stw4*p1p2*p3p4*mdn2*mz4
     $-120d0*stw4*p1p2*p3p4*mmo2*mz4
     $+24d0*stw4*p1p2*mdn2*mmo2*mz4
     $-120d0*stw4*p1p2*mmo4*mz4
     $-176d0*stw4*p1p3*p1p4*p2p3*mz4
     $-80d0*stw4*p1p3*p1p4*p2p4*mz4
     $-512d0*stw4*p1p3*p1p4*mdn2*mz4
     $+176d0*stw4*p1p3*p2p3*p3p4*mz4
     $+296d0*stw4*p1p3*p2p3*mmo2*mz4
     $+120d0*stw4*p1p3*p2p4*mmo2*mz4
     $+240d0*stw4*p1p3*p3p4*mdn2*mz4
     $+400d0*stw4*p1p3*mdn2*mmo2*mz4
     $+120d0*stw4*p1p4*p2p3*mmo2*mz4
     $+80d0*stw4*p1p4*p2p4*p3p4*mz4
     $+200d0*stw4*p1p4*p2p4*mmo2*mz4
     $+48d0*stw4*p1p4*p3p4*mdn2*mz4
     $+208d0*stw4*p1p4*mdn2*mmo2*mz4
     $+56d0*stw4*p2p3*p3p4*mdn2*mz4
     $+80d0*stw4*p2p3*p1p42*mz4
     $-24d0*stw4*p2p3*mdn2*mmo2*mz4
     $+56d0*stw4*p2p4*p3p4*mdn2*mz4
     $+176d0*stw4*p2p4*p1p32*mz4
     $-24d0*stw4*p2p4*mdn2*mmo2*mz4
     $+304d0*stw4*p3p4*mdn2*mmo2*mz4
     $+112d0*stw4*p3p4*mdn4*mz4
     $+112d0*stw4*p3p42*mdn2*mz4
     $+192d0*stw4*mdn2*mmo4*mz4
     $-48d0*stw4*mmo2*mdn4*mz4
     $-256d0*stw6*p1p2*p1p3*p1p4*mz4
     $+128d0*stw6*p1p2*p1p3*p3p4*mz4
     $+128d0*stw6*p1p2*p1p3*mmo2*mz4
     $+128d0*stw6*p1p2*p1p4*p3p4*mz4
     $+128d0*stw6*p1p2*p1p4*mmo2*mz4
     $+128d0*stw6*p1p2*p3p4*mdn2*mz4
     $+128d0*stw6*p1p2*p3p4*mmo2*mz4
     $+128d0*stw6*p1p2*mdn2*mmo2*mz4
     $+128d0*stw6*p1p2*mmo4*mz4
     $+128d0*stw6*p1p3*p1p4*p2p3*mz4
     $+128d0*stw6*p1p3*p1p4*p2p4*mz4
     $+512d0*stw6*p1p3*p1p4*mdn2*mz4
     $-128d0*stw6*p1p3*p2p3*p3p4*mz4
     $-256d0*stw6*p1p3*p2p3*mmo2*mz4
     $-128d0*stw6*p1p3*p2p4*mmo2*mz4
     $-128d0*stw6*p1p4*p2p3*mmo2*mz4
     $-128d0*stw6*p1p4*p2p4*p3p4*mz4
     $-256d0*stw6*p1p4*p2p4*mmo2*mz4
     $-128d0*stw6*p2p3*p3p4*mdn2*mz4
     $-128d0*stw6*p2p3*p1p42*mz4
     $-128d0*stw6*p2p3*mdn2*mmo2*mz4
     $-128d0*stw6*p2p4*p3p4*mdn2*mz4
     $-128d0*stw6*p2p4*p1p32*mz4
     $-128d0*stw6*p2p4*mdn2*mmo2*mz4
     $-768d0*stw6*p3p4*mdn2*mmo2*mz4
     $-256d0*stw6*p3p4*mdn4*mz4
     $-256d0*stw6*p3p42*mdn2*mz4
     $-512d0*stw6*mdn2*mmo4*mz4
     $-256d0*stw6*mmo2*mdn4*mz4
     $+128d0*stw8*p1p2*p1p3*p1p4*mz4
     $-64d0*stw8*p1p2*p1p3*p3p4*mz4
     $-64d0*stw8*p1p2*p1p3*mmo2*mz4
     $-64d0*stw8*p1p2*p1p4*p3p4*mz4
     $-64d0*stw8*p1p2*p1p4*mmo2*mz4
     $-64d0*stw8*p1p2*p3p4*mdn2*mz4
     $-64d0*stw8*p1p2*p3p4*mmo2*mz4
     $-64d0*stw8*p1p2*mdn2*mmo2*mz4
     $-64d0*stw8*p1p2*mmo4*mz4
     $-64d0*stw8*p1p3*p1p4*p2p3*mz4
     $-64d0*stw8*p1p3*p1p4*p2p4*mz4
     $-256d0*stw8*p1p3*p1p4*mdn2*mz4
     $+64d0*stw8*p1p3*p2p3*p3p4*mz4
     $+128d0*stw8*p1p3*p2p3*mmo2*mz4
     $+64d0*stw8*p1p3*p2p4*mmo2*mz4
     $+64d0*stw8*p1p4*p2p3*mmo2*mz4
     $+64d0*stw8*p1p4*p2p4*p3p4*mz4
     $+128d0*stw8*p1p4*p2p4*mmo2*mz4
     $+64d0*stw8*p2p3*p3p4*mdn2*mz4
     $+64d0*stw8*p2p3*p1p42*mz4
     $+64d0*stw8*p2p3*mdn2*mmo2*mz4
     $+64d0*stw8*p2p4*p3p4*mdn2*mz4
     $+64d0*stw8*p2p4*p1p32*mz4
     $+64d0*stw8*p2p4*mdn2*mmo2*mz4
     $+384d0*stw8*p3p4*mdn2*mmo2*mz4
     $+128d0*stw8*p3p4*mdn4*mz4
     $+128d0*stw8*p3p42*mdn2*mz4
     $+256d0*stw8*mdn2*mmo4*mz4
     $+128d0*stw8*mmo2*mdn4*mz4
     $+18d0*p1p2*p1p3*p1p4*mz4
     $-18d0*p1p2*p1p3*p3p4*mz4
     $-18d0*p1p2*p1p3*mmo2*mz4
     $+18d0*p1p2*p3p4*mdn2*mmo2*mz2r
     $-36d0*p1p2*p3p4*mdn2*mmo4
     $-18d0*p1p2*p3p42*mdn2*mmo2
     $-18d0*p1p2*mdn2*mmo2*mmo4
     $+18d0*p1p2*mdn2*mz2r*mmo4
     $-18d0*p1p3*p1p4*p2p3*mz4
     $+36d0*p1p3*p1p4*mdn2*mmo2*mz2r
     $-36d0*p1p3*p1p4*mdn2*mz4
     $+18d0*p1p3*p2p3*p3p4*mdn2*mmo2
     $+18d0*p1p3*p2p3*p3p4*mz4
     $-9d0*p1p3*p2p3*mdn2*mmo2*mz2r
     $+18d0*p1p3*p2p3*mdn2*mmo4
     $+18d0*p1p3*p2p3*mmo2*mz4
     $+18d0*p1p3*p2p4*p3p4*mdn2*mmo2
     $-9d0*p1p3*p2p4*mdn2*mmo2*mz2r
     $+18d0*p1p3*p2p4*mdn2*mmo4
     $-18d0*p1p3*p3p4*mdn2*mmo2*mz2r
     $+36d0*p1p3*p3p4*mdn2*mz4
     $+36d0*p1p3*mdn2*mmo2*mz4
     $-18d0*p1p3*mdn2*mz2r*mmo4
     $+18d0*p1p4*p2p3*p3p4*mdn2*mmo2
     $-9d0*p1p4*p2p3*mdn2*mmo2*mz2r
     $+18d0*p1p4*p2p3*mdn2*mmo4
     $+18d0*p1p4*p2p4*p3p4*mdn2*mmo2
     $-9d0*p1p4*p2p4*mdn2*mmo2*mz2r
     $+18d0*p1p4*p2p4*mdn2*mmo4
     $-18d0*p1p4*p3p4*mdn2*mmo2*mz2r
     $-18d0*p1p4*mdn2*mz2r*mmo4
     $-9d0*p2p3*p3p4*mdn2*mmo2*mz2r
     $-9d0*p2p3*mdn2*mz2r*mmo4
     $-9d0*p2p4*p3p4*mdn2*mmo2*mz2r
     $+18d0*p2p4*p1p32*mz4
     $-9d0*p2p4*mdn2*mz2r*mmo4
     $-36d0*p3p4*mmo2*mz2r*mdn4
     $+72d0*p3p4*mdn4*mmo4
     $+18d0*p1p32*mdn2*mmo2*mz2r
     $+18d0*p1p42*mdn2*mmo2*mz2r
     $+36d0*p3p42*mmo2*mdn4
     $+36d0*mmo2*mdn4*mmo4
     $-36d0*mz2r*mdn4*mmo4
     $)
     $+den32*den52*(
     $+576d0*stw4*p1p2*p1p3*p1p4*mw4
     $+576d0*stw4*p1p2*p1p3*mmo2*mw4
     $-576d0*stw4*p1p2*p1p4*p3p4*mw4
     $+576d0*stw4*p1p2*p2p3*p2p4*mw4
     $-576d0*stw4*p1p2*p2p3*mmo2*mw4
     $+576d0*stw4*p1p2*p2p4*p3p4*mw4
     $-576d0*stw4*p1p2*p3p4*mdn2*mw4
     $-576d0*stw4*p1p2*p3p4*mmo2*mw4
     $-3456d0*stw4*p1p2*mdn2*mmo2*mw4
     $-1152d0*stw4*p1p2*mmo4*mw4
     $-576d0*stw4*p1p3*p1p4*p2p4*mw4
     $-1152d0*stw4*p1p3*p1p4*mdn2*mw4
     $+576d0*stw4*p1p3*p2p4*mdn2*mw4
     $-576d0*stw4*p1p3*p2p42*mw4
     $-576d0*stw4*p1p3*mdn2*mmo2*mw4
     $+576d0*stw4*p1p4*p2p3*p2p4*mw4
     $+576d0*stw4*p1p4*p2p3*mdn2*mw4
     $+1152d0*stw4*p1p4*p2p4*p3p4*mw4
     $+2304d0*stw4*p1p4*p2p4*mmo2*mw4
     $+576d0*stw4*p1p4*p3p4*mdn2*mw4
     $-1152d0*stw4*p2p3*p2p4*mdn2*mw4
     $+576d0*stw4*p2p3*p1p42*mw4
     $+576d0*stw4*p2p3*mdn2*mmo2*mw4
     $-576d0*stw4*p2p4*p3p4*mdn2*mw4
     $+576d0*stw4*p3p4*mdn2*mmo2*mw4
     $+576d0*stw4*p3p4*mdn4*mw4
     $+1152d0*stw4*p1p22*mmo2*mw4
     $+1152d0*stw4*mdn2*mmo4*mw4
     $+2304d0*stw4*mmo2*mdn4*mw4
     $)
     $+den32*den62*(
     $+576d0*stw4*p1p2*p1p3*p1p4*mw4
     $-576d0*stw4*p1p2*p1p3*p3p4*mw4
     $+576d0*stw4*p1p2*p1p4*mmo2*mw4
     $+576d0*stw4*p1p2*p2p3*p2p4*mw4
     $+576d0*stw4*p1p2*p2p3*p3p4*mw4
     $-576d0*stw4*p1p2*p2p4*mmo2*mw4
     $-576d0*stw4*p1p2*p3p4*mdn2*mw4
     $-576d0*stw4*p1p2*p3p4*mmo2*mw4
     $-3456d0*stw4*p1p2*mdn2*mmo2*mw4
     $-1152d0*stw4*p1p2*mmo4*mw4
     $-576d0*stw4*p1p3*p1p4*p2p3*mw4
     $-1152d0*stw4*p1p3*p1p4*mdn2*mw4
     $+576d0*stw4*p1p3*p2p3*p2p4*mw4
     $+1152d0*stw4*p1p3*p2p3*p3p4*mw4
     $+2304d0*stw4*p1p3*p2p3*mmo2*mw4
     $+576d0*stw4*p1p3*p2p4*mdn2*mw4
     $+576d0*stw4*p1p3*p3p4*mdn2*mw4
     $+576d0*stw4*p1p4*p2p3*mdn2*mw4
     $-576d0*stw4*p1p4*p2p32*mw4
     $-576d0*stw4*p1p4*mdn2*mmo2*mw4
     $-1152d0*stw4*p2p3*p2p4*mdn2*mw4
     $-576d0*stw4*p2p3*p3p4*mdn2*mw4
     $+576d0*stw4*p2p4*p1p32*mw4
     $+576d0*stw4*p2p4*mdn2*mmo2*mw4
     $+576d0*stw4*p3p4*mdn2*mmo2*mw4
     $+576d0*stw4*p3p4*mdn4*mw4
     $+1152d0*stw4*p1p22*mmo2*mw4
     $+1152d0*stw4*mdn2*mmo4*mw4
     $+2304d0*stw4*mmo2*mdn4*mw4
     $)
     $+den42*den72*(
     $+128d0*stw4*p1p2*p2p3*p2p4*mw4
     $+64d0*stw4*p1p2*p2p3*p3p4*mw4
     $+64d0*stw4*p1p2*p2p3*mmo2*mw4
     $+64d0*stw4*p1p2*p2p4*p3p4*mw4
     $+64d0*stw4*p1p2*p2p4*mmo2*mw4
     $-64d0*stw4*p1p2*p3p4*mdn2*mw4
     $-64d0*stw4*p1p2*p3p4*mmo2*mw4
     $-64d0*stw4*p1p2*mdn2*mmo2*mw4
     $-64d0*stw4*p1p2*mmo4*mw4
     $+64d0*stw4*p1p3*p2p3*p2p4*mw4
     $+64d0*stw4*p1p3*p2p3*p3p4*mw4
     $+128d0*stw4*p1p3*p2p3*mmo2*mw4
     $+64d0*stw4*p1p3*p2p4*mmo2*mw4
     $-64d0*stw4*p1p3*p3p4*mdn2*mw4
     $-64d0*stw4*p1p3*p2p42*mw4
     $-64d0*stw4*p1p3*mdn2*mmo2*mw4
     $+64d0*stw4*p1p4*p2p3*p2p4*mw4
     $+64d0*stw4*p1p4*p2p3*mmo2*mw4
     $+64d0*stw4*p1p4*p2p4*p3p4*mw4
     $+128d0*stw4*p1p4*p2p4*mmo2*mw4
     $-64d0*stw4*p1p4*p3p4*mdn2*mw4
     $-64d0*stw4*p1p4*p2p32*mw4
     $-64d0*stw4*p1p4*mdn2*mmo2*mw4
     $-256d0*stw4*p2p3*p2p4*mdn2*mw4
     $+384d0*stw4*p3p4*mdn2*mmo2*mw4
     $+128d0*stw4*p3p4*mdn4*mw4
     $+128d0*stw4*p3p42*mdn2*mw4
     $+256d0*stw4*mdn2*mmo4*mw4
     $+128d0*stw4*mmo2*mdn4*mw4
     $)
     $+den42*den82*(
     $+128d0*stw4*p1p2*p1p3*p1p4*mw4
     $-64d0*stw4*p1p2*p1p3*p3p4*mw4
     $-64d0*stw4*p1p2*p1p3*mmo2*mw4
     $-64d0*stw4*p1p2*p1p4*p3p4*mw4
     $-64d0*stw4*p1p2*p1p4*mmo2*mw4
     $-64d0*stw4*p1p2*p3p4*mdn2*mw4
     $-64d0*stw4*p1p2*p3p4*mmo2*mw4
     $-64d0*stw4*p1p2*mdn2*mmo2*mw4
     $-64d0*stw4*p1p2*mmo4*mw4
     $-64d0*stw4*p1p3*p1p4*p2p3*mw4
     $-64d0*stw4*p1p3*p1p4*p2p4*mw4
     $-256d0*stw4*p1p3*p1p4*mdn2*mw4
     $+64d0*stw4*p1p3*p2p3*p3p4*mw4
     $+128d0*stw4*p1p3*p2p3*mmo2*mw4
     $+64d0*stw4*p1p3*p2p4*mmo2*mw4
     $+64d0*stw4*p1p4*p2p3*mmo2*mw4
     $+64d0*stw4*p1p4*p2p4*p3p4*mw4
     $+128d0*stw4*p1p4*p2p4*mmo2*mw4
     $+64d0*stw4*p2p3*p3p4*mdn2*mw4
     $+64d0*stw4*p2p3*p1p42*mw4
     $+64d0*stw4*p2p3*mdn2*mmo2*mw4
     $+64d0*stw4*p2p4*p3p4*mdn2*mw4
     $+64d0*stw4*p2p4*p1p32*mw4
     $+64d0*stw4*p2p4*mdn2*mmo2*mw4
     $+384d0*stw4*p3p4*mdn2*mmo2*mw4
     $+128d0*stw4*p3p4*mdn4*mw4
     $+128d0*stw4*p3p42*mdn2*mw4
     $+256d0*stw4*mdn2*mmo4*mw4
     $+128d0*stw4*mmo2*mdn4*mw4
     $)
      born1 = born1*factor*conhc
      return
      end
